<?php
/**
 * 
 * @package Flatnux
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @copyright Copyright (c) 2003-2005
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
*/
/**
 * 
 * @param string $name
 * @param int $cols
 * @param int $rows
 * @param string $text
 * @param string $defaultdir
 */
function showhtmlarea($name, $cols, $rows, $text = "", $defaultdir = "")
{
	global $_FN;
	$siteurl = $_FN['siteurl'];
	$filetomod = getparam("file",PAR_GET,SAN_FLAT);
	if ( $defaultdir == "" )
		if ( preg_match('/^sections\//',$filetomod) )
		{
			$dirtoopen = dirname($filetomod);
		}
		else
			$dirtoopen = $_FN['datadir'];
	else
		$dirtoopen = $defaultdir;
	
	$str = str_replace("&","&amp;",$text);
	$str = str_replace("<","&lt;",$str);
	$str = str_replace(">","&gt;",$str);
	$l = "en";
	if ( file_exists("include/extra/fck3/ckeditor/lang/{$_FN['lang']}.js") )
		$l = $_FN['lang'];
	$skin = "office2003";
	$toolbar = "Full";
	$fckcolor = "d4d7d0";
	include ("include/extra/fck3/config.php");
	static $jsfck = true;
	if ( $jsfck )
	{
		if ( is_admin() )
		{
			echo "<a href=\"?opindex=modcont&amp;file=include/extra/fck3/config.php\">" . fn_i18n("_EDIT_FILE_CONFIG") . " Fckeditor</a>";
		}
		echo "
<script type=\"text/javascript\" src=\"include/extra/fck3/ckeditor/ckeditor.js\"></script>";
	
	}
	$jsfck = false;
	$h=200;
	$w="auto";	
	if ($rows != "")
		$h = $rows * 10 + 200;
	if ($cols != "")
		$w = $cols * 10;
	
	// view http://docs.cksource.com/ckeditor_api/symbols/CKEDITOR.config.html
	echo "
<textarea cols=\"$cols\" id=\"fckeditor$name\" name=\"$name\" rows=\"$rows\">" . $str . "</textarea>
<script type=\"text/javascript\">
//<![CDATA[

CKEDITOR.replace( 'fckeditor$name',
	{
		language : '$l',
		skin : '$skin',
		baseHref : '{$_FN['siteurl']}',
		width: '$w',
		height: '$h',
		toolbar: '$toolbar',
		
		filebrowserBrowseUrl : '{$_FN['siteurl']}/filemanager.php?mode=t&filemanager_editor=fck3&dir=$dirtoopen',
		filebrowserImageBrowseUrl : '{$_FN['siteurl']}/filemanager.php?mode=t&filemanager_editor=fck3&dir=$dirtoopen&mime=image',
		filebrowserUploadUrl : '{$_FN['siteurl']}/filemanager.php?mode=t&filemanager_editor=fck3&dir=$dirtoopen',
		filebrowserWindowWidth : '640',
        filebrowserWindowHeight : '480',
        ";
	
	if ( file_exists("themes/{$_FN['theme_default']}/fck/style.css") )
		echo "contentsCss:'themes/{$_FN['theme_default']}/fck/style.css?".time(), "',";
	elseif ( file_exists("themes/{$_FN['theme_default']}/style.css") )
		echo "contentsCss:'themes/{$_FN['theme_default']}/style.css', ";
	
	echo "
		uiColor: '#$fckcolor'
	} );

//]]>
</script>
";

}

?>