<?php
/**
 * @package flatnux_section_files
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @copyright Copyright (c) 2003-2005
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 * 
 * Questa sezione pu gestire contenuti di vario tipo a seconda dei campi 
 * presenti nella tabella.
 * I contenuti possono essere aggiuni o modificati da utenti 
 * 
 */
if ( strpos(strtolower($_SERVER['SCRIPT_NAME']), strtolower(basename(__FILE__))) )
{
	header("Location: ../../index.php");
	die("...");
}
global $_FN;
require_once "sections/{$_FN['vmod']}/fnfiles_functions.php";
global $tablename, $pathdatabase, $viewonlycreator, $mailalert, $databasename, $recordsperpage, $trheight, $pathdatabase; //database e tabella di default
global $tableborder, $tableback, $viewpageback, $enablecomments, $enableranks;
global $generate_html_sitemap, $generate_googlesitemap, $tablewidth;
$tablewidth = "90%";
$trheight = "30";
if ( $viewpageback == "" )
	$viewpageback = $tableborder;
include ("sections/{$_FN['vmod']}/config.php");
//extra functions
if ( file_exists("sections/" . $_FN['vmod'] . "/extrafunctions.php") )
{
	require_once ("sections/" . $_FN['vmod'] . "/extrafunctions.php");
}
if ( $pathdatabase == "" )
{
	$pathdatabase = $_FN['datadir'];
}
//---fields obbligatori ---->
$field = array();
$field['name'] = "recorddeleted";
$field['frm_type'] = "check";
$field['frm_show'] = "0";
$field['frm_setonlyadmin'] = "1";
$field['frm_default'] = "0";
$field['defaultvalue'] = "0";
addxmltablefield("$databasename", $tablename, $field, $_FN['datadir'], false);
$field = array();
$field['name'] = "userupdate";
$field['type'] = "varchar";
$field['frm_show'] = "0";
$field['frm_setonlyadmin'] = "1";
addxmltablefield("$databasename", $tablename, $field, $_FN['datadir'], false);
$field = array();
$field['name'] = "insert";
$field['type'] = "varchar";
$field['frm_show'] = "0";
$field['frm_setonlyadmin'] = "1";
addxmltablefield("$databasename", $tablename, $field, $_FN['datadir'], false);
$field = array();
$field['name'] = "update";
$field['type'] = "varchar";
$field['frm_show'] = "0";
$field['frm_setonlyadmin'] = "1";
addxmltablefield("$databasename", $tablename, $field, $_FN['datadir'], false);
//---fields obbligatori ----<
//--gestione download---->
$downloadfile = strippostpslashes(getparam("downloadfile", PAR_GET, SAN_FLAT));
if ( isset($_GET['mode']) && $_GET['mode'] == "go" )
{
	go_download($downloadfile);
}
//--gestione download----<
//--------------- creazione tabelle ------------------------------->
if ( !file_exists("$pathdatabase/$databasename/$tablename") || !file_exists("$pathdatabase/$databasename/$tablename.php") )
{
	$sfields = array();
	$sfields[0]['name'] = "unirecid";
	$sfields[0]['primarykey'] = "1";
	$sfields[0]['extra'] = "autoincrement";
	$sfields[0]['frm_show'] = "0";
	$sfields[1]['name'] = "insert";
	$sfields[1]['type'] = "string";
	$sfields[1]['defaultvalue'] = "";
	$sfields[1]['frm_show'] = "0";
	$sfields[2]['name'] = "update";
	$sfields[2]['type'] = "string";
	$sfields[2]['defaultvalue'] = "";
	$sfields[2]['onrowupdate'] = "0";
	$sfields[2]['frm_show'] = "0";
	$sfields[3]['name'] = "username";
	$sfields[3]['type'] = "string";
	$sfields[3]['frm_show'] = "0";
	$sfields[4]['name'] = "name";
	$sfields[4]['frm_it'] = "Titolo";
	$sfields[4]['frm_en'] = "Title";
	$sfields[4]['type'] = "string";
	$sfields[4]['frm_required'] = "1";
	$sfields[6]['name'] = "view";
	$sfields[6]['frm_it'] = "Visualizzato volte";
	$sfields[6]['frm_en'] = "View";
	$sfields[6]['type'] = "string";
	$sfields[6]['foreignkey'] = "$tablename" . "_stat";
	$sfields[6]['fk_link_field'] = "unirecid";
	$sfields[6]['fk_show_field'] = "view";
	$sfields[6]['frm_show'] = "0";
	$sfields[6]['frm_showinlist'] = "1";
	$sfields[7]['name'] = "description";
	$sfields[7]['frm_cols'] = 80;
	$sfields[7]['frm_rows'] = 10;
	$sfields[7]['frm_help_it'] = "Inserisci qui la descrizione";
	$sfields[7]['frm_help_en'] = "Insert description here";
	$sfields[7]['frm_it'] = "Descrizione";
	$sfields[7]['frm_en'] = "Description";
	$sfields[7]['type'] = "text";
	$sfields[7]['frm_multilanguages'] = "auto";
	$sfields[9]['name'] = "photo1";
	$sfields[9]['frm_it'] = "Immagine";
	$sfields[9]['frm_en'] = "Screenshot";
	$sfields[9]['frm_showinlist'] = "1";
	$sfields[9]['view_hiddentitle'] = "1";
	$sfields[9]['thumb_listheight'] = "64";
	$sfields[9]['type'] = "image";
	$sfields[9]['thumbsize'] = "250";
	$sfields[9]['view_tag'] = "center";
	$sfields[9]['gridicononexists'] = "images/mime/image.png";
	$sfields[10]['name'] = "file";
	$sfields[10]['frm_it'] = "File";
	$sfields[10]['frm_en'] = "File";
	$sfields[10]['type'] = "file";
	$sfields[10]['gridicononexists'] = "images/icons/download.png";
	echo createxmltable($databasename, $tablename, $sfields, $pathdatabase, false);
}
//------------------- tabella delle statistiche -------------------------
if ( !file_exists("$pathdatabase/$databasename/$tablename" . "_stat") || !file_exists("$pathdatabase/$databasename/$tablename" . "_stat.php") )
{
	//echo "<br>creazione statistiche $tablename";
	$sfields = array();
	$sfields[0]['name'] = "unirecid";
	$sfields[0]['primarykey'] = "1";
	$sfields[1]['name'] = "view";
	echo createxmltable($databasename, $tablename . "_stat", $sfields, $pathdatabase);
}
//------------------- tabella delle ranks -------------------------
if ( $enableranks && !file_exists("$pathdatabase/$databasename/$tablename" . "_ranks.php") )
{
	$str = "
<?xml version=\"1.0\" encoding=\"UTF-8\"?>
<?php exit (0)?>
<tables>
	<field>
		<name>unirecid</name>
		<primarykey>1</primarykey>
		<extra>autoincrement</extra>
		<frm_show>0</frm_show>
	</field>
	<field>
		<name>insert</name>
		<type>string</type>
		<frm_show>0</frm_show>
	</field>
	<field>
		<name>username</name>
		<type>string</type>
		<frm_show>0</frm_show>
		<frm_required>1</frm_required>
	</field>
	<field>
		<name>rank</name>
	</field>
	<field>
		<name>unirecidrecord</name>
		<frm_show>0</frm_show>
	</field>
	<indexfield>unirecidrecord</indexfield>
</tables>
";
	$fp = fopen("$pathdatabase/$databasename/$tablename" . "_ranks.php", "w");
	fwrite($fp, $str);
	fclose($fp);
}
//------------------- tabella permessi tabelle -------------------------
if ( !file_exists("$pathdatabase/$databasename/fieldusers") || !file_exists("$pathdatabase/$databasename/$tablename" . "_stat.php") )
{
	$sfields = array();
	$sfields[0]['name'] = "unirecid";
	$sfields[0]['primarykey'] = "1";
	$sfields[0]['extra'] = "autoincrement";
	$sfields[1]['name'] = "username";
	$sfields[2]['name'] = "tablename";
	$sfields[3]['name'] = "table_unirecid";
	echo createxmltable($databasename, "fieldusers", $sfields, $pathdatabase);
}
//------------------- tabella commenti-------------------------
if ( $enablecomments && !file_exists("$pathdatabase/$databasename/$tablename" . "_comments") || !file_exists("$pathdatabase/$databasename/$tablename" . "_comments.php") )
{
	$sfields = array();
	$sfields[0]['name'] = "unirecid";
	$sfields[0]['primarykey'] = "1";
	$sfields[0]['extra'] = "autoincrement";
	$sfields[0]['frm_show'] = "0";
	$sfields[1]['name'] = "insert";
	$sfields[1]['type'] = "string";
	$sfields[1]['defaultvalue'] = "";
	$sfields[1]['frm_show'] = "0";
	$sfields[3]['name'] = "username";
	$sfields[3]['type'] = "string";
	$sfields[3]['frm_show'] = "0";
	$sfields[3]['frm_required'] = "1";
	$sfields[4]['name'] = "title";
	$sfields[4]['frm_it'] = "Titolo";
	$sfields[4]['frm_en'] = "Title";
	$sfields[4]['type'] = "string";
	$sfields[4]['frm_required'] = "1";
	$sfields[5]['name'] = "comment";
	$sfields[5]['frm_it'] = "Commento";
	$sfields[5]['frm_en'] = "Comment";
	$sfields[5]['type'] = "text";
	$sfields[5]['frm_rows'] = "10";
	$sfields[5]['frm_required'] = "1";
	$sfields[5]['frm_cols'] = "80";
	$sfields[6]['name'] = "unirecidrecord";
	$sfields[6]['frm_show'] = "0";
	echo createxmltable($databasename, "$tablename" . "_comments", $sfields, $pathdatabase);
}
//--------------- creazione tabelle -------------------------------<
$unirecid = getparam("id", PAR_GET, SAN_FLAT);
if ( $unirecid == "" )
	$unirecid = getparam("unirecid", PAR_GET, SAN_FLAT);
$unirecid = htmlspecialchars($unirecid);
$op = getparam("op", PAR_GET, SAN_HTML);
if ( $op == "" )
	$op = getparam("opmod", PAR_GET, SAN_HTML);
$Table = xmldb_form($databasename, $tablename, $pathdatabase, $_FN['lang'], $_FN['languages']);
$Table->setlayoutTags("<div class=\"frm_title\">", ":</div>", "", "<br />", "<fieldset class=\"frm_group\" ><legend>", "</legend>", "</fieldset><br />");
//-------------------------principale ------------------------------------->
switch ( $op )
{
	case "view" :
		viewrecordpage($unirecid, $Table); // visualizza la pagina col record
		viewcomments($unirecid);
		break;
	case "viewcomments" :
		viewcomments($unirecid);
		break;
	case "writecomment" :
		writecomment($unirecid);
		break;
	case "request" :
		request($unirecid);
		break;
	case "edit" :
		editrecordform($unirecid, $Table); // form edita record
		break;
	case "new" :
		if ( isset($_POST['xmldbsave']) )
		{
			insertrecord($Table);
			write_plsitemap();
		}
		else
		{
			newrecordform($Table); //  form nuovo record
		}
		break;
	case "users" :
		usersform($unirecid); //  form nuovo record
		break;
	case "delcomment" :
		delcomment($unirecid); //  form nuovo record
		break;
	case "del" :
		delrecordform($unirecid); //  form nuovo record
		break;
	case "updaterecord" :
		if ( count($_POST) == 0 || isset($_POST['__NOSAVE']) || !isset($_POST['xmldbsave']) )
		{
			editrecordform($unirecid, $Table);
		}
		else
		{
			updaterecord($Table); // esegue aggiornamento record
		}
		break;
	case "insertrecord" : // esegue inserimento record
		break;
	case "updatesitemap" :
		write_plsitemap();
		dprint_xml(file_get_contents("sitemap-$tablename.xml"));
		dprint_xml(file_get_contents("index-$tablename.html"));
		break;
	default :
		viewgridform($Table); //griglia con tutti i records
		break;
}
//-------------------------principale -------------------------------------<
function is_adminFiles()
{
	global $groupadmin, $_FN;
	if ( $_FN['user'] == "" )
		return false;

	if ( is_admin ( ) )
		return true;
	if ( $groupadmin != "" && user_in_group($_FN['user'], $groupadmin) )
		return true;
	return false;
}
/**
 * viewgridform
 *
 * visualizza la schermata principale con la griglia dei records
 *
 * */
function viewgridform($Table)
{
	global $_FN, $viewonlycreator, $enablecomments, $tablename, $databasename, $recordsperpage, $_pluginfieldform, $trheight, $pathdatabase, $groupadmin;
	static $tfk = array();
	if ( file_exists("sections/{$_FN['vmod']}/top.php") )
	{
		include ("sections/{$_FN['vmod']}/top.php");
	}
	if ( file_exists("sections/{$_FN['vmod']}/top.{$_FN['lang']}.html") )
	{
		echo file_get_contents("sections/{$_FN['vmod']}/top.{$_FN['lang']}.html");
	}

	$page = isset($_GET['pag']) ? $_GET['pag'] : 1;
	$tablelinks = xmldb_table("$databasename", "$tablename" . "_comments", $_FN['datadir']);
	$min = ($page * $recordsperpage) - $recordsperpage;
	$max = $min + $recordsperpage;
	$DB = new XMLDatabase($databasename, $pathdatabase);
	//$data = $Table->xmltable->Query("SELECT name,unirecid FROM $tablename ORDER BY $order");
	$order = getparam("order", PAR_GET, SAN_FLAT);
	//echo "$order";
	if ( $order == "" )
		$order = "update";
	$pkf = $Table->xmltable->primarykey;
	$fieldstoread = "name|$pkf";
	if ( $order == "update" )
		$fieldstoread .= "|update";
	$rest = array("recorddeleted" => 0);
	$qf = "";
	if ( $viewonlycreator == "1" && !is_adminFiles() )
	{
		$rest['username'] = $_FN['user'];
		$qf = "AND username LIKE '{$_FN['user']}'";
	}
	$data = $DB->Query("SELECT * from $tablename WHERE recorddeleted <> '1' $qf ORDER BY $order"); //$Table->xmltable->GetRecords($rest,false,false,$order,false,$fieldstoread);
	if ( !is_array($data) )
		$data = array();
	$numrecords = count($data);
	//die ($numrecords);
	$numpages = $numrecords / $recordsperpage;
	if ( $numrecords % $recordsperpage > 0 )
		$numpages++;
	if ( $order != "name" )
		$data = array_reverse($data);
	$data = array_slice($data, $min, $recordsperpage);
	$numfelds = count($data);
	//dprint_r($data);
	if ( $numfelds == 0 )
	{
		echo fn_i18n("_NOFILES");
	}
	else
	{
		global $tableback, $tableborder, $tablewidth;
		echo "<table width=\"$tablewidth\" style=\"background-color:#$tableborder\" border=\"0\" cellspacing=\"1\" cellpadding=\"1\"><tr>";
		echo "<td style=\"background-color:#$tableback\" colspan=\"4\" >";
		if ( $order == "update" )
			echo "<b>";
		echo "<a href=\"index.php?mod={$_FN['mod']}&amp;order=update\" style=\"background-color:#$tableback\">" . fn_i18n("_XMBORDERUPDATE") . "</a>";
		if ( $order == "update" )
			echo "</b>";
		echo "&nbsp;&nbsp;|&nbsp;&nbsp;";
		if ( $order == "$pkf" )
			echo "<b>";
		echo "<a href=\"index.php?mod={$_FN['mod']}&amp;order=unirecid\">" . fn_i18n("_XMBORDERINSERT") . "</a>";
		if ( $order == "$pkf" )
			echo "</b>";
		echo "&nbsp;&nbsp;|&nbsp;&nbsp;";
		if ( $order == "name" )
			echo "<b>";
		echo "<a href=\"index.php?mod={$_FN['mod']}&amp;order=name\">" . fn_i18n("_XMBORDERNAME") . "</a>";
		if ( $order == "name" )
			echo "</b>";
		if ( canaddrecord ( ) )
		{
			echo "&nbsp;&nbsp;|&nbsp;&nbsp;";
			echo "<a  href=\"index.php?mod={$_FN['mod']}&amp;op=new\" ><img style=\"vertical-align: middle;\" src=\"" . fromtheme("images/icons/doc.png") . "\" alt=\"\" border='0' />&nbsp;<b>" . fn_i18n("_XMBADDNEWRECORD") . "</b></a>";
		}
		echo "</td>";
		echo "</tr>";
		foreach ( $data as $row )
		{
			$row = $Table->xmltable->GetRecordByPrimaryKey($row[$pkf]);
			//----grid--------------------------------------------------
			echo "";
			echo "<tr height=\"$trheight\"><td style=\"background-color:#$tableback\" >";
			if ( file_exists("sections/{$_FN['vmod']}/icon.png") )
				echo "&nbsp;<img style=\"vertical-align:middle\" src='sections/{$_FN['vmod']}/icon.png' alt='' border='0' />&nbsp;";
			$linkdetails = "index.php?mod={$_FN['mod']}&amp;op=view&amp;id=" . $row[$pkf];
			$linkdetails = fn_rewritelink($linkdetails);
			$idname = 'name';
			if ( !isset($row[$idname]) )
				$idname = "NOME";
			echo "<a href=\"$linkdetails\" >" . getparam($row[$idname], PAR_NULL, SAN_HTML) . "</a>";
			echo "<div align=\"right\"><br />";
			foreach ( $Table->formvals as $field )
				if ( isset($field['gridicononexists']) && $field['gridicononexists'] != "" && isset($row[$field['name']]) && $row[$field['name']] != "" )
				{
					echo "<img border=\"0\" alt=\"" . $field[$idname] . "\" src=\"" . $field['gridicononexists'] . "\" /> ";
					$f = "";
				}
			if ( $enablecomments )
			{
				$numcommenti = $tablelinks->GetNumRecords(array("unirecidrecord" => $row[$pkf]));
				echo "<br><a href=\"$linkdetails#___comments\">" . fn_i18n("_COMMENTI") . " : $numcommenti</a> ";
			}
			global $enableranks;
			if ( $enableranks )
			{
				$htmlrank = html_rank($row[$pkf], true, $tablename);
				echo "<br />" . fn_i18n("_RANK") . " : " . $htmlrank;
			}
			echo "</div></td>";
			$colsuffix = "1";
			for ( $col = 0; $col <= 1; $col++ )
			{
				echo "<td colspan=\"1\" style=\"background-color:#$tableback\" >";
				foreach ( $Table->formvals as $field )
				{
					if ( isset($field['frm_showinlist' . $colsuffix]) && $field['frm_showinlist' . $colsuffix] != 0 )
						if ( isset($row[$field['name']]) && $row[$field['name']] != "" )
						{
							$row[$field['name']] = html_entity_decode($row[$field['name']]);
							switch ( $field['frm_type'] )
							{
								case "image" :
									$h = $w = "";
									$hh = $ww = "64";
									if ( isset($field['thumb_listwidth']) && $field['thumb_listwidth'] != "" )
									{
										$w = "width=\"" . $field['thumb_listwidth'] . "\"";
										$ww = intval($field['thumb_listwidth']);
									}
									if ( isset($field['thumb_listheight']) && $field['thumb_listheight'] != "" )
									{
										$hh = intval($field['thumb_listheight']);
										$h = "height=\"" . $field['thumb_listheight'] . "\"";
									}
									$fileimage = "$pathdatabase/$databasename/$tablename/" . $row[$pkf] . "/" . $field['name'] . "/" . $row[$field['name']];
									//$filethumb = "thumb.php?d=$databasename&amp;t=$tablename&amp;i=".$row[$pkf]."&amp;h=$hh&amp;w=$ww&amp;c=".$field['name'];
									$filethumb = "$pathdatabase/$databasename/$tablename/" . $row[$pkf] . "/" . $field['name'] . "/thumbs/" . $row[$field['name']] . ".jpg";
									echo "<a title=\"" . fn_i18n("_FIG_INGRANDIRE") . "\" href=\"$fileimage\" onclick=\"window.open(this.href);return false;\" ><img border=\"0\" $w $h alt=\"" . basename($field['title']) . "\" src=\"$filethumb\"></a><br />";
									break;
								case "youtubelink" :
									//http://i3.ytimg.com/vi/vbrd56jFpc0/hqdefault.jpg
									$h = $w = "";
									$hh = $ww = "64";
									if ( isset($field['thumb_listwidth']) && $field['thumb_listwidth'] != "" )
									{
										$w = "width=\"" . $field['thumb_listwidth'] . "\"";
										$ww = intval($field['thumb_listwidth']);
									}
									if ( isset($field['thumb_listheight']) && $field['thumb_listheight'] != "" )
									{
										$hh = intval($field['thumb_listheight']);
										$h = "height=\"" . $field['thumb_listheight'] . "\"";
									}
									$c = "vi";
									$value = $row[$field['name']];
									$value = securehtml($row[$field['name']]);
									$code = explode("/v/", $value);
									if ( !isset($code[1]) )
									{
										$code = explode("?v=", $value);
										$c = "vi";
									}
									//print_r($code);
									if ( isset($code[1]) )
									{
										$code = $code[1];
										if ( false !== strstr($code, "&") )
											$code = substr($code, 0, strpos($code, "&"));
										if ( false !== strstr($code, "?") )
											$code = substr($code, 0, strpos($code, "?"));
										if ( $code != "" )
										{

										}
										$th = "http://i3.ytimg.com/$c/$code/hqdefault.jpg";
									}
									else
									{
										$th = "http://code.google.com/intl/it-IT/apis/youtube/images/player_apis_small.png";
									}
									echo "<img  $w $h  src=\"$th\" title=\"\"/>";
									break;
								case "file" :
									$filedownload = "$pathdatabase/$databasename/$tablename/" . $row[$pkf] . "/" . $field['name'] . "/" . $row[$field['name']];
									echo "<a href=\"$filedownload\" >" . $row[$field['name']] . "</a><br />";
									break;
								case "link" :
									$value = securehtml($row[$field['name']]);
									$valueh = $row[$field['name']];
									if ( !preg_match("/^http:\\/\\//is", $valueh) )
										$valueh = "http://$valueh";
									echo "<b>" . $field['title'] . "</b>: <a onclick=\"window.open(this.href);return false;\" href=\"$valueh\">{$valueh}</a><br />";
									break;
								case "html" :
									//$value = makebr(securehtml($value));
									echo "<b>" . $field['title'] . "</b>: $value<br />";
									break;
								default :
									if ( preg_match("/html/is", $field['frm_type']) )
									{
										$value = securehtml($row[$field['name']]);
										echo "<b>" . $field['title'] . "</b>: $value<br />";
									}
									else
									{
										$value = makebr(securehtml($row[$field['name']]));
										//dprint_r($field);	
										if ( isset($field['foreignkey']) )
										{
											$r = array();
											$tfk[$field['fk_link_field']] = xmldb_table($databasename, $field['foreignkey'], $pathdatabase);
											$tablefk = $tfk[$field['fk_link_field']];
											$f = $field['fk_link_field'];
											if ( $field['fk_link_field'] != $field['fk_show_field'] )
											{
												$f.= "|" . $field['fk_show_field'];
											}
											if ( isset($tfk[$field['fk_link_field']]->fields[$field['fk_link_field'] . "_{$_FN['lang']}"]) )
												$f .= "|" . $field['fk_show_field'] . "_{$_FN['lang']}";
											//echo $f;

											$r[$field['fk_link_field']] = $row[$field['name']];
											//dprint_r($value);
											$showfields = explode(",", $field['fk_show_field']);
											$value = "";
											$sep = "";
											foreach ( $showfields as $showfield )
											{
												$tvalue = $tablefk->GetRecord(array($field['fk_link_field'] => $row[$field['name']]));
												if ( isset($tvalue["{$showfield}_{$_FN['lang']}"]) )
													$value .=$sep . $tvalue["{$showfield}_{$_FN['lang']}"];
												else
													$value .=$sep . $tvalue[$showfield];
												$sep = "-";
											}
										}
										else
											$value = makebr(securehtml($row[$field['name']]));
										echo "<b>" . $field['title'] . "</b>: $value<br />";
									}
									break;
							}
						}
				}
				$colsuffix = "";
				echo "</td>";
			}
			echo "<td  style=\"background-color:#$tableback\">";

			if ( !checkmail($row['username']) )
				echo "<b>" . fn_i18n("_XMBINSERTBY") . ":</b> <a title=\"" . fn_i18n("_VIEW_USERPROFILE") . "\" onclick=\"window.open(this.href);return false;\" href=\"index.php?mod=login&op=profile&user=" . $row['username'] . "\" >" . $row['username'] . "</a><br />";

			//----------visualizza modifica se l' utente e' abilitato ------------
			echo "" . fn_i18n("_RECORDINSERITDATE") . " " . (fn_GetDateTime($row['insert'])) . "";

			echo "<br />" . fn_i18n("_RECORDUPDATEDATE") . " " . (fn_GetDateTime($row['update']));

			if ( isset($row['userupdate']) && $row['userupdate'] != "" && $row['userupdate'] != "0" )
				if ( !checkmail($row['username']) )
					echo "<nobr> " . strtolower(fn_i18n("_DA")) . " <a title=\"" . fn_i18n("_VIEW_USERPROFILE") . "\" onclick=\"window.open(this.href);return false;\" href=\"index.php?mod=login&op=profile&user=" . $row['userupdate'] . "\" >{$row ['userupdate']}" . "</a></nobr>";
			echo "<br />";


			echo "<br /><img src='" . fromtheme("images/icons/doc.png") . "' alt='' border='0' /><a href=\"$linkdetails\">" . fn_i18n("_XMBVIEW") . "</a>";
			if ( isUser($row, $tablename, $databasename, $pathdatabase) )
			{
				echo " | <img src='" . fromtheme("images/modify.png") . "' alt='' border='0' /><a href=\"index.php?mod={$_FN['mod']}&amp;op=edit&amp;id=" . $row[$pkf] . "\" >" . fn_i18n("_MODIFICA") . "</a>";
				echo " | <img src='" . fromtheme("images/delete.png") . "' alt='' border='0' /><a href='#' onclick=\"check('?mod={$_FN['mod']}&amp;id=" . $row[$pkf] . "&amp;op=del')\" >" . fn_i18n("_ELIMINA") . "</a>";
			}
			else
			{
				if ( $_FN['user'] != "" )
					echo " | <img src='" . fromtheme("images/modify.png") . "' alt='' border='0' /><a href=\"?mod={$_FN['mod']}&amp;op=edit&amp;id=" . $row[$pkf] . "\" >" . fn_i18n("_MODIFICA") . "</a>";
			}
			echo "</td></tr>";
		}
		echo "<tr><td colspan=\"4\"  style=\"background-color:#$tableback\">";
		//------------------   gestione pagine   -----------------------------
		$vv = "";
		echo "$numrecords " . get_section_title($_FN['vmod']) . "<br />";
		if ( $numpages >= 2 )
		{
			echo "<b>" . fn_i18n("_FNPAG") . ":</b>";
			for ( $i = 1; $i <= $numpages; $i++ )
			{
				if ( $i != $page )
				{
					echo " <a href=\"?mod={$_FN['mod']}&amp;pag=$i&amp;order=$order" . $vv . "\" >$i</a>";
				}
				else
				{
					echo " <b>$i</b>";
				}
			}
			echo "<br />";
			if ( $page > 1 )
			{
				echo "<b><a href=\"?mod={$_FN['mod']}&amp;pag=" . ($page - 1) . "&amp;order=$order\"" . $vv . ">&lt;&lt;</a></b>";
			}
			else
			{
				echo "&lt;&lt;";
			}
			echo "&nbsp;";
			if ( $page < $numpages - 1 )
			{
				echo "<b><a href=\"?mod={$_FN['mod']}&amp;pag=" . ($page + 1) . "&amp;order=$order" . $vv . "\" >&gt;&gt;</a></b>";
			}
			else
			{
				echo "&gt;&gt;";
			}
		}
		echo "</td></tr>";
		echo "</table>";
	}
	if ( canaddrecord ( ) )
	{
		echo "<br /><button class=\"button\" onclick=\"window.location='?mod={$_FN['mod']}&amp;op=new'\"><img style=\"vertical-align: middle;\" src=\"" . fromtheme("images/icons/doc.png") . "\" alt=\"\" />&nbsp;<b>" . fn_i18n("_XMBADDNEWRECORD") . "</b></button>";
	}
	echo "<br />";
}
/**
 * viewrecordpage
 * schermata visualizzazione record
 * @param string unirecid record
 * */
function viewrecordpage($unirecid, $Table)
{
	global $_FN, $_FN, $tableborder, $viewpageback, $viewonlycreator;
	global $tablename, $databasename, $recordsperpage, $pathdatabase;
	global $enableranks;
	$pkf = $Table->xmltable->primarykey;
	$forcelang = isset($_GET['forcelang']) ? $_GET['forcelang'] : $_FN['lang'];
	$rank = getparam("setrank", PAR_GET, SAN_FLAT);
	$cookie = getparam("fnfiles_rank_{$tablename}_{$unirecid}", PAR_COOKIE, SAN_FLAT);
	if ( $enableranks == 1 && $cookie != "true" && isset($_GET['setrank']) && $rank >= 0 && $rank <= 5 )
	{
		//die ($rank);
		jsalert(fn_i18n("_THANKSVOTE"));
		fnfiles_set_rank($unirecid, $rank, $tablename);
		$ctime = time() + 999999999;
		setcookie("fnfiles_rank_{$tablename}_{$unirecid}", "true", $ctime, $_FN['urlcookie']);
		$_COOKIE["fnfiles_rank_{$tablename}_{$unirecid}"] = "true";
	}
	$Table = xmldb_form($databasename, $tablename, $pathdatabase, $forcelang, $_FN['languages']);
	$row = $Table->xmltable->GetRecordByPrimaryKey($unirecid);
	if ( $viewonlycreator && !isUser($row, $tablename, $databasename) )
	{
		echo _NONPUOI;
		return;
	}
	//-------statistiche---------------------->>
	if ( !file_exists("$pathdatabase/$databasename/$tablename" . "_stat") )
	{
		$sfields = array();
		$sfields[0]['name'] = "unirecid";
		$sfields[0]['primarykey'] = "1";
		$sfields[1]['name'] = "view";
		echo createxmltable($databasename, $tablename . "_stat", $sfields, $pathdatabase);
	}
	$tbtmp = xmldb_table($databasename, $tablename . "_stat", $pathdatabase);
	$tmprow['unirecid'] = $row[$pkf];
	if ( ($oldview = $tbtmp->GetRecordByPrimaryKey($row[$pkf])) == false )
	{
		$tmprow['view'] = 1;
		$rowtmp = $tbtmp->InsertRecord($tmprow);
	}
	else
	{
		$oldview['view']++;
		$rowtmp = $tbtmp->UpdateRecord($oldview); //aggiunge vista
		$Table2 = xmldb_table($databasename, $tablename, $pathdatabase);
		$row = $Table2->GetRecordByPrimaryKey($unirecid);
	}
	//dprint_r($tablename);
	//-------statistiche----------------------<<
	$tablename = $Table->tablename;
	$databasename = $Table->databasename;
	$unirecid = isset($row[$pkf]) ? $row[$pkf] : null;
	//----------visualizza modifica se l' utente e' abilitato ------------>>
	echo "<div class=\"fnfilesuserbar\" >";
	if ( isUser($row, $tablename, $databasename, $pathdatabase) )
	{
		echo "&nbsp;<img src='" . fromtheme("images/modify.png") . "' alt='' border='0' /><a href=\"index.php?mod={$_FN['mod']}&amp;op=edit&amp;id=" . $row[$pkf] . " \" >" . fn_i18n("_MODIFICA") . "</a>";
		echo "&nbsp;<img border=\"0\" src=\"" . fromtheme("images/useronline/group-admins.gif") . "\" alt=\"\" /><a href=\"index.php?mod={$_FN['mod']}&amp;op=users&amp;id=" . $row[$pkf] . "\" >" . fn_i18n("_MODIFICAUTENTI") . "</a>";
	}
	else
	{
		if ( $_FN['user'] )
			echo "&nbsp;<img src='" . fromtheme("images/modify.png") . "' alt='' border='0' /><a href=\"index.php?mod={$_FN['mod']}&amp;op=edit&amp;id=" . $row[$pkf] . "\" >" . fn_i18n("_MODIFICA") . "</a>";
		else
			echo "&nbsp;<img src='" . fromtheme("images/modify.png") . "' alt='' border='0' /><a href=\"index.php?mod=login\">" . fn_i18n("_MODIFICA") . "</a>";
	}
	echo " &nbsp;<img src='" . fromtheme("images/print.png") . "' alt=\"" . fn_i18n("_STAMPA") . "\" border='0' title=\"" . fn_i18n("_STAMPA") . "\" />";
	echo "<a onclick=\"window.open(this.href);return false;\" href=\"print.php?mod={$_FN['mod']}&amp;op=view&amp;id=$unirecid\">" . fn_i18n("_STAMPA") . "</a>";
	echo "</div>";
	//	echo "<img border=\"0\" src=\"sections/{$_FN['vmod']}/icon.png\" alt=\"\"><a href='?mod={$_FN['mod']}&amp;' >" . fn_i18n("_XMBLISTRECORDS") . "</a>";
	//	echo "<br /><br /><button onclick=\"javascript:history.back()\">&lt;&lt;$tit</button>";
	//----------visualizza modifica se l' utente e' abilitato ------------<<
	//----------------visualizzazione------------------>
	//echo "<table width=\"100%\" cellpadding=\"5\"><tr><td style=\"background-color:#$viewpageback\">";
	echo "<div id='viewrecordpage'>";
	echo xmldb_view($unirecid, $tablename, $databasename, $_FN['datadir'], $_FN['lang'], $_FN['languages']);
	if ( file_exists("sections/{$_FN['vmod']}/viewfooter.php") )
	{
		include ("sections/{$_FN['vmod']}/viewfooter.php");
	}
	echo "</div>";
	echo "<br /><br />";
	//echo "</td></tr></table>";
	//----------------visualizzazione------------------<
	echo "<div class=\"fnfilesfooter\" ><hr />";
	if ( $enableranks == 1 )
		echo "<div class=\"fnfilesranks\" name=\"\"><a name=\"___ranks\" id=\"___ranks\"></a>" . html_rank_editable($unirecid, false, $tablename) . "<hr /><br /></div>";
	//----------visualizza modifica se l' utente e' abilitato ------------>>
	if ( isUser($row, $tablename, $databasename, $pathdatabase) )
	{
		echo "<img src='" . fromtheme("images/modify.png") . "' alt='' border='0' />&nbsp;<a href=\"index.php?mod={$_FN['mod']}&amp;op=edit&amp;id=" . $row[$pkf] . "\" >" . fn_i18n("_MODIFICA") . "</a>";
		echo "<br /><img src='" . fromtheme("images/delete.png") . "' alt='' border='0' />&nbsp;<a href='#' onclick=\"check('?mod={$_FN['mod']}&amp;id=" . $row[$pkf] . "&amp;op=del')\" >" . fn_i18n("_ELIMINA") . "</a>";
		echo "<br /><img border=\"0\" src=\"" . fromtheme("images/useronline/group-admins.gif") . "\" alt=\"\" />&nbsp;<a href=\"index.php?mod={$_FN['mod']}&amp;op=users&amp;id=" . $row[$pkf] . "\" >" . fn_i18n("_MODIFICAUTENTI") . "</a>";
	}
	else
	{
		if ( $_FN['user'] )
			echo "<img src='" . fromtheme("images/modify.png") . "' alt='' border='0' />&nbsp;<a href=?mod={$_FN['mod']}&amp;op=edit&amp;id=" . $row[$pkf] . ">" . fn_i18n("_MODIFICA") . "</a>";
	}
	echo "</div>";
	//----------visualizza modifica se l' utente e' abilitato ------------<<
	//echo "<br /><br /><img border=\"0\" src=\"sections/{$_FN['vmod']}/icon.png\" alt=\"\">&nbsp;<a href=\"$listlink\" >" . fn_i18n ( "_XMBLISTRECORDS" ) . "</a>";
	$listlink = fn_rewritelink("index.php?mod={$_FN['mod']}");
	$tit = fn_i18n("_INDIETRO");
	echo "<br /><br /><button onclick=\"window.location='$listlink'\"><img border=\"0\" style=\"vertical-align:middle\" src=\"" . fromtheme("images/icons/back.png") . "\" alt=\"\">&nbsp;" . fn_i18n("_XMBLISTRECORDS") . "</button>";
	echo "<br /><br />";
}
?>