<?php
// previene che il blocco sia eseguito direttamente e redirige a index.php
if (strpos ( strtolower ( $_SERVER ['SCRIPT_NAME'] ), strtolower ( basename ( __FILE__ ) ) ))
{
	header ( "Location: ../../index.php" );
	die ( "..." );
}

global $_FN;
global $theme;
global $lang, $home_section, $_FNMOD, $_FNVMOD, $languages, $sitename;

$filesection = getparam("filesection", PAR_GET, SAN_FLAT);
$op = getparam("opt", PAR_GET, SAN_FLAT);

if ($filesection != "")
{
	echo "$filesection";
	if (!file_exists($filesection))
	{
		if (false !== ($fp=fopen($filesection,"a")))
		{
			jsalert($filesection."\n"._FNFILECREATED);
			fclose($fp);
		}
	}
	if (file_exists($filesection))
	{
		edit_content($filesection, "{$_FN['self']}?mod={$_FN['mod']}&opt=$op");
	}
}
else
{

	$sections = list_sections_translated("sections", true, true);
	echo "<fieldset><legend>" . _SECTION_CREATE . ":</legend>";
	echo "<form  method=\"post\" action=\"verify.php?mod=newsection&amp;from=" . basename($_FN['self']) . "?" . urlencode($_FN['vmod'] . "&opt=$op") . "\" >";
	echo "Path:<select name=\"path\">";
	echo "<option value=\"\" />" . $sitename . "</option>";
	foreach ($sections as $section)
	{
		$sectionname = $section['title'];
		echo "<option value=\"" . $section['link'] . "\" />&nbsp;" . get_sectiontitle_tree($section['link']) . "</option>";
	}
	echo "</select><br />";
	echo _POS . "<select  type=\"text\" name=\"sectionposition\" >";
	print_all_prefix2("sections/$section", "");
	echo "</select><br /><nobr>" . _TITLE . ":&nbsp;";
	$ll = explode(",", $languages);
	foreach ($ll as $llang)
	{
		echo "<input type=\"text\"  size=\"7\" name=\"sectiontitle" . $llang . "\" />";
		echo "<img  border=\"0\" src=\"" . fromtheme("images/flags/$llang.png") . "\" alt=\"$llang\" />";
	}
	echo "</nobr><input type=\"submit\" class=\"submit\" name=\"newdir\" value=\"" . _CREA . "\" /></form>";
	echo "</fieldset>";
	if ($home_section == "")
	{
		if (file_exists("themes/$theme/images/menu.png"))
			echo "<img border=0 src=\"themes/$theme/images/menu.png\" alt=\"home\" />";
		echo "<a href='index.php'>";
		if (defined(_FIRSTBUTTONMENU))
			echo fn_i18n("_FIRSTBUTTONMENU");
		else
			echo "HOME";
		echo "</a>";
	}
	echo "<br />";
	printsection("sections");
}
/**
 * Stampa la lista delle sezioni e delle sottosessioni
 *
 * @param string $path dove cercare la sezione (es. sections/01_pippo)
 *
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 *
 */
function printsection($path)
{
	global $_FN;
	$sections = list_sections_translated("sections", true, true);
	$filesection = getparam("filesection", PAR_GET, SAN_FLAT);
	$op = getparam("opt", PAR_GET, SAN_FLAT);

	echo "<table cellpadding=\"1\" cellspacing=\"1\" class=\"fn_cc_table\"><thead>";
	echo "<tr>";
	echo "\n<td style=\"text-align:center\">";
	echo _POS;
	echo "\n</td>";
	echo "\n<td>";
	echo _TITLE;
	echo "\n</td>";
	echo "\n<td>";
	echo _FNPAG;
	echo "\n</td>";
	echo "\n<td style=\"text-align:center\" colspan=\"3\">";
	echo _FNVIEWPERMS;
	echo "\n</td>";
	echo "\n<td style=\"text-align:center\" colspan=\"2\">";
	echo _FNEDITPERMS;
	echo "\n</td>\n<td>&nbsp;</td>";
	echo "</tr></thead><tbody>";
	//seconda riga
	echo "<tr>";
	echo "\n<td>";
	echo "";
	echo "\n</td>";
	echo "\n<td>";
	echo "";
	echo "\n</td>";
	echo "\n<td>";
	echo "";
	echo "\n</td>";
	echo "\n<td>";
	echo _LEVEL;
	echo "\n</td>";
	echo "\n<td>";
	echo _NOMEUTENTE;
	echo "\n</td>";
	echo "\n<td>";
	echo _FGRUPPO;
	echo "\n</td>";

	echo "\n<td>";
	echo _NOMEUTENTE;
	echo "\n</td>";
	echo "\n<td>";
	echo _FGRUPPO;
	echo "\n</td><td>&nbsp;</td>";

	echo "</tr>";
	foreach ($sections as $section)
	{
		if (preg_match('/^none_Control_Center/si',$section['link']))
			continue;
		echo "<tr>";
		echo "\n<td>";
		if ($section['prefix']!="none")
			echo intval($section['prefix']);
		else
			echo "-";
		echo "\n</td>";
		echo "\n<td>";
		$leveldir = count(explode("/", $section['link']));
		for ($i = 1; $i < $leveldir; $i++)
			echo "&nbsp;&nbsp;&nbsp;&nbsp;";
		$st="";
		if (preg_match('/^none/si',basename($section['link'])))
			$st="style=\"font-style:italic\"";
		else
			$st="style=\"font-weight:bold\"";
		echo "<img alt=\"{$section['link']}\" title=\"{$section['link']}\"  style=\"border:0px\" src=\"" . fromtheme("images/section.png") . "\" /><a $st accesskey=\"{$section['accesskey']}\" href='index.php?mod={$section['link']}&amp;fneditmode=1'>&nbsp;{$section['title']}</a>";
		echo "\n</td>";
		echo "\n<td>";
		if (file_exists("sections/{$section['link']}/section.php"))
		{
			$filetomodify = "sections/{$section['link']}/section.php";
			echo "&nbsp;<a  href=\"?mod={$_FN['mod']}&opt=$op&amp;filesection=$filetomodify\" ><img style=\"border:2px solid #00ff00;\" alt=\"\" title=\"" . _MODIFICA . "\" src=\"" . fromtheme("images/mime/php.png") . "\" /></a>";

		}
		else
		{
			$empty = true;
			foreach ($_FN['listlanguages'] as $l)
			{
				$filetomodify = "sections/{$section['link']}/section.$l.html";
				if (file_exists($filetomodify))
				{
					$empty = false;
					echo "&nbsp;<a  href=\"?mod={$_FN['mod']}&opt=$op&amp;filesection=$filetomodify\" ><img style=\"border:2px solid #00ff00;\" alt=\"\" title=\"" . _MODIFICA . "\" src=\"" . fromtheme("images/flags/$l.png") . "\" /></a>";
				}
				else
				{
					echo "&nbsp;<a  href=\"?mod={$_FN['mod']}&opt=$op&amp;filesection=$filetomodify\" ><img style=\"border:2px solid red;\" alt=\"\" title=\"" . _NEW_STATIC_PAGE . "\" src=\"" . fromtheme("images/flags/$l.png") . "\" /></a>";
				}
			}
			if ($empty)
			{
				$filetomodify = "sections/{$section['link']}/section.php";
				echo "&nbsp;<a  href=\"?mod={$_FN['mod']}&opt=$op&amp;filesection=$filetomodify\" ><img style=\"border:2px solid red;\" alt=\"\" title=\"" . _NEW_DYNAMIC_PAGE . "\" src=\"" . fromtheme("images/mime/php.png") . "\" /></a>";
			}
		}
		echo "\n</td>";
		$perm = getsectperm("sections/" . $section['link']);
		echo "\n<td>";
		echo $perm['level'];
		if ($perm['level'] == 0)
			echo "(" . _ONLYREGISTERED . ")";
		echo "\n</td>";
		echo "\n<td>";
		echo ($perm['user_view'] == "") ? "-" : $perm['user_view'];
		echo "\n</td>";
		echo "\n<td>";
		echo ($perm['group_view'] == "") ? "-" : $perm['group_view'];
		echo "\n</td>";
		echo "\n<td>";
		echo ($perm['user'] == "") ? "-" : $perm['user'];
		echo "\n</td>";
		echo "\n<td>";
		echo ($perm['group'] == "") ? "-" : $perm['group'];
		echo "\n</td>";
		echo "\n<td>";
		echo "<img style=\"cursor:pointer\" title=\""._FNDELETESECTION." {$section['link']}"."\" src=\"" . fromtheme("images/delete.png") . "\" onclick=\"check('verify.php?mod=delsection&sectionname={$section['link']}&from=" . basename($_FN['self']) . "?mod=" . urlencode($_FN['vmod'] . "&opt=$op") . "');\" />";
		echo "\n</td>";

		echo "</tr>";

	}

	echo "</tbody></table>";

	return;
}
/**
 * 
 * @param string $where
 * @param string $selected
 */
function print_all_prefix2($where, $selected)
{
	global $_FNMESSAGE;
	$ret = array ();
	if (file_exists($where) && is_dir($where))
	{
		$handle = opendir($where);
		while (false !== $file = readdir($handle))
		{
			if (preg_match("/^[0-9]+_|^none_/si", $file))
			{
				$tmp = preg_replace("/^[0-9]+_|^none_/s", "", $file);
				$prefix = str_replace("_$tmp", "", $file);
				if ($prefix != "none")
					$ret[] = $prefix;
			}

		}
	}
	echo "\n<option value=\"none\">" . $_FNMESSAGE['hidden'] . "</option>";
	for ($i = 0; $i < 100; $i++)
	{
		$p = $i;
		if ($p < 10)
		{
			$p = "0$p";
		}
		//cerca la prima libera
		if ($selected == "" && !in_array($p, $ret))
			$selected = $p;
		if ($selected == $p)
			echo "\n<option selected=\"selected\" value=\"$p\">$i</option>";
		else
		{
			if (!in_array($p, $ret))
			{
				echo "\n<option value=\"$p\">$i</option>";
			}
			else
			{
				echo "\n<option disabled=\"disabled\" value=\"$p\">$i</option>";

			}
		}
	}

}

/**
 * 
 * 
 */
function get_sectiontitle_tree($mod)
{
	$tit = "";
	$albero = explode("/", $mod);
	$so = sizeof($albero);
	for ($i = 0; $i < $so; $i++)
	{
		$mypath = "";
		for ($j = 0; $j <= $i; $j++)
		{
			$mypath .= $albero[$j];
			if ($i > 0 and ($j != $i))
				$mypath .= "/";
		}
		$tmp = getLang("sections/$mypath/lang.xml", preg_replace("/^[0-9][0-9]_/si", "", $albero[$i]));
		$tit .= str_replace("_", "&nbsp;", $tmp);
		if ($i != $so -1)
			$tit .= "/";
	}
	return $tit;
}
?>