<?php
/**
 * Section filemanager created on 3-mag-2006
 *
 * @package Flatnux
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @copyright Copyright (c) 2003-2005
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 */
if ( strpos(strtolower($_SERVER['SCRIPT_NAME']),strtolower(basename(__FILE__))) )
{
	header("Location: ../../index.php");
	die("...");
}
//-------------start filemanager ------------->
define("_SIZE1",200);
define("_SIZE2",50);
define("_SIZE3",77);
define("_SIZE4",135);
define("_SIZE5",160);
global $_FNMESSAGE,$_FN;
if ( is_admin() || ($_FN['user'] != "" && versecid($_FN['user'])) )
{
	strstr(PHP_OS,"WIN") ? $slash = "\\" : $slash = "/";
	$_FN['slash'] = $slash;
	$filemanagerdir = substr(realpath($_SERVER['SCRIPT_FILENAME']),0,(strrpos(realpath($_SERVER['SCRIPT_FILENAME']),"$slash"))) . "$slash";
	$dir = getparam("dir",PAR_POST,SAN_FLAT);
	if ( $dir == "" )
		$dir = getparam("dir",PAR_GET,SAN_FLAT);
	if ( $dir == "" )
		$dir = $filemanagerdir;
		//dprint_r($filemanagerdir);
	$dir = realpath($dir);
	
	$browse_all_filesystem = 0;
	if ( $browse_all_filesystem == 0 )
	{
		$minlevel = realpath(dirname($_SERVER['SCRIPT_FILENAME']));
		//dprint_r("dir=$dir minlevel=".$minlevel);
		if (  !preg_match("/^" . str_replace('/','\\/',str_replace("\\","\\\\",$minlevel)) . "/s",$dir) )
		{
			$dir = $minlevel;
		}
	}
	
	$file = isset($_GET['ffile']) ? $_GET['ffile'] : null;
	if ( $file == null )
		$file = isset($_POST['ffile']) ? $_POST['ffile'] : null;
	$opmod = isset($_GET['opmod']) ? $_GET['opmod'] : null;
	if ( $opmod == null )
		$opmod = isset($_POST['opmod']) ? $_POST['opmod'] : null;
	$dir = realpath($dir);
	//echo "dir=$dir,file=$file";
	if (  !$dir )
		$dir = "$slash";
	switch ($opmod)
	{
		case "save" :
			fm_save_file($dir,$file);
			fm_browse($dir);
		break;
		case "open" :
			fm_open_file($dir,$file);
		break;
		case "rename" :
			fm_rename_file($dir,$file);
		break;
		case "newfolder" :
			fm_newfolder($dir);
			fm_browse($dir);
		break;
		case "newfile" :
			fm_newfile($dir);
			fm_browse($dir);
		break;
		case "dorename" :
			fm_dorename_file($dir,$file);
			fm_browse($dir);
		break;
		case "delfile" :
			fm_dodel_file($dir,$file);
			fm_browse($dir);
		break;
		case "upload" :
			fm_upload_file($dir);
			fm_browse($dir);
		break;
		default :
		case "browse" :
		case "" :
			fm_browse($dir);
		break;
	}
}
//-------------start filemanager -------------<
/**
 * upload a file
 *
 * @param string $dir
 */
function fm_upload_file($dir)
{
	global $_FNMESSAGE,$_FN;
	$file_clean = strippostpslashes($_FILES['filename']['name']);
	if ( file_exists($dir . "/" . $file_clean) )
	{
		echo $_FNMESSAGE['_FCC_FILEEXISTS'];
		return;
	}
	if (  !can_modify_file($_FN['user'],$dir . "/" . $file_clean) ) // se non e' un file valido
	{
		echo _NONPUOI . " - " . _FILENOTCREATED . "<br />";
	}
	else
	{
		if (  !move_uploaded_file($_FILES['filename']['tmp_name'],$dir . "/" . $file_clean) )
		{
			echo "" . _FILENOTCREATED . "<br />";
		}
	}
}
/**
 * create folder
 *
 * @param string $dir
 */
function fm_newfolder($dir)
{
	if (  !is_admin() )
		return;
	$folder = getparam("newfolder",PAR_POST,SAN_FLAT);
	if ( $folder == "" )
		return;
	if ( file_exists("$dir/$folder") )
		return;
	if (  !is_writable("$dir") )
		return;
	mkdir("$dir/$folder");
}
/**
 * create file
 *
 * @param string $dir
 */
function fm_newfile($dir)
{
	global $_FN;
	$file = getparam("newfile",PAR_POST,SAN_FLAT);
	if ( $file == "" )
		return;
	if ( file_exists("$dir{$_FN['slash']}$file") )
	{
		jsalert(_FIG_ALERTEXIST);
		return;
	}
	if (  !is_writable("$dir") )
	{
		jsalert(_FIG_ALERTNOTWR);
		return;
	}
	if (  !can_modify_file($_FN['user'],"$dir{$_FN['slash']}$file") )
	{
		jsalert(_NONPUOI);
		return;
	}
	jsalert(_FNFILECREATED);
	$fp = fopen("$dir{$_FN['slash']}$file","a+");
	fclose($fp);
}
/**
 * Delet file
 *
 * @param string $dir
 * @param string $file
 */
function fm_dodel_file($dir, $file)
{
	global $_FN;
	if ( $file == "" )
		return;
	if ( $_FN['user'] == "" ||  !versecid($_FN['user']) )
		return;
	if (  !can_modify_file($_FN['user'],"$dir{$_FN['slash']}$file") )
		return;
		//echo "del $file ";
	//return;
	if ( is_dir("$dir{$_FN['slash']}$file") )
	{
		//echo "deldir $dir{$_FN['slash']}$file";
		rmdird("$dir{$_FN['slash']}$file");
	}
	else
	{
		if (  !is_admin() )
			backup_file("$dir{$_FN['slash']}$file");
		unlink("$dir{$_FN['slash']}$file");
		jsalert(_FNFILEDELETED);
	}
}
/**
 * fm_rename_file
 * Apre un file
 * @param string $dir
 * @param string $file
 */
function fm_rename_file($dir, $file)
{
	global $_FN;
	$sess_filemanager_editor = getparam("filemanager_editor",PAR_GET,SAN_FLAT);
	$op = getparam("opt",PAR_GET,SAN_FLAT);
	$mime = getparam("mime",PAR_GET,SAN_HTML);
	$from = fm_link(array("opmod"=>"","ffile"=>""),"&");
	echo "<div style=\"display:block;text-align:center;margin-top:auto;padding:10px;background-color:transparent;\">";
	echo "\n<form method=\"post\" action=\"?mod={$_FN['mod']}&amp;filemanager_editor=$sess_filemanager_editor&amp;mime=$mime&amp;opt=$op&amp;dir=$dir&amp;ffile=$file&amp;opmod=dorename\">";
	echo "\n<input size=\"40\" name=\"newname\" value=\"" . ($file) . "\" /><br />";
	echo "\n<input type=\"submit\" class=\"submit\" value=\"" . fn_i18n("_FCC_RENAME") . "\" />";
	echo "\n<input type=\"button\" onclick=\"window.location='$from'\" class=\"button\" value=\"" . fn_i18n("_CANCEL") . "\" />";
	echo "\n</form>";
	echo "</div>\n";
}
function fm_dorename_file($dir, $file)
{
	global $_FNMESSAGE,$_FN;
	$newname = getparam("newname",PAR_POST,SAN_FLAT);
	if ( $newname == "" )
		return;
	if (  !can_modify_file($_FN['user'],"$dir{$_FN['slash']}$newname") )
	{
		jsalert(_NONPUOI);
		return;
	}
	if ( file_exists("$dir{$_FN['slash']}$newname") )
	{
		jsalert($_FNMESSAGE['_FCC_FILEEXISTS']);
		return;
	}
	//echo "<br>dir=$dir";
	//echo "<br>file=$file";
	//echo "<br>dirnewname=$dir/$newname";
	if (  !is_writable($dir) ||  !is_writable("$dir{$_FN['slash']}$file") )
	{
		jsalert(_FIG_ALERTNOTWR);
		return;
	}
	jsalert(_FNFILERENAMED . ":\n$file => $newname");
	//	if (is_dir("$dir{$_FN['slash']}$file"))
	backup_file("$dir{$_FN['slash']}$file","$dir{$_FN['slash']}$newname");
	rename("$dir{$_FN['slash']}$file","$dir{$_FN['slash']}$newname");
}
/**
 * fm_open_file
 * Apre un file
 * @param string $dir
 * @param string $file
 */
function fm_open_file($dir, $file)
{
	$sess_filemanager_editor = getparam("filemanager_editor",PAR_GET,SAN_FLAT);
	global $_FN,$_FNMESSAGE;
	$mime = getparam("mime",PAR_GET,SAN_HTML);
	$filetype = fn_mime_content_type(realpath("$dir{$_FN['slash']}$file"));
	$scriptfilename = basename(getparam('SCRIPT_FILENAME',PAR_SERVER,SAN_FLAT));
	$op = getparam("opt",PAR_GET,SAN_FLAT);
	$local = getparam("local",PAR_GET,SAN_FLAT);
	$abs = getparam("abs",PAR_GET,SAN_FLAT);
	$lind = fm_link(array("opmod"=>"","dir"=>$dir,"ffile"=>""),"&");
	$image_http_link = realpath(dirname($_SERVER['SCRIPT_FILENAME'])) . $_FN['slash'];
	$image_http_link = str_replace($image_http_link,"{$_FN['siteurl']}","$dir/$file");
	$image_http_link = str_replace($_FN['slash'],"/",$image_http_link);
	if ( $local == "" )
	{
		$url_link = $image_http_link;
	}
	else
	{
		$url_link = "$dir/$file";
		if ( $abs == "" )
		{
			$url_link = realpath(dirname($_SERVER['SCRIPT_FILENAME'])) . $_FN['slash'];
			$url_link = str_replace($url_link,"","$dir/$file");
		}
	}
	$image_fullpath = realpath(dirname($_SERVER['SCRIPT_FILENAME'])) . $_FN['slash'] . $file;
	echo "<div style=\"display:block;text-align:center;margin-top:auto;padding:10px;background-color:transparent;\">";
	if (  !isset($_GET['edit']) )
	{
		echo "<img style=\"vertical-align:middle;position:absolute;right:10px\"src=\"" . fn_GetIconByFilename($file) . "\" alt=\"\" />";
		echo ("\n<span style=\"font-size:20px\">$file</span>");
		echo ("\n<br />" . "$image_fullpath");
		echo ("\n<br />" . "URL" . "\t: <a " . stylea() . "onclick=\"window.open(this.href);return false;\" href=\"$image_http_link\" >$image_http_link</a>");
		echo ("\n<br />" . $_FNMESSAGE['_FCC_FILETYPE'] . "\t: $filetype ");
		echo ("\n<br />" . $_FNMESSAGE['_FCC_FILESIZE'] . "\t: " . fn_byteConvert(@filesize("$dir{$_FN['slash']}$file")) . "");
		echo ("\n<br />" . $_FNMESSAGE['_FCC_FILEPERM'] . "\t: " . get_perms("$dir{$_FN['slash']}$file"));
		echo ("\n<br />" . $_FNMESSAGE['_FCC_FILEDATA'] . "\t: " . date("Y-m-d h:i:s",filemtime("$dir{$_FN['slash']}$file")));
		//echo "$image_http_link";
	}
	if ( preg_match('/^text\\//s',$filetype) == 1 || filesize("$dir{$_FN['slash']}$file") == 0 )
	{
		if ( isset($_GET['edit']) && $_GET['edit'] != "" )
		{
			edit_file_form($dir,$file);
		}
		else
		{
			if ( can_modify_file($_FN['user'],"$dir{$_FN['slash']}$file") )
				echo "<div style=\"text-align:left;background-color:transparent;\">" . fn_i18n("_ANTEPRIMA") . ":</div><div style=\"background-color:#ffffff;height:200px;overflow:auto;border:1px inset #000000;padding:5px\"><div style=\"white-space:normal;text-align:left;\">" . htmlspecialchars(file_get_contents("$dir{$_FN['slash']}$file",0,null, -1,50000),ENT_QUOTES) . "</div></div>";
			else
				echo "<div style=\"text-align:left;background-color:transparent;\">" . fn_i18n("_ANTEPRIMA") . ":</div><div style=\"background-color:#ffffff;height:200px;overflow:auto;border:1px inset #000000;padding:5px\">" . fn_i18n("_FCC_NOT_AVAILABLE") . "</div>";
			echo "<input type='button' class='button' onclick=\"window.location='$lind'\"  value='&lt;&lt;" . _INDIETRO . "' />";
			if ( $sess_filemanager_editor != "" )
			{
				echo "&nbsp;<input type='button' class='button' onclick=\"insertElement('$url_link')\" value=\"" . $_FNMESSAGE['_FCC_INSERT'] . "\"/>";
			}
			else
			{
				if ( can_modify_file($_FN['user'],"$dir{$_FN['slash']}$file") )
				{
					echo "&nbsp;<input type='button' class='button' onclick=\"window.location='?mod={$_FN['mod']}&amp;filemanager_editor=$sess_filemanager_editor&amp;mime=$mime&amp;edit=yes&amp;opmod=open&amp;opt=$op&amp;dir=" . urlencode($dir) . "&amp;ffile=$file'\" value=\"" . _MODIFICA . " $file\"/>";
				}
				echo "&nbsp;<input type='button' class='button' onclick=\"window.location='?mod={$_FN['mod']}&amp;filemanager_editor=$sess_filemanager_editor&amp;mime=$mime&amp;opmod=rename&amp;opt=$op&amp;dir=" . urlencode($dir) . "&amp;ffile=$file'\" value=\"" . fn_i18n('_FCC_RENAME') . " $file\"/>";
			}
		}
	}
	else
	{
		if ( preg_match("/^image\\//s",$filetype) == 1 )
		{
			if (  !function_exists("imagecreatetruecolor") )
			{
				$icon = $image_http_link;
			}
			else
			{
				$icon = "{$_FN['siteurl']}sections/none_filemanager/thumb.php?f=$dir{$_FN['slash']}$file&amp;h=185&amp;w=480";
			}
			echo "<div style=\"text-align:left;background-color:transparent;\">" . fn_i18n("_ANTEPRIMA") . ":</div><div style=\"background-color:transparent;background-image:url('images/transparent.png');height:200px;overflow:auto;border:1px inset #000000;padding:5px\"><img style=\"background-color:transparent;\" src=\"$icon\" border=\"0\"  alt=\"\" /></div>";
			echo "<br /><br /><input type='button' class='button' onclick=\"window.location='$lind'\"  value='&lt;&lt;" . _INDIETRO . "' />";
			if ( $sess_filemanager_editor != "" )
			{
				echo "&nbsp;<input type='button' class='button' onclick=\"insertElement('$url_link');\" value=\""  . $_FNMESSAGE['_FCC_INSERT'] . "\"/>";
			}
			else
			{
				echo "&nbsp;<input type='button' class='button' onclick='window.location=\"sections/none_filemanager/download.php?file=" . urlencode($dir) . "/" . basename($file) . "\"'  value='" . "Download" . "' />";
				echo "&nbsp;<input type='button' class='button' onclick=\"window.location='?mod={$_FN['mod']}&amp;filemanager_editor=$sess_filemanager_editor&amp;mime=$mime&amp;opmod=rename&amp;opt=$op&amp;dir=" . urlencode($dir) . "&amp;ffile=$file'\" value=\"" . fn_i18n('_FCC_RENAME') . " $file\"/>";
			}
		}
		else
		{
			echo "<div style=\"text-align:left;background-color:transparent;\">" . fn_i18n("_ANTEPRIMA") . ":</div><div style=\"background-color:transparent;height:200px;overflow:auto;border:1px inset #000000;padding:5px\">" . fn_i18n("_FCC_NOT_AVAILABLE") . "</div>";
			echo "<br /><br /><input type='button' class='button' onclick=\"window.location='$lind'\"  value='&lt;&lt;" . _INDIETRO . "' />";
			if ( $sess_filemanager_editor != "" )
			{
				echo "&nbsp;<input type='button' class='button' onclick=\"insertElement('$url_link" . "')\" value=\"" . $_FNMESSAGE['_FCC_INSERT'] . "\"/>";
			}
			else
			{
				echo "&nbsp;<input type='button' class='button' onclick='window.location=\"sections/none_filemanager/download.php?file=" . urlencode($dir . "/" . basename($file)) . "\"'  value='" . "Download" . "' />";
				echo "&nbsp;<input type='button' class='button' onclick=\"window.location='?mod={$_FN['mod']}&amp;filemanager_editor=$sess_filemanager_editor&amp;mime=$mime&amp;opmod=rename&amp;opt=$op&amp;dir=" . urlencode($dir) . "&amp;ffile=$file'\" value=\"" . fn_i18n('_FCC_RENAME') . " $file\"/>";
			}
		}
	}
	echo "</div>";
}
/**
 * fm_save_file
 * Salva un file
 * @param string $dir
 * @param string $file
 */
function fm_save_file($dir, $file)
{
	global $_FN;
	if (  !isset($_POST['body']) || $file == "" )
	{
		return;
	}
	$body = strippostpslashes($_POST['body']);
	$filetowrite = "$dir{$_FN['slash']}$file";
	//echo "$filetowrite";
	if ( is_dir($filetowrite) )
		echo "is directory";
	elseif (  !file_exists($filetowrite) )
		echo "$filetowrite file not exists";
	elseif (  !is_writable($filetowrite) )
		echo _READONLY;
	else
	{
		$handle = fopen($filetowrite,"w");
		fwrite($handle,$body);
		fclose($handle);
		echo "<br />" . jsalert("$filetowrite saved");
		//echo "file salvato correttamente";
	}
}
/**
 * 
 * 
 * 
 */
function edit_file_form($dir, $file)
{
	global $_FN;
	$sess_filemanager_editor = getparam("filemanager_editor",PAR_GET,SAN_FLAT);
	$mime = getparam("mime",PAR_GET,SAN_HTML);
	$op = getparam("opt",PAR_GET,SAN_FLAT);
	//echo "edit $dir{$_FN['slash']}$file";
	//--- modifica del file ----
	if ( $file !== null && file_exists($dir . "{$_FN['slash']}" . $file) )
	{
		$readonly = $enable = "";
		$lhl = strtolower(get_file_extension($file));
		//solo l' amministratore puo' modificare files php
		if (  !can_modify_file($_FN['user'],"$dir{$_FN['slash']}$file") )
		{
			//echo "$file";
			return;
		}
		echo "<div style=\"text-align:center\"><b>" . _MODIFICA . ":</b>" . realpath("$dir{$_FN['slash']}$file") . "</div>";
		echo "<form method='post' action='?mod={$_FN['mod']}&amp;opt=$op&amp;filemanager_editor=$sess_filemanager_editor&amp;mime=$mime'>";
		if (  !is_writable("$dir{$_FN['slash']}$file") )
		{
			$readonly = "readonly='readonly' ";
			$enable = " disabled=\"true\" ";
		}
		echo "<textarea id=\"body\" name=\"body\" $readonly cols=\"80\" rows=\"28\" >" . htmlspecialchars(file_get_contents($dir . "/" . $file)) . "</textarea>";
		echo "<br /><input $enable type='submit' value='" . _SAVE . "'  />";
		echo "\n <input type=\"hidden\" name=\"opmod\" value=\"save\" />";
		echo "\n <input type=\"hidden\" name=\"ffile\" value=\"$file\" />";
		echo "\n <input type=\"hidden\" name=\"dir\" value=\"$dir\" />";
		echo "<input type='button' class='button' onclick='history.back()'  value='" . _CANCEL . "' />";
		echo "</form>";
		echo "";
		if ( $_FN['syntax_highlighting'] == "1" )
		{
			if ( $lhl !== "php" && $lhl !== "sql" && $lhl !== "js" && $lhl !== "html" && $lhl !== "xhtml" && $lhl !== "xml" && $lhl !== "css" )
				$lhl = "text";
			if ( $lhl == "xml" || $lhl == "xhtml" || $lhl == "htm" )
				$lhl = "html";
			if ( $lhl == "js" )
				$lhl = "javascript";
			echo "\n<script type=\"text/javascript\" src=\"include/codepress/codepress.js\" ></script>";
			echo "\n<script type=\"text/javascript\" >codepressReplaceTextarea(\"include/codepress/\",\"body\",\"$lhl\",600,300);";
			echo "</script>";
		}
	}
}
/**
 * make filemanager link
 * 
 * @param array $params
 */
function fm_link($params = false, $sep = "&amp;")
{
	global $_FN;
	$sess_filemanager_editor = getparam("filemanager_editor",PAR_GET,SAN_FLAT);
	$link = array();
	foreach ( $_GET as $key=>$value )
	{
		if ( isset($_GET[$key]) )
		{
			$link[$key] = "$key=" . getparam("$key",PAR_GET,SAN_FLAT);
			if ( getparam("$key",PAR_GET,SAN_FLAT) == "" )
				unset($link[$key]);
		}
	}
	if ( is_array($params) )
	{
		foreach ( $params as $key=>$value )
		{
			$link[$key] = "$key=" . urlencode($params[$key]);
			if ( $params[$key] == "" )
				unset($link[$key]);
		}
	}
	$link = "?" . implode($sep,$link);
	return $link;
}
/**
 * browse
 * visualizza elenco cartelle e files
 * @param string dir
 * 
 */
function fm_browse($dir)
{
	global $_FNMESSAGE,$_FN;
	$sess_filemanager_editor = getparam("filemanager_editor",PAR_GET,SAN_FLAT);
	$op = getparam("opt",PAR_GET,SAN_FLAT);
	$mime = getparam("mime",PAR_GET,SAN_HTML);
	//dprint_r($_FN);
	$exdir = explode($_FN['slash'],$dir);
	$strdir = "";
	$pd = "";
	foreach ( $exdir as $ld )
	{
		$pd .= $ld;
		if ( can_modify($_FN['user'],$pd) )
			$strdir .= "<a href=\"" . fm_link(array("dir"=>$pd,"opmod"=>"")) . "\">$ld</a>{$_FN ['slash']}";
		else
			$strdir .= "$ld{$_FN ['slash']}";
		$pd .= $_FN['slash'];
	}
	$op = getparam("opt",PAR_GET,SAN_FLAT);
	$mime = getparam("mime",PAR_GET,SAN_HTML);
	$order = getparam("order",PAR_GET,SAN_FLAT);
	$viewmode = getparam("mode",PAR_GET,SAN_FLAT);
	if ( $order == "" )
		$order = "name";
		//$viewmode="t";
	//---  creazione elenco ---
	// BARRA NAVIGAZIONE -------------------->
	echo "<div>";
	echo "<a href=\"javascript:history.back()\"><img src=\"images/icons/back.png\" style=\"vertical-align:middle;height:16px;width:16px;border:0px\" alt=\"" . _INDIETRO . "\" title=\"" . _INDIETRO . "\"></a>";
	echo "<a href=\"javascript:history.forward()\"><img src=\"images/icons/forward.png\" style=\"vertical-align:middle;height:16px;width:16px;border:0px\" alt=\"" . _AVANTI . "\" title=\"" . _AVANTI . "\"></a>";
	if ( can_modify($_FN['user'],dirname($dir)) )
	{
		$l = fm_link(array("dir"=>dirname("$dir"),"opmod"=>""));
		echo "&nbsp;<a href=\"$l\"><img src=\"images/icons/folder-up.png\" style=\"vertical-align:middle;height:16px;width:16px;border:0px\" alt=\"home\"></a>";
	}
	$l = fm_link(array("dir"=>".","opmod"=>""));
	if ( can_modify($_FN['user'],".") )
	{
		echo "&nbsp;|&nbsp;<a href=\"$l\"><img src=\"images/icons/home.png\" style=\"vertical-align:middle;height:16px;width:16px;border:0px\" alt=\"home\"></a>";
	}
	if ( $viewmode == "" )
	{
		$l = fm_link(array("mode"=>"t","opmod"=>""));
		echo "&nbsp;|&nbsp;&nbsp;<a title=\"" . fn_i18n("_ANTEPRIMA") . "\" href=\"$l\"><img src=\"images/mime/image.png\" style=\"vertical-align:middle;height:16px;width:16px;border:1px outset transparent\" alt=\"home\"></a>";
	}
	else
	{
		$l = fm_link(array("mode"=>"","opmod"=>""));
		echo "&nbsp;|&nbsp;&nbsp;<a title=\"" . fn_i18n("_ANTEPRIMA") . "\" href=\"$l\"><img src=\"images/mime/image.png\" style=\"vertical-align:middle;height:16px;width:16px;border:1px inset #dadada\" alt=\"home\"></a>";
	}
	echo "&nbsp;&nbsp;&nbsp;$strdir</div>";
	// BARRA NAVIGAZIONE --------------------<
	// TITOLI -------------------->
	$down = "&nbsp;<img src=\"images/icons/down.png\" style=\"border:0px;height:10px;vertical-align:middle\"/>";
	$bgcolorselect = "#f0f0f0";
	$bgcolor = "#dadada";
	echo "\n<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\" style=\"margin-top:10px;\">";
	echo "\n\t<tr style=\"\">";
	$a = $order == "name" ? $down : "";
	$cl = $order == "name" ? $bgcolorselect : $bgcolor;
	echo "<td style=\"width:" . (_SIZE1 - 1) . "px;background-color:$cl;color:#000000;border-left:1px solid #000000\"><a href=\"" . fm_link(array("order"=>"name")) . "\" " . stylediv(_SIZE1 - 1) . " >";
	echo $_FNMESSAGE['_FCC_FILENAME'] . $a;
	echo "</div></td>";
	$a = $order == "size" ? $down : "";
	$cl = $order == "size" ? $bgcolorselect : $bgcolor;
	echo "<td style=\"width:" . (_SIZE2 - 1) . "px;background-color:$cl;color:#000000;border-left:1px solid #000000\"><a href=\"" . fm_link(array("order"=>"size")) . "\"" . stylediv(_SIZE2 - 1) . " >";
	echo $_FNMESSAGE['_FCC_FILESIZE'] . $a;
	echo "\n\t\t</td>";
	$a = $order == "perm" ? $down : "";
	$cl = $order == "perm" ? $bgcolorselect : $bgcolor;
	echo "\n\t\t<td style=\"width:" . (_SIZE3 - 1) . "px;background-color:$cl;color:#000000;border-left:1px solid #000000\"><a href=\"" . fm_link(array("order"=>"perm")) . "\"" . stylediv(_SIZE3 - 1) . " >";
	echo $_FNMESSAGE['_FCC_FILEPERM'] . $a;
	echo "</div></td>";
	$a = $order == "data" ? $down : "";
	$cl = $order == "data" ? $bgcolorselect : $bgcolor;
	echo "<td style=\"width:" . (_SIZE4 - 1) . "px;background-color:$cl;color:#000000;border-left:1px solid #000000\"><a href=\"" . fm_link(array("order"=>"data")) . "\"" . stylediv(_SIZE4 - 1) . " >";
	echo $_FNMESSAGE['_FCC_FILEDATA'] . $a;
	echo "</div></td>";
	echo "<td style=\"width:" . (_SIZE5 - 1) . "px;background-color:#efef52;color:#000000;border-left:1px solid #000000\"><div " . stylediv(_SIZE5 - 1) . " >";
	if ( $viewmode == "" )
		echo $_FNMESSAGE['_FCC_FILEOPTIONS'];
	echo "</div></td>";
	echo "\n\t</tr>";
	echo "\n</table>";
	// TITOLI --------------------<
	// CONTENUTO -------------------->
	echo "<div style=\"background-color:#f1f1e3;border:1px inset;height:300px;overflow:auto\">";
	if (  !is_readable($dir) )
		die("<br />accesso negato");
	$handle = opendir($dir);
	$listdir = array();
	$listfiles = array();
	while (false !== ($f = readdir($handle)))
	{
		if ( $f != ".." && $f != "." )
		{
			$dirname = "$dir{$_FN['slash']}$f";
			if ( is_dir($dir . "{$_FN['slash']}" . $f) && can_modify_file($_FN['user'],"$dir{$_FN['slash']}$f") )
			{
				//dprint_r(glob("$dir/$f/*"));
				$ncontents = count(glob("$dirname{$_FN['slash']}*"));
				$listdir[] = array("fullpath"=>$dirname,"name"=>basename($f),"size"=>$ncontents,"perm"=>get_perms($dirname));
			}
			else
			{
				if ( $mime == "" || preg_match("/" . str_replace('/','\\/',$mime) . "/s",fn_mime_content_type("$dir/$f")) )
				{
					if ( can_modify_file($_FN['user'],"$dir{$_FN['slash']}$f") )
					{
						$listfiles[] = array("fullpath"=>$dirname,"name"=>basename($f),"size"=>@filesize($dirname),"perm"=>get_perms($dirname));
					}
				}
			}
		}
	}
	//dprint_r($listdir);
	$listdir = array_sort_by_key($listdir,$order);
	$listfiles = array_sort_by_key($listfiles,$order);
	if ( $viewmode == "" )
	{
		echo "\n<table  border=\"0\" cellpadding=\"0\" cellspacing=\"0\" style=\"\">";
		foreach ( $listdir as $d )
		{
			echo "<tr>";
			drawfolder($d['fullpath'],$viewmode);
			echo "</tr>";
		}
		foreach ( $listfiles as $f )
		{
			echo "<tr>";
			drawfile($f['fullpath'],$viewmode);
			echo "<tr>";
		}
		echo "\n</table>";
	}
	else
	{
		foreach ( $listdir as $d )
		{
			drawfolder($d['fullpath'],$viewmode);
		}
		foreach ( $listfiles as $f )
		{
			drawfile($f['fullpath'],$viewmode);
		}
	}
	echo "</div>";
	// CONTENUTO --------------------<
	// FORM -------------------->
	if ( is_writable($dir) )
	{
		$ac = fm_link(array("opmod"=>"upload"));
		echo "<fieldset><table cellpadding=\"0\" cellspacing=\"0\" border=\"0\" >";
		echo "<tr >";
		echo "<td >";
		echo "" . _SENDFILE . ":";
		echo "</td>";
		echo "<td >";
		//echo "<form enctype=\"multipart/form-data\" method=\"post\" action=\"?mod={$_FN['mod']}&amp;opt=$op&amp;opmod=upload&amp;filemanager_editor=$sess_filemanager_editor&amp;mime=$mime\" >";
		echo "<form enctype=\"multipart/form-data\" method=\"post\" action=\"$ac\" >";
		echo "<input title=\"" . $_FNMESSAGE['_FCC_SENDNEWFILEHERE'] . "\" type=\"file\" name=\"filename\" value=\"upload\" />";
		echo "<input type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"90000000\" />";
		echo "<input type=\"submit\" class=\"submit\" value=\"" . _FINVIA . "\" name=\"send\" />";
		echo "<input type=\"hidden\" value=\"$dir\" name=\"dir\" />";
		echo "</form>";
		echo "</td>";
		echo "</tr>";
		if ( is_admin() )
		{
			echo "<tr>";
			echo "<td>";
			echo "<b>" . $_FNMESSAGE['_FCC_NEWFOLDER'] . " :</b>";
			echo "</td>";
			echo "<td>";
			echo "<form method=\"post\" action=\"?mod={$_FN['mod']}&amp;opt=$op&amp;dir=$dir&amp;opmod=newfolder&amp;filemanager_editor=$sess_filemanager_editor&amp;mime=$mime\" >";
			echo "<input size=\"20\" name=\"newfolder\" value=\"\" />";
			echo "<input type=\"submit\" class=\"submit\" value=\"" . _CREA . "\" name=\"send\" />";
			echo "</form>";
			echo "</td>";
			echo "</tr>";
		}
		echo "<tr>";
		echo "<td>";
		echo "" . $_FNMESSAGE['_FCC_NEWFILE'] . " :";
		echo "</td>";
		echo "<td>";
		echo "<form method=\"post\" action=\"?mod={$_FN['mod']}&amp;opt=$op&amp;dir=$dir&amp;opmod=newfile&amp;filemanager_editor=$sess_filemanager_editor&amp;mime=$mime\" >";
		echo "<input size=\"20\" name=\"newfile\" value=\"\" />";
		echo "<input type=\"submit\" class=\"submit\" value=\"" . _CREA . "\" name=\"send\" />";
		echo "</form>";
		echo "</td>";
		echo "</tr>";
		echo "\n</table></fieldset>";
	}
	// FORM --------------------<
}
function stylediv($size, $extra = "")
{
	return "style=\"font-size:10px;color:#000000;font-family:Verdana, Arial;white-space:nowrap;width:$size" . "px;overflow:hidden;margin:0px;padding:0px;$extra\"";
}
function stylea()
{
	return "style=\"text-decoration:none;font-weight:normal;padding:0px;font-size:10px;color:#000000;font-family:Verdana,'Lucida Grande';border:0px;margin:0px\"";
}
function stylef()
{
	return "style=\"background-color:#ffffff;font-weight:normal ; padding:0px ; font-size:10px ; color:#000000 ; font-family: Verdana , 'Lucida Grande' ; border:0px ; margin:0px\"";
}
/**
 * drawfolder
 * disegna una cartella
 */
function drawfolder($dir, $mode)
{
	global $_FN,$_FNMESSAGE;
	static $i = 0;
	$color[0] = "#ffffff";
	$color[1] = "#eaeaea";
	$color2[0] = "#f3e49c";
	$color2[1] = "#f3e4c8";
	$_FN['colorline'] = isset($_FN['colorline']) ? $_FN['colorline'] : 1;
	$bgcolor = $color[($_FN['colorline']) % 2];
	$bgcolor2 = $color2[($_FN['colorline']++ ) % 2];
	$sess_filemanager_editor = getparam("filemanager_editor",PAR_GET,SAN_FLAT);
	$op = getparam("opt",PAR_GET,SAN_FLAT);
	$mime = getparam("mime",PAR_GET,SAN_HTML);
	if ( basename($dir) == "." )
		return;
	$ncontents = count(glob("$dir/*"));
	$pdir = $dir;
	if ( basename($pdir) == ".." )
		$pdir = realpath($pdir);
		//$pdir = $pdir;
	$l = fm_link(array("dir"=>$pdir,"opmod"=>""));
	$l2 = fm_link(array("dir"=>$pdir,"opmod"=>""),"&");
	$tit = basename($dir);
	if ( $mode == "" )
		$icon = fromtheme("images/mime/dir.png");
	else
		$icon = fromtheme("sections/none_filemanager/folder.png");
	$size = $ncontents;
	$perm = get_perms($dir);
	$date = date("Y-m-d h:i:s",filemtime($dir));
	if ( $mode == "" )
	{
		echo "<td style=\"background-color:$bgcolor;width:" . _SIZE1 . "px\"><div " . stylediv(_SIZE1) . " >";
		echo "<a  title=\"" . fn_i18n("_OPEN") . "\"  " . stylea() . "href=\"$l\"" . "style=\"text-decoration: none;font-family: sans-serif,helvetica, arial;\" >";
		echo "<img style=\"vertical-align:middle\" src=\"$icon\" border='0' />&nbsp;";
		echo basename($dir) . "</a>";
		echo "</div>\n\t\t</td>";
		echo "\n\t\t<td style=\"background-color:$bgcolor;width:" . _SIZE2 . "px\"><div " . stylediv(_SIZE2,"text-align:right") . " >";
		echo "($ncontents)";
		echo "</div></td>";
		echo "<td style=\"background-color:$bgcolor;width:" . _SIZE3 . "px\"><div " . stylediv(_SIZE3,"text-align:right") . " >";
		echo get_perms($dir);
		echo "</div></td>";
		echo "<td style=\"background-color:$bgcolor;width:" . _SIZE4 . "px\"><div " . stylediv(_SIZE4,"text-align:right") . " >";
		echo date("Y-m-d h:i:s",@filemtime($dir));
		echo "</div></td>";
		if ( is_writable($dir) && basename($dir) != ".." )
		{
			$ldel = fm_link(array("opmod"=>"delfile","dir"=>dirname($dir),"ffile"=>basename($dir)),"&");
			$lmod = fm_link(array("opmod"=>"rename","dir"=>dirname($dir),"ffile"=>basename($dir)));
			echo "\n\t\t<td style=\"background-color:$bgcolor2;width:" . _SIZE5 . "px\"><div " . stylediv(_SIZE5) . " >&nbsp;";
			echo "<a " . stylea() . " href=\"javascript:check('?mod={$_FN['mod']}&opt=$op&opmod=delfile&dir=" . dirname($dir) . "&ffile=" . basename($dir) . "&filemanager_editor=$sess_filemanager_editor&mime=$mime');\">" . fn_i18n("_ELIMINA") . "</a>";
			echo "&nbsp;<a " . stylea() . " href=\"$lmod\" >" . fn_i18n('_FCC_RENAME') . "</a>";
			echo "</div></td>";
		}
		else
			echo "\n\t\t<td style=\"width:140px\">&nbsp;</td>";
	}
	else
	{
		echo "<div onmouseout=\"this.style.borderColor='#dadada'\" onmouseover=\"this.style.borderColor='#1010ff'\" onclick=\"window.location='$l2'\" style=\"float:left;background-color:#f0f0f0;margin:4px;border:1px solid #dadada;padding:0px;height:133px;width:112px;text-align:center;overflow:hidden\">";
		echo "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" title=\"" . fn_i18n("_OPEN") . " $tit\" onclick=\"window.location='$l2'\" style=\"cursor:pointer;background-color:#ffffff;margin:0px;line-height:80px;height:80px;width:100%;text-align:center;overflow:hidden\"><tr><td valign=\"center\">";
		echo "<img style=\"line-height:80px;margin:0px;border:0px;vertical-align:middle;\" src='$icon' alt=\"\" />";
		echo "</td></tr></table>";
		echo "<div style=\"font-weight:bold;font-size:12px;height:14px;overflow:hidden\">$tit</div>";
		echo "<div style=\"font-size:10px;height:12px;overflow:hidden\">($size)</div>";
		echo "<div style=\"font-size:10px;height:12px;overflow:hidden\">$perm</div>";
		echo "<div style=\"font-size:10px;height:12px;overflow:hidden\">$date</div>";
		echo "</div>";
	}
}
/**
 * drawfile
 * disegna un file
 */
function drawfile($file, $mode)
{
	global $_FN,$_FNMESSAGE;
	$color[0] = "#ffffff";
	$color[1] = "#eaeaea";
	$color2[0] = "#f3e49c";
	$color2[1] = "#f3e4c8";
	$_FN['colorline'] = isset($_FN['colorline']) ? $_FN['colorline'] : 1;
	;
	$bgcolor = $color[($_FN['colorline']) % 2];
	$bgcolor2 = $color2[($_FN['colorline']++ ) % 2];
	$sess_filemanager_editor = getparam("filemanager_editor",PAR_GET,SAN_FLAT);
	$mime = getparam("mime",PAR_GET,SAN_HTML);
	$op = getparam("opt",PAR_GET,SAN_FLAT);
	$pdir = dirname($file);
	$pfile = basename($file);
	$icon = fn_GetIconByFilename($file);
	$ldel = fm_link(array("opmod"=>"delfile","dir"=>dirname($file),"ffile"=>basename($file)),"&");
	$lmod = fm_link(array("opmod"=>"rename","dir"=>dirname($file),"ffile"=>basename($file)));
	$l = fm_link(array("ffile"=>basename($pfile),"dir"=>$pdir,"opmod"=>"open"));
	$l2 = fm_link(array("ffile"=>basename($pfile),"dir"=>$pdir,"opmod"=>"open"),"&");
	$tit = basename($file);
	$size = fn_byteConvert(@filesize($file));
	$perm = get_perms($file);
	$date = date("Y-m-d h:i:s",filemtime($file));
	if ( $mode == "" )
	{
		echo "<td style=\"background-color:$bgcolor;width:" . _SIZE1 . "px\"><div " . stylediv(_SIZE1) . " >";
		echo "<a title=\"" . fn_i18n("_OPEN") . "\" " . stylea() . " href=\"$l" . "\" >";
		echo "<img style=\"vertical-align:middle;width:16px;height:16px;\" src='$icon' border='0' />&nbsp;";
		echo basename($file) . "</a>";
		echo "</div></td>";
		echo "<td style=\"background-color:$bgcolor;width:" . _SIZE2 . "px\"><div " . stylediv(_SIZE2,"text-align:right") . " >";
		echo $size;
		echo "</div></td>";
		echo "<td style=\"background-color:$bgcolor;width:" . _SIZE3 . "px\"><div " . stylediv(_SIZE3,"text-align:right") . " >";
		echo $perm;
		echo "</div></td>";
		echo "<td style=\"background-color:$bgcolor;width:" . _SIZE4 . "px\"><div " . stylediv(_SIZE4,"text-align:right") . " >";
		echo $date;
		echo "</div></td>";
		echo "<td style=\"background-color:$bgcolor2;width:" . _SIZE5 . "px\"><div " . stylediv(_SIZE5) . " >&nbsp;";
		if ( is_writable($file) )
		{
			echo "<a " . stylea() . "href='#' onclick=\"check('$ldel');\">" . fn_i18n("_ELIMINA") . "</a>";
			echo "&nbsp;<a " . stylea() . " href=\"$lmod\" >" . fn_i18n('_FCC_RENAME') . "</a>&nbsp;";
		}
		echo "<a " . stylea() . " href=\"sections/none_filemanager/download.php?file=$pdir/" . basename($file) . "\" >" . "Download" . "</a>";
		echo "</div></td>";
	}
	else
	{
		$filetype = fn_mime_content_type($file);
		if ( preg_match("/^image\\//s",$filetype) == 1 )
		{
			$icon = "{$_FN['siteurl']}sections/none_filemanager/thumb.php?f=$file&amp;h=80&amp;w=110";
		}
		echo "<div onmouseout=\"this.style.borderColor='#dadada'\" onmouseover=\"this.style.borderColor='#1010ff'\" onclick=\"window.location='$l2'\" style=\"float:left;background-color:#f0f0f0;margin:4px;border:1px solid #dadada;padding:0px;height:133px;width:112px;text-align:center;overflow:hidden\">";
		echo "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" title=\"" . fn_i18n("_OPEN") . " $tit\" onclick=\"window.location='$l2'\" style=\"cursor:pointer;background-color:#ffffff;margin:0px;line-height:80px;height:80px;width:100%;text-align:center;overflow:hidden\"><tr><td valign=\"center\">";
		echo "<img style=\"line-height:80px;margin:0px;border:0px;vertical-align:middle;\" src='$icon' alt=\"\" />";
		echo "</td></tr></table>";
		echo "<div style=\"font-weight:bold;font-size:12px;height:14px;overflow:hidden\">$tit</div>";
		echo "<div style=\"font-size:10px;height:12px;overflow:hidden\">$size</div>";
		echo "<div style=\"font-size:10px;height:12px;overflow:hidden\">$perm</div>";
		echo "<div style=\"font-size:10px;height:12px;overflow:hidden\">$date</div>";
		echo "</div>";
	}
}
/**
 * 
 * @param string $filename
 */
function get_perms($filename)
{
	$perms = fileperms($filename);
	if ( ($perms & 0xC000) == 0xC000 )
	{
		// Socket
		$info = 's';
	}
	elseif ( ($perms & 0xA000) == 0xA000 )
	{
		// Symbolic Link
		$info = 'l';
	}
	elseif ( ($perms & 0x8000) == 0x8000 )
	{
		// Regular
		$info = '-';
	}
	elseif ( ($perms & 0x6000) == 0x6000 )
	{
		// Block special
		$info = 'b';
	}
	elseif ( ($perms & 0x4000) == 0x4000 )
	{
		// Directory
		$info = 'd';
	}
	elseif ( ($perms & 0x2000) == 0x2000 )
	{
		// Character special
		$info = 'c';
	}
	elseif ( ($perms & 0x1000) == 0x1000 )
	{
		// FIFO pipe
		$info = 'p';
	}
	else
	{
		// Unknown
		$info = 'u';
	}
	// Owner
	$info .= (($perms & 0x0100) ? 'r' : '-');
	$info .= (($perms & 0x0080) ? 'w' : '-');
	$info .= (($perms & 0x0040) ? (($perms & 0x0800) ? 's' : 'x') : (($perms & 0x0800) ? 'S' : '-'));
	// Group
	$info .= (($perms & 0x0020) ? 'r' : '-');
	$info .= (($perms & 0x0010) ? 'w' : '-');
	$info .= (($perms & 0x0008) ? (($perms & 0x0400) ? 's' : 'x') : (($perms & 0x0400) ? 'S' : '-'));
	// World
	$info .= (($perms & 0x0004) ? 'r' : '-');
	$info .= (($perms & 0x0002) ? 'w' : '-');
	$info .= (($perms & 0x0001) ? (($perms & 0x0200) ? 't' : 'x') : (($perms & 0x0200) ? 'T' : '-'));
	return $info;
}
/**
 * 
 * @param int $bytes
 */
function fn_byteConvert($bytes)
{
	if ( $bytes <= 0 )
		return '0 Byte';
	$convention = 1000; //[1000->10^x|1024->2^x]
	$s = array('B','kB','MB','GB','TB','PB','EB','ZB');
	$e = floor(log($bytes,$convention));
	return round($bytes / pow($convention,$e),2) . ' ' . $s[$e];
}
/**
 * Ricava il tipo di file
 * 
 */
function fn_mime_content_type($f)
{
	$ext = strtolower(get_file_extension($f));
	switch ($ext)
	{
		case "js" :
		case "inc" :
		case "xhtml" :
		case "xml" :
		case "html" :
		case "htm" :
		case "php" :
		case "txt" :
		case "sh" :
		case "" :
			return "text/plain";
		break;
		case "png" :
		case "bmp" :
		case "jpg" :
		case "jpeg" :
		case "ico" :
		case "gif" :
			return "image/$ext";
		break;
		default :
			return "binary/$ext";
		break;
	}
}
?>