<?php
function create_menu()
{
	global $_FN,$theme,$menu_recursive,$show_icons;
	$tl = ($_FN['lang'] != $_FN['lang_default']) ? "?lang={$_FN['lang']}" : "";
	if ( $_FN['home_section'] == "" )
	{
		echo "<div class=\"menuitem\"><a href=\"index.php$tl\">";
		if ( ($text = getLang("sections/.lang.xml")) != "" )
			echo $text;
		elseif ( defined(_FIRSTBUTTONMENU) )
			echo _FIRSTBUTTONMENU;
		else
			echo "HOME";
		echo "</a></div>";
	}
	printsection2("sections",$menu_recursive);
	fn_languages();
	echo "<br />";
}
function printsection2($path, $recursive = true)
{
	global $_FN,$theme,$home_section,$show_icons;
	static $slevel = 0;
	$modlist = list_sections_translated($path,false,false);
	$slevel++ ;
	$tl = ($_FN['lang'] != $_FN['lang_default']) ? "&lang={$_FN['lang']}" : "";
	foreach ( $modlist as $mod )
	{
		$tmp = $mod['title'];
		$link = $mod['link'];
		$accesskey = $mod['accesskey'];
		if ( $slevel == 1 )
		{
			//	echo "<div class=\"menuitem\">";
		}
		$icon = "";
		$hlink = get_section_id($link);
		$active = "";
		if ( fn_erg('^' . $mod['link'],$_FN['vmod']) )
			$active = "class=\"active\"";
		echo "<div class=\"menuitem\">";
		echo "\n\t$icon<a $active accesskey=\"$accesskey\" href=\"" . fn_rewritelink("index.php?mod=$hlink$tl") . "\">$tmp</a>";
		echo "</div>";
		if ( $slevel == 1 )
		{
			//		echo "</div>";
		}
		$l = basename($link);
		global $menu_recursive_onlyselected,$_FNVMOD;
		if ( $recursive )
		{
			if ( $menu_recursive_onlyselected && fn_erg('^' . $mod['link'],$_FN['vmod']) )
				printsection2("$path/$l");
			else
			{
				if (  !$menu_recursive_onlyselected )
					printsection2("$path/$l");
			}
		}
	}
	$slevel-- ;
}
function OpenBlock($image, $title)
{
	echo "<div class=\"block\"><fieldset><legend>$title</legend>";
}
function CloseBlock($image = "", $title = "")
{
	echo "</fieldset></div>";
}
function FN_OpenSection($title)
{
	echo "<div><div class=\"sectiontitle\">$title</div>";
}
function FN_CloseSection($title)
{
	echo "</div>";
}
function fn_languages()
{
	global $_FN;
	if ( $_FN['listlanguages'] > 1 )
	{
		echo "<div class=\"lang\">";
		$htmllanguages = array();
		foreach ( $_FN['listlanguages'] as $l )
		{
			$ll = $l;
			$a = getaccesskey($ll,"lang=$l");
			$ak = "";
			if ( $_FN['showaccesskey'] == 1 )
				$ak = "[$a]";
			$getvars = "";
			foreach ( $_GET as $key=>$value )
			{
				$key = getparam($key,PAR_NULL,SAN_HTML);
				$value = getparam($value,PAR_NULL,SAN_HTML);
				if ( $key !== "mod" && $key != "lang" )
				{
					$getvars .= "&amp;$key=$value";
				}
			}
			$image = fromtheme("images/flags/$l.png");
			$ltitle = getlang("languages/$l.php.xml",$l,$l);
			$htmllanguages[] = "<a  accesskey=\"$a\" title=\"$ltitle\" href=\"" . fn_rewritelink("index.php?mod={$_FN['idmod']}&amp;lang={$l}$getvars") . "\">" . "<img style=\"border:0px;\" src=\"$image\" alt=\"$ltitle\" />" . "</a>";
		}
		echo implode("&nbsp;",$htmllanguages);
		echo "</div>";
	}
}
?>