<?php
/**
 * Login Block
 * 
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @copyright Copyright (c) 2003-2009
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 * 
 * @package Flatnux
 */
if ( strpos(strtolower($_SERVER['SCRIPT_NAME']),strtolower(basename(__FILE__))) )
{
	header("Location: ../../index.php");
	die("...");
}
global $_FN;
global $_FNMESSAGE;
//---------OPZIONI UTENTE NON REGISTRATO------------>>>
if ( $_FN['user'] == "" )
{
	?>
<div style="text-align: center">
<form action="?mod=login" method="post">
<div><input type="hidden" name="op" value="login" /> <input
	type="hidden" name="from" value="<?php
	echo $_FN['mod']?>" /> <label for="username"><?php
	echo fn_i18n("_NOMEUTENTE")?>:<br />
</label> <input alt="username" name="nome" size="10" id="username" /><br />
<label for="password"><?php
	echo fn_i18n("_PASSWORD")?></label>:<br />
<input alt="password" name="logpassword" type="password" size="10"
	id="password" /><br />
		<?php
	if ( $_FN['remember_login'] == 1 )
	{
		echo "\n<div style=\"margin:1em;\"><label for=\"rememberlogin\">" . fn_i18n("_REMEMBERLOGIN") . "</label>";
		echo "\n<input type=\"checkbox\" alt=\"remember_login\" name=\"rememberlogin\" id=\"rememberlogin\" /><br />";
		echo "\n</div>";
	}
	else
		echo "<br />";
	?>
	<button type="submit" ><?php
	echo fn_i18n("_LOGIN")?></button>
</div>
</form>
	<?php
	if ( $_FN['enable_registration'] == 1 )
	{
		?>
	<b><a href="index.php?mod=login&amp;op=rec_pass"><?php
		echo $_FNMESSAGE['_FORGPASS2']?></a></b><br />
	<?php
		echo fn_i18n("_NONREG")?><br />
<a href="?mod=login&amp;op=vis_reg"><b><?php
		echo fn_i18n("_REGORA")?></b></a>
	<?php
	}
	?>
</div>
<?php
}
//---------OPZIONI UTENTE NON REGISTRATO------------<<
//---------OPZIONI UTENTE REGISTRATO------------>>>
else
{
	echo fn_i18n("_BENVENUTO") . " <b><a href=\"?mod=login&amp;op=profile&amp;user=" . $_FN['user'] . "\">" . $_FN['user'] . "</a></b>!";
	echo "\n<br /><br />";
	echo "\n<div style=\"text-align:center\">";
	echo "\n<a href=\"?mod=login&amp;op=profile&amp;user=" . $_FN['user'] . "\">";
	$uservalues = get_user($_FN['user']);
	$image = fromtheme("images/avatars/blank.png");
	if ( isset($uservalues['avatar']) && $uservalues['avatar'] != "" )
	{
		$image = "{$_FN['datadir']}/fndatabase/users/" . $_FN['user'] . "/avatar/" . $uservalues['avatar'];
	}
	else
	{
		if ( isset($uservalues['avatarimage']) && $uservalues['avatarimage'] != "" )
		{
			$image = ("{$_FN['datadir']}/fndatabase/avatars/" . urlencode($uservalues['avatarimage']) . "/filename/" . $uservalues['avatarimage']);
		}
		else
			$image = fromtheme("images/avatars/blank.png");
	}
	echo "<img src=\"$image\" alt=\"" . $_FN['user'] . "\" style=\"border:0px;\" />";
	print "</a></div><br />";
	$level = getlevel($_FN['user']);
	//-disegno la barra del livello ->
	if ( $level > 0 )
	{
		echo "\n<br />";
		echo "\n<div style=\"position: relative; float: left; width: 30px;\">0</div>";
		echo "\n<div style=\"position: relative; float: right; width: 30px; text-align: right;\">10</div>";
		echo "\n<div style=\"position: relative; margin-left: 0px; margin-right: 0px; text-align: center;\">";
		echo "\n<b>" . fn_i18n("_LEVEL") . " $level</b>";
		echo "\n</div>";
		echo "\n<div style=\"text-align:center\">";
		echo "\n<hr noshade=\"noshade\" size=\"1\" width=\"100%\" />";
		for ( $i = 0;$i < $level;$i++  )
			echo "<img  src=\"" . fromtheme("images/useronline/level_y.gif") . "\" alt=\"level\" align=\"middle\" />";
		for (;$i < $level;$i++  )
			echo "<img  src=\"" . fromtheme("images/useronline/level_n.gif") . "\" alt=\"level\" align=\"middle\" />";
		print "\n</div><hr size='1' noshade=\"noshade\" width='100%' align='center' />";
	}
	//-disegno la barra del livello -<
	echo "\n<div style=\"text-align:center\" >";
	if ( isadmin()  && $_FN ['enable_online_administration'])
	{
		echo "\n<a href=\"controlcenter.php?mod=none_Control_Center\">" . fn_i18n("_MANAGEFLATNUKE") . "</a><br />";
	}

	if ( user_can_edit_section($_FN['vmod']) && $_FN ['enable_online_administration'])
	{

		echo "<a title=\"" . fn_i18n("_FILESINSECTION") . "\" href=\"javascript:/**/\" onclick=\"window.open('filemanager.php?dir=sections/{$_FN['vmod']}/','" . "filemanager" . "','toolbar= 0,location= 0,directories= 0,status= 0,menubar= 0,scrollbars= 1,resizable= 1,width=640,height=480');\" >" . fn_i18n("_MANAGEFILE") . "</a><br />";
		echo "\n<hr size=\"1\" noshade=\"noshade\" width=\"100%\" align=\"center\" />";
	}
	echo "\n</div>";
	echo "<div style=\"text-align:right\"><a href=\"?mod=login&amp;op=logout&amp;from=index.php\"><b>" . _LOGOUT . "</b></a></div>";
}
//---------OPZIONI UTENTE REGISTRATO------------<<
?>