<?php
/**
 * @package flatnux_blocks
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @copyright Copyright (c) 2003-2005
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 */

if ( strpos(strtolower($_SERVER['SCRIPT_NAME']),strtolower(basename(__FILE__))) )
{
	header("Location: ../../index.php");
	die("...");
}
/**
 * Supmenu
 */
function CreateSubmenuBlock()
{
	global $_FN;
	if ( $_FN['vmod'] == "" )
		return;
	$modlist = list_sections_translated("sections/" . $_FN['vmod']); // return array width title - link
	if ( count($modlist) < 1 && strpos($_FN['vmod'],"/") !== false )
	{
		$nmod = substr($_FN['vmod'],0,(strrpos($_FN['vmod'],"/")));
		$modlist = list_sections_translated("sections/" . $nmod); // return array width title - link
		if ( count($modlist) <= 1 )
			return;
	}
	foreach ( $modlist as $modl )
	{
		$link = get_section_id($modl['link']);
		$title = $modl['title'];
		$accesskey = $modl['accesskey'];
		if ( $_FN['vmod'] == $link )
			$title = "<b>$title</b>";
		echo "<img  src=\"" . fromtheme("images/subsection.png") . "\" alt=\"\" />&nbsp;";
		echo "<a accesskey=\"$accesskey\" href=\"" . fn_rewritelink("index.php?mod=$link") . "\">$title</a><br />";
	}
}

CreateSubmenuBlock();
?>