<?php
/**
 * Controlcenter
 * 
 * @package Flatnux
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @copyright Copyright (c) 2003-2010
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 */
global $_FN;
$_FN = array();
$_GET['mod'] = "controlcenter";
include "./include/flatnux.php";
//disabilito il mod-rewrite per il pannello di controllo
$_FN['enable_mod_rewrite_default'] = $_FN['enable_mod_rewrite'];
$_FN['enable_mod_rewrite'] = 0;
require_once "./include/head.php";
echo "<body id=\"fn_contolcenterbody\">";
print_themes();
echo "<div  style=\"text-align:left;\">";
echo " <img src=\"" . fromtheme("images/configure.png") . "\" /> ";
echo "<a href=\"?mod=controlcenter\">Flatnux controlcenter</a> | ";
echo "<img src=\"" . fromtheme("images/icons/home.png") . "\" />&nbsp;";
echo "<a style=\"white-space:nowrap\" href=\"index.php?theme={$_FN['theme_default']}\">" . fn_i18n("_CC_VIEW_WEBSITE") . "</a>";
if ( $_FN['user'] != "" )
{
	echo " &nbsp;| &nbsp;" . fn_i18n("_BENVE") . "&nbsp;<a href=\"controlcenter.php?mod=controlcenter&opt=03_users/30_users&opmod=profile&user={$_FN['user']}\">{$_FN['user']}</a>&nbsp;";
	echo "&nbsp;&nbsp;|&nbsp;&nbsp;<img src=\"" . fromtheme("images/delete.png") . "\" />";
	echo "<a href=\"?fnlogin=logout\">" . fn_i18n("_LOGOUT") . "</a>";
}
echo "</div>";
echo "<hr />";
$opindex = getparam("opindex",PAR_GET,SAN_FLAT);
if ( $_FN['mod'] == "modcont" )
	$opindex = "modcont";
if ( $opindex )
{
	$filetomodify = getparam("file",PAR_GET,SAN_FLAT);
	if ( $filetomodify != "" && can_modify_file($_FN['user'],$filetomodify) )
	{
		if ( fn_erg('config.php$',$filetomodify) )
			fn_editconffile($filetomodify);
		else
			edit_content($filetomodify);
	}
}
else
{
	view_section($_FN['vmod'],false);
}
echo "</body></html>";
function print_languages()
{
	global $_FN;
	foreach ( $_FN['listlanguages'] as $l )
	{
		$ll = $l;
		$a = getaccesskey($ll,"lang=$l");
		$ak = "";
		if ( $_FN['showaccesskey'] == 1 )
			$ak = "[$a]";
		$getvars = "";
		foreach ( $_GET as $key=>$value )
		{
			$key = getparam($key,PAR_NULL,SAN_HTML);
			$value = getparam($value,PAR_NULL,SAN_HTML);
			if ( $key !== "mod" && $key != "lang" )
			{
				$getvars .= "&amp;$key=$value";
			}
		}
		$image = fromtheme("images/flags/$l.png");
		echo "&nbsp;<a accesskey=\"$a\" href=\"?lang=$l&amp;mod={$_FN['mod']}$getvars\">$ak<img style=\"border:0px;vertical-align:middle\" src=\"$image\" alt=\"$l\" /></a>";
	}
}
/**
 * print combo with themes
 *
 */
function print_themes()
{
	global $_FN;
	$handle = opendir("themes/");
	$list_themes = array();
	while (false !== ($file = readdir($handle)))
	{
		if (  !($file == "." or $file == "..") and is_dir("themes/$file") )
		{
			if ( file_exists("themes/$file/theme.php") )
				array_push($list_themes,$file);
		}
	}
	closedir($handle);
	$mod = $_FN['mod'];
	echo "
	<form method=\"get\" style=\"float:right;\" action=\"\" name=\"f\">";
	echo fn_i18n("_THEME") . " controlcenter:<select style=\"vertical-align:middle\" name=\"theme\" onchange=\"window.location='?cc_theme='+ document.f.theme.options[document.f.theme.selectedIndex].text + '&amp;mod=$mod'\">
	";
	foreach ( $list_themes as $theme_ )
	{
		echo "\n<option ";
		if ( $_FN['cc_theme'] == $theme_ )
		{
			echo ' selected="selected" ';
		}
		echo ">$theme_</option>";
	}
	echo "
			</select>";
	print_languages();
	echo "</form>";
}
?>