<?php
/**
 * @package flatnux_section_flatforum
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @copyright Copyright (c) 2003-2005
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 * 
 */
if ( strpos(strtolower($_SERVER['SCRIPT_NAME']),strtolower(basename(__FILE__))) )
{
	die("...");
}
global $_FN,$_FNMESSAGE;
$res = array();
$count = 0;
include ("sections/$module/config.php");
$langs = $_FN['listlanguages'];
if ( count($langs) > 1 )
	$multilanguage = true;
else
	$multilanguage = false;
$userlevel = getlevel($_FN['user']);
$count = 0;
foreach ( $langs as $l )
{
	$forumdir = get_section_id($module) . "_$l";
	$tablename = $forumdir . "_posts";
	$db = new XMLDatabase("fndatabase",$_FN['datadir']);
	$query = "SELECT DISTINCT topicid FROM $tablename WHERE ";
	$m = "";
	foreach ( $listfind as $q )
	{
		if ( $q != "" )
		{
			$query .= "$m ( text LIKE '%$q%' OR subject LIKE '%$q%' )";
			$m = $method;
		}
	}
	$posts = $db->Query($query);
	//dprint_r($query);
	$table_forum_topics = new XMLTable("fndatabase",$forumdir . "_topics",$_FN['datadir']);
	if ( is_array($posts) )
	{
		$slang = $l;
		$tablearguments = new XMLTable("fndatabase",$forumdir . "_arguments",$_FN['datadir']);
		foreach ( $posts as $th )
		{
			$topicid = $th['topicid'];
			$topic = $table_forum_topics->GetRecordByPk($topicid);
			if ( $topic['hidden'] == 1 &&  !is_admin() )
				continue;
				//associo il livello del topic a quello dell' argomento
			$argumentvalues = $tablearguments->GetRecordByPk($topic['argument']);
			$topic['level'] = $argumentvalues['level'];
			if ( $topic['level'] == "" )
				$topic['level'] =  -1;
			if ( $topic['level'] == "" )
				$topic['level'] =  -1;
			if ( $topic['level'] > $userlevel )
				continue;
			$st = "";
			if ( $topic['hidden'] == 1 )
				$st = "style=\"text-decoration: line-through;\" ";
			$res[$count] = "";
			$res[$count] .= "<img src=\"" . fromtheme("images/icons/topic.png") . "\" alt=\"topic\">&nbsp;<a $st href=\"index.php?mod=$module&amp;op=readtopic&amp;topic=" . $topic['unirecid'] . "\">" . $topic['subject'] . "</a> (" . date($_FNMESSAGE['datetimeformat'],$topic['time']) . ")";
			;
			if ( $multilanguage )
			{
				$res[$count] .= "&nbsp;<img height=\"10\" border=\"0\" src=\"" . fromtheme("images/flags/$l.png") . "\" />";
			}
			$count++ ;
		}
	}
}
?>