<?php
/**
 * @package flatnux_section_flatforum
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @copyright Copyright (c) 2003-2005
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 * 
 */
if ( strpos(strtolower($_SERVER['SCRIPT_NAME']),strtolower(basename(__FILE__))) )
{
	header("Location: ../../index.php");
	die("...");
}
global $_FN;
global $topicperpage,$postperpage,$allowmodifypost;
//addxmltablefield("fndatabase", "users", $field, "misc");
include ("sections/{$_FN['vmod']}/config.php");
$forumdir = $_FN['idmod'] . "_" . $_FN['lang'];
// creo il gruppo degli amministratori del forum
if (  !file_exists($_FN['datadir'] . "/fndatabase/groups/admin_$forumdir.php") )
{
	$table = new XMLTable("fndatabase","groups",$_FN['datadir']);
	$table->InsertRecord(array("groupname"=>"admin_$forumdir"));
}
if (  !xmltableexists("fndatabase",$forumdir . "_arguments",$_FN['datadir']) )
{
	$fields = array();
	$fields[0]['name'] = "unirecid";
	$fields[0]['extra'] = "autoincrement";
	$fields[0]['frm_show'] = "0";
	$fields[0]['primarykey'] = "1";
	$fields[1]['name'] = "subject";
	$fields[1]['frm_size'] = "60";
	$fields[1]['frm_required'] = "1";
	$fields[2]['name'] = "argumentgroup";
	$fields[2]['frm_required'] = "1";
	$fields[3]['name'] = "level";
	$fields[4]['name'] = "description";
	echo createxmltable("fndatabase",$forumdir . "_arguments",$fields,$_FN['datadir']);
}
if (  !xmltableexists("fndatabase",$forumdir . "_user_topics",$_FN['datadir']) )
{
	$fields = array();
	$fields[0]['name'] = "unirecid";
	$fields[0]['extra'] = "autoincrement";
	$fields[0]['frm_show'] = "0";
	$fields[0]['primarykey'] = "1";
	$fields[1]['name'] = "username";
	$fields[1]['frm_required'] = "1";
	$fields[2]['name'] = "topicid";
	$fields[2]['frm_required'] = "1";
	echo createxmltable("fndatabase",$forumdir . "_user_topics",$fields,$_FN['datadir']);
}
if (  !xmltableexists("fndatabase",$forumdir . "_topics",$_FN['datadir']) )
{
	$fields = array();
	$fields[0]['name'] = "unirecid";
	$fields[0]['primarykey'] = "1";
	$fields[0]['extra'] = "autoincrement";
	$fields[0]['frm_show'] = "0";
	$fields[1]['name'] = "username";
	$fields[1]['frm_show'] = "0";
	$fields[2]['name'] = "subject";
	$fields[2]['frm_it'] = "Titolo";
	$fields[2]['frm_en'] = "Title";
	$fields[2]['frm_es'] = "Title"; //traturre
	$fields[2]['frm_de'] = "Title"; //traturre
	$fields[2]['frm_required'] = "1";
	$fields[2]['frm_size'] = "60";
	$fields[3]['name'] = "argument";
	$fields[3]['frm_it'] = "Argomento";
	$fields[3]['frm_en'] = "Argument";
	$fields[3]['frm_es'] = "Argument"; //traturre
	$fields[3]['frm_de'] = "Argument"; //traturre
	$fields[3]['frm_required'] = "1";
	$fields[3]['foreignkey'] = $forumdir . "_arguments";
	$fields[3]['fk_link_field'] = "unirecid";
	$fields[3]['fk_show_field'] = "subject";
	$fields[3]['frm_setonlyadmin'] = "1";
	/*	$fields[4]['name'] = "status";
	$fields[4]['foreignkey'] = "forum_status";
	$fields[4]['fk_link_field'] = "unirecid";
	$fields[4]['fk_show_field'] = "name";
	$fields[4]['frm_show'] = "0";
	$fields[4]['frm_setonlyadmin'] = "1";*/
	$fields[5]['name'] = "time";
	$fields[5]['frm_show'] = "0";
	$fields[6]['name'] = "level";
	$fields[6]['frm_show'] = "frm_setonlyadmin";
	$fields[7]['name'] = "read";
	$fields[7]['frm_show'] = "0";
	$fields[8]['name'] = "locked";
	$fields[8]['frm_it'] = "Bloccato";
	$fields[8]['frm_en'] = "Locked";
	$fields[8]['frm_es'] = "Locked"; //traturre
	$fields[8]['frm_de'] = "Locked"; //traturre
	$fields[8]['type'] = "check";
	$fields[9]['name'] = "hidden";
	$fields[9]['frm_it'] = "Nascosto";
	$fields[9]['frm_en'] = "Nascosto";
	$fields[9]['frm_es'] = "Hidden"; //traturre
	$fields[9]['frm_de'] = "Hidden"; //traturre
	$fields[9]['type'] = "check";
	$fields[10]['name'] = "position";
	$fields[10]['defaultvalue'] = "100";
	$fields[10]['frm_it'] = "Posizione";
	$fields[10]['frm_show'] = "0";
	$fields[10]['frm_en'] = "Position";
	$fields[10]['frm_es'] = "Position"; //traturre
	$fields[10]['frm_de'] = "Position"; //traturre
	echo createxmltable("fndatabase",$forumdir . "_topics",$fields,$_FN['datadir']);
}
if (  !xmltableexists("fndatabase",$forumdir . "_posts",$_FN['datadir']) )
{
	$fields = array();
	$fields[0]['name'] = "unirecid";
	$fields[0]['primarykey'] = "1";
	$fields[0]['extra'] = "autoincrement";
	$fields[0]['frm_show'] = "0";
	$fields[1]['name'] = "subject";
	$fields[2]['name'] = "text";
	$fields[2]['frm_required'] = "1";
	$fields[2]['type'] = "text";
	$fields[4]['name'] = "parent";
	$fields[4]['frm_show'] = "0";
	$fields[5]['name'] = "time";
	$fields[5]['frm_show'] = "0";
	$fields[6]['name'] = "topicid";
	$fields[6]['foreignkey'] = $forumdir . "_topics";
	$fields[6]['fk_link_field'] = "unirecid";
	$fields[6]['fk_show_field'] = "subject";
	$fields[6]['frm_show'] = "0";
	$fields[7]['name'] = "username";
	$fields[7]['frm_show'] = "0";
	echo createxmltable("fndatabase",$forumdir . "_posts",$fields,$_FN['datadir'],array("indexfield"=>"topicid"));
}
//----------------------------GRAFICA------------------------------------->>>
if (  !function_exists("FN_OpenForumMenu") )
{
	function FN_OpenForumMenu()
	{
	}
}
if (  !function_exists("FN_CloseForumMenu") )
{
	function FN_CloseForumMenu()
	{
	}
}
if (  !function_exists("FN_OpenForum") )
{
	function FN_OpenForum()
	{
	}
}
if (  !function_exists("FN_OpenForumHeader") )
{
	function FN_OpenForumHeader()
	{
		FN_OpenForum();
	}
}
if (  !function_exists("FN_CloseForumHeader") )
{
	function FN_CloseForumHeader()
	{
		FN_CloseForum();
	}
}
if (  !function_exists("FN_CloseForum") )
{
	function FN_CloseForum()
	{
	}
}
if (  !function_exists("FN_OpenPost") )
{
	function FN_OpenPost()
	{
		global $forumborder;
		FN_OpenForum();
	}
}
if (  !function_exists("FN_ClosePost") )
{
	function FN_ClosePost()
	{
		FN_CloseForum();
	}
}
//----------------------------GRAFICA-------------------------------------
function forumheader()
{
	global $_FN;
	global $forumback,$forumborder;
	$forumdir = $_FN['idmod'] . "_" . $_FN['lang'];
	$fbackborder = "";
	$fbackground = "";
	if ( $forumborder != "" )
		$fbackborder = "bgcolor=\"$forumborder\" cellspacing=\"1\"";
	if ( $forumback != "" )
		$fbackground = "bgcolor=\"$forumback\"";
	FN_OpenForumHeader();
	echo "\n<!-- FORUM HEADER    -->" . "\n<table $fbackborder class=\"forum-header-table\"  width=\"100%\">" . "\n	<tbody>";
	//barra di navigazione   ---->
	echo "\n<tr>" . "\n<td  $fbackground class=\"forum-header-navigation\"  colspan=\"5\" >";
	echo "\n<font class=\"forum\">";
	$tmp = str_replace("none_","",$_FN['vmod']);
	$tmp = preg_replace("/^[0-9][0-9]_/si","",$tmp);
	$tmp = getLang("sections/" . $_FN['vmod'] . "/lang.xml",$tmp);
	echo "<a class=\"forum\" href=\"" . fn_rewritelink("index.php?mod={$_FN['idmod']}") . "\">$tmp</a>";
	$table_forum_arguments = new XMLTable("fndatabase",$forumdir . "_arguments",$_FN['datadir']);
	$table_forum_topics = new XMLTable("fndatabase",$forumdir . "_topics",$_FN['datadir']);
	$argumentid = getparam("argument",PAR_GET,SAN_FLAT);
	$topicid = getparam("topic",PAR_GET,SAN_FLAT);
	$subj = "";
	if ( $argumentid == "" )
	{
		if ( $topicid != "" )
		{
			$topic = $table_forum_topics->GetRecordByPk($topicid);
			$argumentid = $topic['argument'];
		}
	}
	if ( $argumentid != "" )
	{
		$argument = $table_forum_arguments->GetRecordByPk($argumentid);
		echo "-><a href=\"" . fn_rewritelink("index.php?mod={$_FN['idmod']}&amp;op=disc&amp;argument=" . $argument['unirecid']) . "\">" . notags($argument['subject']) . "</a>";
	}
	if ( $topicid != "" )
	{
		echo "-><a href=\"" . fn_rewritelink("index.php?mod={$_FN['idmod']}&amp;op=readtopic&amp;topic=" . $topic['unirecid']) . "\">" . notags($topic['subject']) . "</a>";
	}
	echo "\n</font>";
	echo "\n</td>" . "\n	</tr>";
	//barra di navigazione   ----<
	echo "\n	<tr>" . "\n		<td  $fbackground  align=\"center\" colspan=\"5\"  class=\"forum-header-search\" >" . "\n			<form action=\"index.php\" method=\"get\">" . "\n				<input type=\"hidden\" name=\"mod\" value=\"none_Search\" />" . "\n				<input type=\"text\" name=\"find\" size=\"16\" />&nbsp;&nbsp;" . "\n				<select name=\"where\" >";
	$mods = list_sections("sections",false,true);
	foreach ( $mods as $mod1 )
	{
		if ( file_exists("sections/$mod1/search.php") )
		{
			echo "\n";
			$tit = "";
			$albero = explode("/",$mod1);
			for ( $i = 0;$i < sizeof($albero);$i++  )
			{
				$mypath = "";
				for ( $j = 0;$j <= $i;$j++  )
				{
					if ( $i > 0 and ($j != $i) )
					{
						$mypath .= $albero[$j] . "/";
					}
					else
					{
						$mypath .= $albero[$j];
					}
				}
				$tmp = str_replace("none_","",$albero[$i]);
				$tmp = preg_replace("/^[0-9][0-9]_/si","",$tmp);
				$tmp = getLang("sections/$mypath/lang.xml",$tmp);
				if ( $i != (sizeof($albero) - 1) )
				{
					$tit .= str_replace("_","&nbsp;",$tmp) . "/";
				}
				else
				{
					$tit .= str_replace("_","&nbsp;",$tmp);
				}
			}
			echo "<option  value=\"$mod1\"";
			if ( $mod1 == sectionlocation($_FN['mod']) )
				echo "selected=\"selected\"";
			echo " >$tit</option>";
		}
	}
	echo "	</select>&nbsp;&nbsp;" . "<input type=\"submit\" class=\"submit\" value=" . _CERCA . " />" . "		</form>" . "	</td>" . "</tr>" . "<tr>" . "	<td $fbackground class=\"forum-header-wellcome\">" . "		<font class=\"forum\">" . _BENVE;
	if ( $_FN['user'] == "" )
	{
		echo " <b>" . _SCON . "</b>";
	}
	else
	{
		echo " <b>{$_FN['user']}</b>";
	}
	echo "</font>
</td>
";
	if ( $_FN['user'] == "" )
	{
		echo "\n<td $fbackground class=\"forum-header-edit-profile\"  width=\"90\" align=\"center\" >" . "\n	<font class=\"forum\">" . "\n		<a class=\"forum\" href=\"" . fn_rewritelink("?mod=login&amp;op=vis_reg") . "\">" . _REGORA . "</a>" . "\n	</font>" . "\n</td>" . "\n<td $fbackground class=\"forum-header-enter\"   width=\"90\" align=\"center\" >" . "\n	<font class=\"forum\" >" . "\n		<a class=\"forum\" href=\"" . fn_rewritelink("?mod=login&amp;op=vis_login&amp;from=index.php?mod={$_FN['idmod']}") . "\">" . _LOGIN . "</a>" . "\n	</font>" . "\n</td>";
	}
	else
	{
		echo "<td $fbackground class=\"forum-header-edit-profile\"  width=\"90\" align=\"center\" >" . "\n<font class=\"forum\" >" . "\n	<a class=\"forum\" href=\"" . fn_rewritelink("?mod=login&amp;op=profile&amp;user={$_FN['user']}") . "\">" . _FMODPROF . "</a>" . "\n</font>" . "\n</td>" . "\n<td $fbackground class=\"forum-header-edit-profile\"   width=\"90\" align=\"center\" >" . "\n	<font class=\"forum\" >" . "\n		<a class=\"forum\" href=\"" . fn_rewritelink("?mod=login&amp;op=logout") . "\">" . _LOGOUT . "</a>" . "\n	</font>" . "\n</td>";
	}
	$i = count_users();
	echo "<td $fbackground class=\"forum-header-help\"  width=\"90\" align=\"center\">
<font class=\"forum\">
<a  class=\"forum\" href=\"" . fn_rewritelink("?mod=" . $_FN['idmod'] . "&amp;op=help") . "\" >" . _FGUIDA . "</a>
</font>
</td>
											";
	echo "<td $fbackground class=\"forum-header-members\"  width=\"150\" align=\"center\">
<font class=\"forum\">
<a class=\"forum\" href=\"" . fn_rewritelink("?mod=login&amp;op=members") . "\"><b>$i</b> " . _FUTENTI . "</a>
</font>
</td>
";
	echo "</tr>
</tbody>
</table><br />
<!-- CHIUSURA HEADER-->";
	FN_CloseForumHeader();
}
//----------------------------GRAFICA-------------------------------------<<?php
$opmod = getparam("op",PAR_GET,SAN_FLAT);
switch ($opmod)
{
	case "readtopic" :
		forumheader();
		readtopic();
	break;
	case "help" :
		forumheader();
		include ("sections/{$_FN['vmod']}/help.{$_FN['lang']}.php");
		$tit = _INDIETRO;
		echo "<br /><a accesskey=\"" . getaccesskey($tit,"javascript:history.back()") . "\" href=\"javascript:history.back()\">&lt;&lt;$tit</a>";
	break;
	case "newtopic" :
		forumheader();
		newtopic();
	break;
	case "editpost" :
		forumheader();
		editpost();
	break;
	case "delpost" :
		forumheader();
		delpost();
	break;
	case "newdisc" :
		forumheader();
		newdisc();
	break;
	case "regtopic" :
		forumheader();
		regtopic();
	break;
	case "regdisc" :
		forumheader();
		regdisc();
	break;
	case "disc" :
		forumheader();
		mainargument();
	break;
	case "" :
		forumheader();
		main();
	break;
}
/**
 * delete post
 */
function delpost()
{
	if (  !isforumadmin() )
		return;
	global $_FN;
	global $forumback,$forumborder;
	$forumdir = $_FN['idmod'] . "_" . $_FN['lang'];
	$fbackborder = "";
	$fbackground = "";
	if ( $forumborder != "" )
		$fbackborder = "bgcolor=\"$forumborder\" cellspacing=\"1\"";
	if ( $forumback != "" )
		$fbackground = "bgcolor=\"$forumback\"";
	$post = getparam("post",PAR_GET,SAN_FLAT);
	$table_forum_posts = new XMLTable("fndatabase",$forumdir . "_posts",$_FN['datadir']);
	$table_forum_posts->DelRecord($post);
	//	FN_OpenForum();
	echo _FILEDELETED;
	jsalert(_FILEDELETED);
	jsredirect("?mod={$_FN['idmod']}");
	//	FN_CloseForum();
}
/**
 * 
 */
function GetArgGroups()
{
	global $_FN;
	$forumdir = $_FN['idmod'] . "_" . $_FN['lang'];
	$list = array();
	$table_forum_arguments = new FieldForm("fndatabase",$forumdir . "_arguments",$_FN['datadir'],$_FN['lang']);
	$list_forum_arguments = $table_forum_arguments->xmltable->GetRecords(false,false,false,"argumentgroup");
	$oldargumentgroup = "";
	foreach ( $list_forum_arguments as $forum_arguments )
	{
		if ( $oldargumentgroup != $forum_arguments['argumentgroup'] )
		{
			$list[] = $forum_arguments['argumentgroup'];
		}
	}
	return $list;
}
/**
 * main
 * schermata principale
 */
function main()
{
	global $_FN;
	$topicsthreads = array();
	global $topicperpage,$postperpage,$giorni,$mesi;
	global $forumtitle;
	global $forumback,$forumborder;
	$forumdir = $_FN['idmod'] . "_" . $_FN['lang'];
	$fbackborder = "";
	$fbackground = "";
	if ( $forumborder != "" )
		$fbackborder = "bgcolor=\"$forumborder\" cellspacing=\"1\"";
	if ( $forumback != "" )
		$fbackground = "bgcolor=\"$forumback\"";
	FN_OpenForum();
	echo "<table $fbackborder width=\"100%\"  class=\"forum-group-table\"  >" . "<tbody>";
	if ( isforumadmin() )
	{
		echo "<tr >" . "	<td $fbackground colspan=\"6\" align=\"center\"  >" . "		<font class=\"forum\"><a href=\"" . fn_rewritelink("?mod={$_FN['idmod']}&amp;op=newdisc&amp;mode=nuovo") . "\">" . _FNEWARG . "</a></font>" . "	</td>" . "</tr>";
	}
	$table_forum_arguments = new FieldForm("fndatabase",$forumdir . "_arguments",$_FN['datadir'],$_FN['lang']);
	$table_forum_topics = new XMLTable("fndatabase",$forumdir . "_topics",$_FN['datadir']);
	$table_forum_threads = new XMLTable("fndatabase",$forumdir . "_posts",$_FN['datadir']);
	$list_forum_arguments = $table_forum_arguments->xmltable->GetRecords(false,false,false,"argumentgroup");
	if ( file_exists("themes/{$_FN['theme']}/images/forum.png") )
		$image = "themes/{$_FN['theme']}/images/forum.png";
	else
		$image = fromtheme("images/subsection.png");
	$oldargumentgroup = "";
	//-------------leggo tutti i messaggi e li raggruppo per topic
	$threads = $table_forum_threads->GetRecords(false,false,false,"topicid",false,"topicid|time|username");
	foreach ( $threads as $th )
	{
		$topicsthreads[$th['topicid']][] = $th;
	}
	//-------------leggo tutti i topics e li raggruppo per argomento
	$topics = $table_forum_topics->GetRecords(false,false,false,"argument",false,"argument|unirecid|username");
	$userlevel = getlevel($_FN['user']);
	$arguments_topics = array();
	foreach ( $topics as $th )
	{
		$arguments_topics[$th['argument']][] = $th;
	}
	if ( count($list_forum_arguments) == 0 )
	{
		if ( is_admin() )
		{
			if ( find_section("forum") != "" )
				echo "<b><a href=\"" . fn_rewritelink("index.php?mod={$_FN['idmod']}&amp;importa") . "\">>>>>>Import old forum</a></b>";
		}
		if ( is_admin() && isset($_GET['importa']) )
		{
			$topicslocation = "alltopics";
			if ( find_section("forum") != "" )
				include ("sections/" . find_section("forum") . "/config.php");
			echo "<br />topicslocation=$topicslocation<br />";
			ImportaVecchioForum($topicslocation);
		}
	}
	foreach ( $list_forum_arguments as $forum_arguments )
	{
		if ( $forum_arguments['level'] == "" )
			$forum_arguments['level'] =  -1;
		if ( $forum_arguments['level'] > $userlevel )
			continue;
		if ( $oldargumentgroup != $forum_arguments['argumentgroup'] )
		{
			$oldargumentgroup = $forum_arguments['argumentgroup'];
			echo "<tr ><td $fbackground class=\"forum-group-header\"   colspan=\"6\"  >" . $forum_arguments['argumentgroup'] . ":</td>";
			//-------------titoli------------>
			echo "<tr class=\"forum-group-title\" $fbackground >" . "<td class=\"forum-group-icon-header\" $fbackground ></td>" . "<td class=\"forum-group-arg-header\"  $fbackground>" . _ARGOMENTO . "</td>" . "<td class=\"forum-group-topics-header\"  >" . _FDISCS . "</td>" . "<td class=\"forum-group-msg-header\"  $fbackground>" . _FNMESS . "</td>" . "<td class=\"forum-group-latest-msg-header\" $fbackground>" . _FULTPOST . "</td>";
			if ( isforumadmin() )
			{
				echo "<td $fbackground class=\"forum-group-latest-msg-header\"  >&nbsp;</td>";
			}
			echo "</tr>";
			//-------------titoli------------<
		}
		echo "\n<tr>";
		$topics = isset($arguments_topics[$forum_arguments['unirecid']]) ? $arguments_topics[$forum_arguments['unirecid']] : array();
		$ndisc = count($topics);
		$nmessages = 0;
		$lasthread = false;
		foreach ( $topics as $topic )
		{
			if ( isset($topicsthreads[$topic['unirecid']]) )
			{
				$threads = $topicsthreads[$topic['unirecid']];
				$c = count($threads);
				$nmessages += $c;
				if ( $c > 0 )
				{
					if (  !isset($lasthread['time']) || $lasthread['time'] < $threads[$c - 1]['time'] )
						$lasthread = $threads[$c - 1];
				}
			}
		}
		echo "\n<td class=\"forum-group-icon\" $fbackground ><img src=\"$image\" alt=\"\"/></td>";
		echo "\n<td class=\"forum-group-arg\" $fbackground  ><font class=\"forum\" ><a href=\"" . fn_rewritelink("index.php?mod={$_FN['idmod']}&amp;op=disc&amp;argument=" . $forum_arguments['unirecid']) . "\">" . notags($forum_arguments['subject']) . "</a></font>";
		echo "<br /><em>" . $forum_arguments['description'] . "</em></td>";
		echo "\n<td class=\"forum-group-topics\" $fbackground >$ndisc</td>";
		echo "\n<td class=\"forum-group-msg\" $fbackground >$nmessages</td>";
		if ( isset($lasthread['username']) )
			echo "\n<td class=\"forum-group-latest-msg\" $fbackground ><a href=\"" . fn_rewritelink("?mod={$_FN['idmod']}&amp;op=readtopic&amp;last&amp;topic=" . $lasthread['topicid']) . "\">" . $lasthread['username'] . ":&nbsp;" . GetPostTime($lasthread['time']) . "</a></td>";
		else
			echo "\n<td class=\"forum-group-latest-msg\" $fbackground >-</td>";
		if ( isforumadmin() )
		{
			echo "\n<td  class=\"forum-group-latest-msg\" $fbackground >";
			echo "<a href=\"" . fn_rewritelink("?mod={$_FN['idmod']}&amp;op=newdisc&amp;mode=modify&amp;id=" . $forum_arguments['unirecid']) . "\" >" . _MODIFICA . "</a>";
			echo "&nbsp;<a href=\"javascript:check('" . fn_rewritelink("?mod={$_FN['idmod']}&op=newdisc&mode=delete&id=" . $forum_arguments['unirecid']) . "');\" >" . _ELIMINA . "</a>";
			echo "</td>";
		}
		echo "\n</tr>";
	}
	if (  !is_array($list_forum_arguments) || count($list_forum_arguments) == 0 )
	{
		echo "<tr><td class=\"forum-group-latest-msg\" $fbackground></td></tr>";
	}
	echo "</tbody>" . "</table>";
	FN_CloseForum();
}

function natsort2d(& $aryInput)
{
	$aryTemp = $aryOut = array();
	foreach ( $aryInput as $key=>$value )
	{
		reset($value);
		$aryTemp[$key] = current($value);
	}
	//fn_natsort($aryTemp);
	natsort($aryTemp);
	foreach ( $aryTemp as $key=>$value )
	{
		//if (isset($aryInput[$key]))
		$aryOut[$key] = $aryInput[$key];
		// --------^^^^ add this if you want your keys preserved!
	}
	$aryInput = $aryOut;
}
/**
 * 
 */
function mainargument()
{
	global $_FN;
	global $topicperpage,$postperpage,$giorni,$mesi;
	global $forumborder,$forumtitle;
	global $forumback;
	$forumdir = $_FN['idmod'] . "_" . $_FN['lang'];
	if ( $forumborder != "" )
		$fbackborder = "bgcolor=\"$forumborder\" cellspacing=\"1\"";
	if ( $forumback != "" )
		$fbackground = "bgcolor=\"$forumback\"";
	$argumentid = getparam("argument",PAR_GET,SAN_FLAT);
	$page = getparam("page",PAR_GET,SAN_FLAT);
	if ( $page == "" )
		$page = 1;
	$starttopic = ($page * $topicperpage) - $topicperpage + 1;
	FN_OpenForum();
	$table_forum_topics = new XMLTable("fndatabase",$forumdir . "_topics",$_FN['datadir'],$_FN['lang']);
	$table_forum_threads = new XMLTable("fndatabase",$forumdir . "_posts",$_FN['datadir']);
	$table_forum_arguments = new FieldForm("fndatabase",$forumdir . "_arguments",$_FN['datadir'],$_FN['lang']);
	$argument = $table_forum_arguments->xmltable->GetRecordByPk($argumentid);
	$userlevel = getlevel($_FN['user']);
	if ( $argument['level'] == "" )
		$argument['level'] =  -1;
	if ( $argument['level'] > $userlevel )
		return;
	$alltopics = $table_forum_topics->GetRecords(false,false,false,false,false,"argument|unirecid");
	$topicsthreads = array();
	foreach ( $alltopics as $ct )
	{
		if ( $ct['argument'] == $argument['unirecid'] )
			$topicsthreads[$ct['unirecid']] = array();
	}
	//-------------leggo tutti i messaggi e li raggruppo per topic
	$threads = $table_forum_threads->GetRecords(false,false,false,"unirecid",false,"unirecid|topicid|time|username");
	foreach ( $threads as $th )
	{
		if ( isset($topicsthreads[$th['topicid']]) )
		{
			$topicsthreads[$th['topicid']]['last'] = $th['unirecid'];
			$topicsthreads[$th['topicid']][] = $th;
		}
	}
	//dprint_r();
	natsort2d($topicsthreads);
	$topicsthreads = array_reverse($topicsthreads,true);
	$num_topics = count($topicsthreads);
	echo "<table $fbackborder class=\"forum\"   width=\"100%\" >";
	echo "<tbody>";
	if ( isforumadmin() )
	{
		$newlevel = getparam("level",PAR_POST,SAN_FLAT);
		if ( $newlevel != "" )
		{
			$argument = $table_forum_arguments->xmltable->UpdateRecord(array("unirecid"=>$argumentid,"level"=>$newlevel));
		}
		//cambio permessi dell' argomento
		$level = $argument['level'];
		print("<tr  ><td $fbackground colspan=\"7\"><form action='" . fn_rewritelink("?mod={$_FN['idmod']}&amp;op=disc&argument=$argumentid") . "' method='post'>");
		print("<b>" . _LEVEL . "</b>:");
		print("<select name='level'>");
		print("<option value='-1'>---</option>");
		for ( $i = 0;$i < 11;$i++  )
		{
			if ( $level == $i )
				print("<option value='$i' selected=\"selected\" >$i</option>");
			else
				print("<option value='$i' >$i</option>");
		}
		print("</select>");
		print("&nbsp;<input type='submit' class=\"submit\" value='OK' />");
		print("</form></td></tr>");
	}
	//stampa le pagine ------------->
	echo "<tr>";
	echo "<td $fbackground colspan=\"7\" class=\"forum-arg-firstpost\" align=\"center\" >";
	$numPagesTopic = ceil($num_topics / $topicperpage);
	echo fn_i18n("_FNPAG") . ": ";
	for ( $i = 1;$i <= $numPagesTopic;$i++  )
	{
		if ( $i == $page )
			echo "&nbsp;<b><a href=\"" . fn_rewritelink("?mod={$_FN['idmod']}&amp;op=disc&amp;argument=" . $argumentid . "&amp;page=$i") . "\">$i</b></a>";
		else
			echo "&nbsp;<a href=\"" . fn_rewritelink("?mod={$_FN['idmod']}&amp;op=disc&amp;argument=" . $argumentid . "&amp;page=$i") . "\">$i</a>";
	}
	echo "</td>";
	echo "</tr>";
	//stampa le pagine -------------<?php
	echo "<tr  class=\"forumtitle\" >";
	if ( $_FN['user'] != "" )
	{
		echo "<td  $fbackground colspan=\"7\" align=\"center\" width=\"100%\">";
		echo "<button class=\"button\" onclick=\"window.location='" . fn_rewritelink("?mod={$_FN['idmod']}&argument=$argumentid&op=newtopic&mode=nuovo") . "';\">" . _FNUOVOTOP . "</a></button>";
		echo "</td>" . "</tr>" . "<tr>";
	}
	echo "<td $fbackground class=\"forum-arg-icon-header\"  align=\"center\" >&nbsp;</td>" . "	<td $fbackground class=\"forum-arg-mess-header\" >" . _FTITTOP . "</td>" . "   <td $fbackground class=\"forum-arg-pages-header\"  align=\"center\" width=\"100\">" . _FNPAG . "</td>" . "	<td $fbackground class=\"forum-arg-msg-count-header\"  align=\"center\" >" . _FNMESS . "</td>" . "	<td $fbackground class=\"forum-arg-visits-header\"  align=\"center\" >" . _FLETTO . "</td>" . "	<td $fbackground class=\"forum-arg-firstpost-header\"  align=\"center\" >" . _FINIPOST . "</td>" . "	<td $fbackground class=\"forum-arg-lastpost-header\"  align=\"center\" >" . _FULTPOST . "</td>" . "</tr>";
	$start = ($page * $topicperpage - $topicperpage) + 1;
	$end = $start + $topicperpage - 1;
	$contatopic = 1;
	foreach ( $topicsthreads as $unirecid=>$messages )
	{
		unset($messages['last']);
		if ( $contatopic < $start )
		{
			$contatopic++ ;
			continue;
		}
		if ( $contatopic >= $end )
		{
			break;
		}
		$contatopic++ ;
		$topic = $table_forum_topics->GetRecordByPk($unirecid);
		$num_message = count($messages);
		//se ho eliminato tutti i posts
		if ( $num_message == 0 )
			continue;
		$last = array();
		if ( $num_message > 0 )
			$last = $messages[$num_message - 1];
			/*
		dprint_r ("last=$num_message");
		dprint_r ($messages);
		dprint_r ($last);
		*/
		$image = fromtheme("images/icons/topic.png");
		if ( $topic['locked'] == 1 )
		{
			$image = fromtheme("images/icons/lock.png");
		}
		$st = "";
		if ( $topic['hidden'] == 1 )
		{
			if ( isforumadmin() )
				$st = "style=\"text-decoration: line-through;\" ";
			else
				continue;
		}
		echo "<tr>";
		echo "<td $fbackground class=\"forum-arg-icon\" >";
		echo "<img src=\"$image\" alt=\"topic\" />";
		echo "</td>";
		echo "<td $fbackground class=\"forum-arg-mess\" >";
		echo "<a $st href=\"" . fn_rewritelink("?mod={$_FN['idmod']}&amp;op=readtopic&amp;topic=" . $topic['unirecid']) . "\">" . htmlentities($topic['subject']) . "</a>";
		echo "</td>";
		echo "<td $fbackground class=\"forum-arg-pages\"  align=\"center\" >";
		$numPages = ceil($num_message / $postperpage);
		for ( $i = 1;$i <= $numPages;$i++  )
		{
			echo "&nbsp;<a href=\"" . fn_rewritelink("?mod={$_FN['idmod']}&amp;op=readtopic&amp;topic=" . $topic['unirecid'] . "&amp;page=$i") . "\">[$i]</a>";
		}
		echo "</td>";
		echo "<td $fbackground class=\"forum-arg-msg-count\" align=\"center\" >";
		echo "" . $num_message . "";
		echo "</td>";
		echo "<td $fbackground class=\"forum-arg-visits\" align=\"center\" class=\"forum-arg-firstpost\" >";
		echo "" . $topic['read'] . "";
		echo "</td>";
		echo "<td $fbackground class=\"forum-arg-firstpost\" align=\"center\" >";
		echo "<a href=\"" . fn_rewritelink("?mod={$_FN['idmod']}&amp;op=readtopic&amp;topic=" . $topic['unirecid']) . "\">" . $topic['username'] . "<br />" . GetPostTime($topic['time']) . "</a>";
		echo "</td>";
		echo "<td $fbackground class=\"forum-arg-lastpost\" align=\"center\">";
		echo "<a href=\"" . fn_rewritelink("?mod={$_FN['idmod']}&amp;op=readtopic&amp;topic=" . $topic['unirecid'] . "&amp;page=$numPages") . "\">" . $last['username'] . "<br />" . GetPostTime($last['time']) . "</a>";
		echo "</td>";
		echo "</tr>";
	}
	echo "</tr>";
	//stampa le pagine ------------->
	echo "<tr>";
	echo "<td $fbackground colspan=\"7\" class=\"forum-arg-firstpost\" align=\"center\" >";
	$numPagesTopic = ceil($num_topics / $topicperpage);
	echo fn_i18n("_FNPAG") . ": ";
	for ( $i = 1;$i <= $numPagesTopic;$i++  )
	{
		if ( $i == $page )
			echo "&nbsp;<b><a href=\"" . fn_rewritelink("?mod={$_FN['idmod']}&amp;op=disc&amp;argument=" . $argumentid . "&amp;page=$i") . "\">$i</b></a>";
		else
			echo "&nbsp;<a href=\"" . fn_rewritelink("?mod={$_FN['idmod']}&amp;op=disc&amp;argument=" . $argumentid . "&amp;page=$i") . "\">$i</a>";
	}
	echo "</td>";
	echo "</tr>";
	//stampa le pagine -------------<?php
	echo "</tbody>" . "</table>";
	FN_CloseForum();
}
/**
 * 
 * @param $postime
 */
function GetPostTime($postime)
{
	$ret = "";
	global $_FN;
	global $giorni,$mesi;
	$ret .= $giorni[date("w",$postime + (3600 * $_FN['jet_lag']))];
	$ret .= date(" d ",$postime + (3600 * $_FN['jet_lag']));
	$tmp = date(" m",$postime + (3600 * $_FN['jet_lag']));
	if ( $tmp < 10 )
		$tmp = str_replace("0","",$tmp);
	$ret .= $mesi[$tmp - 1];
	$ret .= date(" Y - ",$postime + (3600 * $_FN['jet_lag']));
	$ret .= date("H:",$postime + (3600 * $_FN['jet_lag']));
	$ret .= date("i",$postime + (3600 * $_FN['jet_lag']));
	return $ret;
}
/**
 * 
 */
function newdisc()
{
	global $_FN;
	global $forumback,$forumborder;
	$forumdir = $_FN['idmod'] . "_" . $_FN['lang'];
	$fbackborder = "";
	$fbackground = "";
	if ( $forumborder != "" )
		$fbackborder = "bgcolor=\"$forumborder\" cellspacing=\"1\"";
	if ( $forumback != "" )
		$fbackground = "bgcolor=\"$forumback\"";
	if ( isforumadmin() )
	{
		$id = getparam("id",PAR_GET,SAN_FLAT);
		$mode = getparam("mode",PAR_GET,SAN_FLAT);
		$table_forum_arguments = new FieldForm("fndatabase",$forumdir . "_arguments",$_FN['datadir'],$_FN['lang']);
		if ( $mode == "delete" )
		{
			$table_forum_arguments->xmltable->DelRecord($id);
			jsredirect(fn_rewritelink("?mod={$_FN['idmod']}"));
			return;
		}
		if ( $id != "" )
			$oldvalues = $table_forum_arguments->xmltable->GetRecordByPk($id);
		else
			$oldvalues = array("subject"=>"","level"=>"-1","argumentgroup"=>"","description"=>"","title"=>"","unirecid"=>"");
		echo "<form action=\"" . fn_rewritelink("?mod={$_FN['idmod']}&amp;op=regdisc") . "\" method=\"post\" name=\"newdisc\">";
		FN_OpenForum();
		echo "<table $fbackborder class=\"forum\" border=\"0\"  width=\"100%\">
																						<tbody>";
		echo "	<tr>
										<td   $fbackground colspan=\"2\" align=\"center\" >";
		if ( $id != "" )
			echo "<b>" . _MODIFICA . "</b><br /> ";
		else
			echo "<b>" . _FNEWARG . "</b><br /> ";
		echo _FCAMPI . "</b>
										</td>
									</tr>";
		echo "<tr>";
		echo "<td $fbackground >";
		echo "<font class=\"forum\">";
		echo ("<b>" . _LEVEL . "</b>:");
		echo "</font>";
		echo "</td>";
		echo "<td $fbackground >";
		echo ("<select name='level'>");
		echo ("<option value='-1'>---</option>");
		for ( $i = 0;$i < 11;$i++  )
		{
			if ( $oldvalues['level'] == $i )
				$s = "selected=\"selected\"";
			else
				$s = "";
			print("<option $s value='$i' >$i</option>");
		}
		print("</select>");
		echo "</td>";
		echo "</tr>";
		//gruppo
		echo "<tr>";
		echo "<td $fbackground >";
		echo "<font class=\"forum\">";
		echo ("<b>" . _FGRUPPO . "</b>:");
		echo "</font>";
		echo "</td>";
		echo "<td $fbackground >";
		echo "<input name='argumentgroup' value=\"" . $oldvalues['argumentgroup'] . "\" />";
		$list = GetArgGroups();
		echo "<select  name=\"ssubj\"  onchange=\"document.newdisc.argumentgroup.value = document.newdisc.ssubj.options[document.newdisc.ssubj.selectedIndex].text\">";
		echo "<option value=\"\"></option>";
		$list = array_unique($list);
		foreach ( $list as $ar )
		{
			$s = isset($s) ? $s : $ar;
			echo "<option value=\"$ar\">$ar</option>";
		}
		echo "</select";
		echo "</td>";
		echo "</tr>";
		//soggetto
		echo "<tr>";
		echo "<td $fbackground >";
		echo "<font class=\"forum\">";
		echo ("<b>" . _TITLE . "</b>:");
		echo "</font>";
		echo "</td>";
		echo "<td $fbackground>";
		echo "<input  size=\"50\" name='subject' value=\"" . notags($oldvalues['subject']) . "\" />";
		echo "</td>";
		echo "</tr>";
		//descrizione
		echo "<tr>";
		echo "<td $fbackground >";
		echo "<font class=\"forum\">";
		echo ("<b>" . _FDESCR . "</b>:");
		echo "</font>";
		echo "</td>";
		echo "<td $fbackground >";
		echo "<input size=\"50\" name='description' value=\"" . notags($oldvalues['description']) . "\"  />";
		echo "<input type=\"hidden\" name='unirecid' value=\"" . $oldvalues['unirecid'] . "\"  />";
		echo "</td>";
		echo "</tr>";
		echo "<tr>
<td  $fbackground colspan=\"2\" >
	<input type=\"submit\" class=\"submit\" value=\"" . _SAVE . "\" />
	</td>
</tr>";
		echo "</tbody></table>";
		FN_CloseForum();
		echo "</form>";
	}
}
/**
 * remove tags from string
 * @param $str
 */
function notags($str)
{
	$str = str_replace("<","&lt;",$str);
	$str = str_replace(">","&gt;",$str);
	$str = str_replace("\"","&quot;",$str);
	return $str;
}
/**
 * 
 */
function regdisc()
{
	global $_FN;
	$forumdir = $_FN['idmod'] . "_" . $_FN['lang'];
	if ( isforumadmin() )
	{
		FN_OpenForum();
		echo "<table   width=\"100%\">" . "	<tbody>" . "<tr>" . "<td  colspan=\"5\" width=\"100%\" >" . "<font class=\"forum\">";
		$table_forum_arguments = new FieldForm("fndatabase",$forumdir . "_arguments",$_FN['datadir'],$_FN['lang']);
		$id = getparam("unirecid",PAR_POST,SAN_FLAT);
		$toupdate = false;
		if ( $id != "" )
		{
			$toupdate = true;
		}
		$newvalues = $table_forum_arguments->getbypost();
		$err = $table_forum_arguments->Verify($newvalues,$toupdate);
		if ( $err == "" )
		{
			$addr = getparam("REMOTE_ADDR",PAR_SERVER,SAN_FLAT);
			if ( $toupdate )
			{
				$UserValues = $table_forum_arguments->xmltable->UpdateRecord($newvalues);
				FN_log("Update argument $id : {$newvalues['subject']}.");
				echo fn_i18n("The_data_were_successfully_updated");
			}
			else
			{
				$UserValues = $table_forum_arguments->xmltable->InsertRecord($newvalues);
				FN_log("user create new argument : {$newvalues['subject']} .");
				echo fn_i18n("_FTOPOK");
			}
			echo "<br />\n<br />\n";
			echo "<a class=\"forum\" href=\"" . fn_rewritelink("index.php?mod=" . $_FN['idmod']) . "\">&nbsp;" . _FLEGGI . "&gt;&gt;</a>";
		}
		else
		{
			echo _FERRCAMPO . " :<br /><br />
																																	$err<br />";
			$tit = _INDIETRO;
			echo "<a accesskey=\"" . getaccesskey($tit,"javascript:history.back()") . "\" href=\"javascript:history.back()\">&lt;&lt;$tit</a>";
		}
		echo "	</font>" . "</td>" . "</tr>" . "</tbody>" . "</table>";
		FN_CloseForum();
	}
}
/**
 * newtopic
 * Visualizza il form per l' inserimento di un post
 */
function newtopic()
{
	global $_FN;
	global $forumback,$forumborder;
	$forumdir = $_FN['idmod'] . "_" . $_FN['lang'];
	$fbackborder = "";
	$fbackground = "";
	if ( $forumborder != "" )
		$fbackborder = "bgcolor=\"$forumborder\" cellspacing=\"1\"";
	if ( $forumback != "" )
		$fbackground = "bgcolor=\"$forumback\"";
	$mode = getparam("mode",PAR_GET,SAN_FLAT);
	$argument = getparam("argument",PAR_GET,SAN_FLAT);
	$parent = getparam("parent",PAR_GET,SAN_FLAT);
	$topicid = getparam("topic",PAR_GET,SAN_FLAT);
	$oldtitle = "";
	$oldtext = "";
	if ( $parent != "" )
	{
		$table_forum_posts = new XMLTable("fndatabase",$forumdir . "_posts",$_FN['datadir']);
		$oldpost = $table_forum_posts->GetRecordByPk($parent);
		if ( isset($oldpost['subject']) )
		{
			$table_forum_topics = new XMLTable("fndatabase",$forumdir . "_topics",$_FN['datadir']);
			$oldtopic = $table_forum_topics->GetRecordByPk($oldpost['topicid']);
			$oldtitle = "Re: " . $oldtopic['subject'];
		}
		if ( isset($oldpost['text']) )
		{
			$oldtext = "[quote]" . $oldpost['text'] . "[/quote]\n";
		}
	}
	else
	{
		if ( $topicid != "" )
		{
			$table_forum_topics = new XMLTable("fndatabase",$forumdir . "_topics",$_FN['datadir']);
			$oldpost = $table_forum_topics->GetRecordByPk($topicid);
			$oldtitle = "Re: " . $oldpost['subject'];
		}
	}
	FN_OpenForum();
	echo "<form method=\"post\" action=\"" . fn_rewritelink("index.php?mod={$_FN['idmod']}&amp;op=regtopic") . "\">";
	echo "<table  $fbackborder width=\"100%\">" . "	<tbody>" . "		<tr>" . "			<td $fbackground  colspan=\"2\" width=\"100%\" >" . "				<font class=\"forum\"><b>";
	if ( $mode == "nuovo" )
	{
		echo _FNUOVOTOP;
	}
	else
	{
		echo _FNUOVOMESS;
	}
	echo "</b></font>" . "</td>" . "</tr>";
	echo "<tr>" . "<td $fbackground colspan=\"2\" align=\"center\"  >";
	FN_OpenForumMenu();
	bbcodes_js();
	bbcodes_panel("text","formatting");
	echo "<br />\n";
	bbcodes_panel("text","emoticons");
	echo "<br />\n";
	FN_CloseForumMenu();
	echo "</td>" . "</tr>" . "<tr>" . "<td $fbackground >" . "<font class=\"forum\" >" . "<input type=\"hidden\" name=\"op\" value=\"regtopic\" />" . "	<input type=\"hidden\" name=\"argument\" value=\"$argument\" />" . "<input type=\"hidden\" name=\"parent\" value=\"$parent\" />" . "<input type=\"hidden\" name=\"topicid\" value=\"$topicid\" />" . "<input type=\"hidden\" name=\"mode\" value=\"$mode\" />" . _FOGG . ":" . "</font>" . "</td>";
	echo "<td $fbackground >" . "<input name=\"subject\"  value=\"$oldtitle\" size=\"63\" />" . "</td>" . "</tr>" . "<tr>" . "	<td $fbackground valign=\"top\">" . "	<font class=\"forum\">" . _FMESS . ": </font>" . "	</td>" . "	<td $fbackground >" . "		<textarea name=\"text\" rows=\"20\" cols=\"60\">$oldtext</textarea>" . "	</td>" . "</tr>" . "<tr>" . "	<td $fbackground colspan=\"2\" align=\"center\">" . "<input type=\"submit\" class=\"submit\" value=\"" . _FINVIA . "\" />" . "	</td>" . "</tr>" . "</tbody>" . "</table>" . "</form>";
	FN_CloseForum();
	if ( $topicid != "" )
		readtopic($topicid,true);
}
/**
 * editpost
 * Visualizza il form per la modifica il contenuto di un post
 */
function editpost()
{
	global $_FN;
	global $forumback,$forumborder,$allowmodifypost;
	$forumdir = $_FN['idmod'] . "_" . $_FN['lang'];
	$fbackborder = "";
	$fbackground = "";
	if ( $forumborder != "" )
		$fbackborder = "bgcolor=\"$forumborder\" cellspacing=\"1\"";
	if ( $forumback != "" )
		$fbackground = "bgcolor=\"$forumback\"";
	$post = getparam("post",PAR_GET,SAN_FLAT);
	$table_forum_posts = new XMLTable("fndatabase",$forumdir . "_posts",$_FN['datadir']);
	$oldpost = $table_forum_posts->GetRecordByPk($post);
	if ( $allowmodifypost == 0 || $_FN['user'] != $oldpost['username'] )
		if (  !isforumadmin() )
			return;
	FN_OpenForum();
	echo "<form method=\"post\" action=\"" . fn_rewritelink("index.php?mod={$_FN['idmod']}&amp;op=regtopic&amp;mode=edit") . "\">";
	echo "<table  $fbackborder width=\"100%\">" . "	<tbody>" . "		<tr>" . "			<td $fbackground  colspan=\"2\" width=\"100%\" >" . "				<font class=\"forum\"><b>";
	echo _MODIFICA . ":";
	echo "</b></font>" . "			</td>" . "		</tr>";
	echo "<tr>" . "<td $fbackground colspan=\"2\" align=\"center\"  >";
	FN_OpenForumMenu();
	bbcodes_js();
	bbcodes_panel("text","formatting");
	echo "<br />";
	bbcodes_panel("text","emoticons");
	echo "<br />";
	FN_CloseForumMenu();
	echo "</td>" . "	</tr>" . "<tr>" . "	<td $fbackground >" . "		<font class=\"forum\" >" . "			<input type=\"hidden\" name=\"op\" value=\"regtopic\" />" . "			<input type=\"hidden\" name=\"unirecid\" value=\"$post\" />" . _FOGG . ":" . "		</font>" . "	</td>";
	echo "<td $fbackground >" . "<input name=\"subject\"  value=\"" . notags($oldpost['subject']) . "\" size=\"63\" />" . "</td>" . "</tr>" . "<tr>" . "	<td $fbackground valign=\"top\">" . "	<font class=\"forum\">" . _FMESS . ": </font>" . "	</td>" . "	<td $fbackground >" . "		<textarea name=\"text\" rows=\"20\" cols=\"60\">" . notags($oldpost['text']) . "</textarea>" . "	</td>" . "</tr>" . "<tr>" . "	<td $fbackground colspan=\"2\" align=\"center\">" . "		<input type=\"submit\" class=\"submit\" value=\"" . _SAVE . "\" />" . "	</td>" . "</tr>" . "</tbody>" . "</table>" . "</form>";
	FN_CloseForum();
}
/**
 * regtopic
 * reristra un topic oppure lo modifica
 * 
 */
function regtopic()
{
	global $_FN,$allowmodifypost;
	global $forumback,$forumborder;
	$notify_message_to_all_users = 0;
	include ("sections/{$_FN['vmod']}/config.php");
	$forumdir = $_FN['idmod'] . "_" . $_FN['lang'];
	$fbackborder = "";
	$fbackground = "";
	if ( $forumborder != "" )
		$fbackborder = "bgcolor=\"$forumborder\" cellspacing=\"1\"";
	if ( $forumback != "" )
		$fbackground = "bgcolor=\"$forumback\"";
	if ( $_FN['user'] == "" )
		die(_NONPUOI);
	$argument = getparam("argument",PAR_POST,SAN_FLAT);
	$parent = getparam("parent",PAR_POST,SAN_FLAT);
	$topicid = getparam("topicid",PAR_POST,SAN_FLAT);
	$mode = getparam("mode",PAR_GET,SAN_FLAT);
	$uservalues = get_user($_FN['user']);
	$err = "";
	FN_OpenForum();
	echo "<table  $fbackborder width=\"100%\">" . "<tbody>" . "<tr>" . "<td $fbackground colspan=\"2\" width=\"100%\" >" . "<font class=\"forum\">";
	if (  !isset($_POST['subject']) ||  !isset($_POST['text']) || ($_POST['subject'] == "") || ($_POST['text'] == "") )
	{
		print _FERRCAMPO . "<br /><br /><a class=\"forum\" href=\"javascript:history.back()\">&lt;&lt;" . _INDIETRO . "</a><br /><br />";
	}
	else
	{
		//modifica topic
		if ( $mode == "edit" )
		{
			//if (isforumadmin())
			{
				$table_forum_threads = new FieldForm("fndatabase",$forumdir . "_posts",$_FN['datadir'],$_FN['lang']);
				$newvalues = $table_forum_threads->getbypost();
				$oldvalues = $table_forum_threads->xmltable->GetRecordByPrimaryKey($newvalues['unirecid']);
				$err = $table_forum_threads->Verify($newvalues);
				//dprint_r($oldvalues);
				if ( $allowmodifypost == 0 || $_FN['user'] != $oldvalues['username'] )
					if (  !isforumadmin() )
					{
						$err = _NONPUOI;
						$newvalues = $oldvalues;
					}
				if ( $err != "" )
				{
					print _FERRCAMPO . "<br />$err<br /><a class=\"forum\" href=\"javascript:history.back()\">&lt;&lt;" . _INDIETRO . "</a><br /><br />";
				}
				else
					$newvalues = $table_forum_threads->xmltable->UpdateRecord($newvalues);
			}
		}
		else //nuovo topic
		//if ($parent == "" && $topicid == "")
		{
			$table_forum_threads = new FieldForm("fndatabase",$forumdir . "_posts",$_FN['datadir'],$_FN['lang']);
			$forum_topics = new FieldForm("fndatabase",$forumdir . "_topics",$_FN['datadir'],$_FN['lang']);
			$newvalues = $table_forum_threads->getbypost();
			if ( $uservalues['signature'] != "" )
				$newvalues['text'] .= "\n\n" . $uservalues['signature'];
			if (  !isforumadmin() && is_spam($newvalues['subject'] . " " . $newvalues['text']) )
			{
				die(_THISISSPAM);
			}
			$tablearguments = new XMLTable("fndatabase",$forumdir . "_arguments",$_FN['datadir']);
			//nuovo topic (e primo messaggio del thread)
			if ( $newvalues['topicid'] == "" )
			{
				if ( $argument == "" )
					die(_NONPUOI);
				if ( $tablearguments->GetRecordByPk($argument) == null )
				{
					die(_NONPUOI);
				}
				$topic = array();
				$topic['subject'] = $newvalues['subject'];
				$topic['user'] = $_FN['user'];
				$topic['time'] = time();
				$topic['read'] = "0";
				$topic['argument'] = $argument;
				$topic['username'] = $_FN['user'];
				$newtopic = $forum_topics->xmltable->InsertRecord($topic);
				$newvalues['topicid'] = $newtopic['unirecid'];
			}
			else
				$topic = $forum_topics->xmltable->GetRecordByPk($newvalues['topicid']);
			if ( $argument == "" )
			{
				$argument = $tablearguments->GetRecordByPk($topic['argument']);
				$argument = $argument['unirecid'];
			}
			$newvalues['time'] = time();
			$newvalues['username'] = $_FN['user'];
			$table_forum_threads->xmltable->InsertRecord($newvalues);
			//notifica ---->
			if ( $notify_message_to_all_users )
			{
				$listnotify = get_userlist();
			}
			else
				$listnotify = listusernotify($newvalues['topicid']);
			foreach ( $listnotify as $notify )
			{
				$orimess = $newvalues['text'];
				if ( strtoupper(substr(PHP_OS,0,3) == 'WIN') )
				{
					$eol = "\r\n";
				}
				elseif ( strtoupper(substr(PHP_OS,0,3) == 'MAC') )
				{
					$eol = "\r";
				}
				else
				{
					$eol = "\n";
				}
				//fix newline
				$orimess = str_replace("\r","",$orimess);
				$orimess = str_replace("\n","$eol",$orimess);
				$uservalues = get_user($notify);
				$email = $uservalues['email'];
				$server = "http://" . $_SERVER['SERVER_NAME'] . $_SERVER['SCRIPT_NAME'];
				$string = fn_i18n("_FNUOVOMESS") . ":$eol$server?mod={$_FN['mod']}&op=readtopic&topic=" . $newvalues['topicid'] . "$eol$eol" . fn_i18n("_DA") . " {$_FN['user']}$eol$orimess$eol$eol" . $_FN['sitename'] . "$eol";
				//if ($notify!=$_FN['user'])
				{
					mail("$email","[{$_FN['sitename']}] - " . fn_i18n("_FNUOVOMESS"),$string,"From: {$_FN['site_email_address']}$eol" . "Reply-To: {$_FN['site_email_address']}$eol" . "X-Mailer: PHP/" . phpversion());
				}
			}
			//notifica ----<
		}
		if ( $parent == "" && $topicid == "" )
		{
			FN_log("user created new topic : {$newvalues['subject']}.");
			print fn_i18n("_FTOPOK");
		}
		else
		{
			FN_log("Post added by user {$_FN['user']} in topic " . $newvalues['topicid'] ."({$newvalues['subject']})");
			print fn_i18n("_FMESSOK");
		}
		if ( $err == "" )
		{
			echo "<br /><a class=\"forum\" href=\"" . fn_rewritelink("index.php?mod=" . $_FN['idmod'] . "&amp;op=readtopic&topic=" . $newvalues['topicid']) . "\" >&lt;&lt;" . _FLEGGI . "</a>";
			jsredirect(fn_rewritelink("index.php?mod=" . $_FN['idmod'] . "&op=readtopic&topic=" . $newvalues['topicid'] . "&last"));
		}
	}
	echo "</font></td>" . "</tr>" . "</tbody>" . "</table>" . "</form>";
	FN_CloseForum();
}
/**
 * readtopic
 * 
 * legge i topics
 * 
 */
function readtopic($topic = false, $compact = false)
{
	if (  !$topic )
		$topic = getparam("topic",PAR_GET,SAN_FLAT);
	global $_FN,$postperpage;
	global $forumback,$forumborder,$allowmodifypost;
	$forumdir = $_FN['idmod'] . "_" . $_FN['lang'];
	$fbackborder = "";
	$fbackground = "";
	if ( $forumborder != "" )
		$fbackborder = "bgcolor=\"$forumborder\" cellspacing=\"1\"";
	if ( $forumback != "" )
		$fbackground = "bgcolor=\"$forumback\"";
	$argument = getparam("argument",PAR_POST,SAN_FLAT);
	$parent = getparam("parent",PAR_GET,SAN_FLAT);
	$page = getparam("page",PAR_GET,SAN_FLAT);
	$tablethreads = new XMLTable("fndatabase",$forumdir . "_posts",$_FN['datadir']);
	// aggiorno le letture ->
	$tabletopics = new FieldForm("fndatabase",$forumdir . "_topics",$_FN['datadir'],$_FN['lang']);
	$topicsvalues = $tabletopics->xmltable->GetRecordByPk($topic);
	if (  !is_array($topicsvalues) )
		return;
	$userlevel = getlevel($_FN['user']);
	//associo il livello del topic a quello dell' argomento
	$tablearguments = new XMLTable("fndatabase",$forumdir . "_arguments",$_FN['datadir']);
	$argumentvalues = $tablearguments->GetRecordByPk($topicsvalues['argument']);
	$topicsvalues['level'] = $argumentvalues['level'];
	if ( $topicsvalues['level'] == "" )
		$topicsvalues['level'] =  -1;
	if ( $topicsvalues['level'] > $userlevel )
		return;
	$topicsvalues['read']++ ;
	$tabletopics->xmltable->UpdateRecord($topicsvalues);
	// aggiorno le letture -<
	if ( $page == "" )
		$page = 1;
	FN_OpenPost();
	echo "<table width=\"100%\" $fbackborder class=\"forum-topic-table\"  >" . "<tbody >";
	//salvataggio  ----->
	if ( isforumadmin() &&  !$compact )
	{
		if ( isset($_POST['save']) )
		{
			$newvalues = $tabletopics->getbypost();
			$err = $tabletopics->Verify($newvalues,true);
			if ( $err == "" )
				$topicsvalues = $tabletopics->xmltable->UpdateRecord($newvalues);
			else
			{
				echo "<tr  ><td $fbackground colspan=\"2\">";
				echo "$err";
				echo "</td></tr>";
			}
		}
	}
	//salvataggio  -----<
	$r = array("topicid"=>$topic);
	$posts = $tablethreads->GetRecords($r,false,false,"unirecid");
	$totalposts = count($posts);
	$numPages = ceil($totalposts / $postperpage);
	if ( isset($_GET['last']) || $compact )
		$page = $numPages;
	$starttopic = ($page * $postperpage) - $postperpage + 1;
	//--------rispondi---------------------------->
	if ( $topicsvalues['locked'] != 1 &&  !$compact )
		if ( $_FN['user'] != "" )
		{
			echo "<tr>" . "<td $fbackground colspan=\"2\"  align=\"center\" >" . "<font class=\"forum\">";
			echo "<button onclick=\"window.location='" . fn_rewritelink("?mod={$_FN['idmod']}&op=newtopic&mode=ris&topic=$topic") . "'\" >" . _FRISP . "</button>" . "</font></td></tr>";
		}
		//--------rispondi----------------------------<
	echo "<tr>" . "\n<td $fbackground class=\"forum-topic-user-header\" align=\"center\" width=\"120\">" . "\n<font class=\"forum\" ><b>" . _FUTENTE . "</b></font>" . "\n</td>" . "\n<td $fbackground class=\"forum-topic-post-header\" align=\"center\" >" . "\n<font class=\"forum\" ><b>" . _FMESS . "</b></font>" . "\n</td>" . "\n</tr>";
	for ( $ip = $starttopic - 1;$ip < ($starttopic + $postperpage) - 1;$ip++  )
	{
		if (  !isset($posts[$ip]) )
			break;
		$post = $posts[$ip];
		echo "<tr>";
		echo "<td $fbackground class=\"forum-topic-user\"  valign=\"top\" align=\"center\" width=\"120\"><font class=\"forum\" >";
		$poster = $post['username'];
		if ( ($uservalues = get_user($post['username'])) != null )
		{
			//immagine utente ---->
			if ( isset($uservalues['avatar']) && $uservalues['avatar'] != "" )
				$image = $_FN['datadir'] . "/fndatabase/users/$poster/avatar/" . $uservalues['avatar'];
			else 
				if ( isset($uservalues['avatarimage']) && $uservalues['avatarimage'] != "" )
				{
					$image = ($_FN['datadir'] . "/fndatabase/avatars/" . urlencode($uservalues['avatarimage']) . "/filename/" . $uservalues['avatarimage']);
				}
				else
					$image = fromtheme("images/avatars/blank.png");
			print "<img alt=\"\" src=\"$image\" border='0' /><br />";
			print "<br /><b>$poster</b><br /><br />";
			//immagine utente ----<
			// tabella per livello  0-10 ------>
			$level = $uservalues['level'];
			print "
						<table  cellpadding='0' cellspacing='0' width=\"120\">
							<tr><td>0</td>
						<td align='center' ><b>" . _LEVEL . " $level</b></td>
						<td align='right'>10</td></tr></table>";
			// tabella per livello  0-10   ------<
			print "<hr size='1' noshade=\"noshade\" width='120' align='center' />";
			//barra livello ----------->
			$i = 0;
			while ($i < $level)
			{
				echo "<img src=\"" . fromtheme("images/useronline/level_y.gif") . "\" alt=\"level\" align=\"middle\" />";
				$i++ ;
			}
			while ($i < 10)
			{
				echo "<img  src=\"" . fromtheme("images/useronline/level_n.gif") . "\" alt=\"level\" align=\"middle\" />";
				$i++ ;
			}
			//barra livello -----------<
			print "<hr width='120' size='1' noshade=\"noshade\"  align='center' />";
			print "<a class=\"forum\" href=\"" . fn_rewritelink("?mod=login&amp;op=profile&amp;user=$poster") . "\"><img alt=\"profile\"src=\"images/icons/profile.png\" border=\"0\" /></a>" . "&nbsp;";
			if ( ( !isset($uservalues['emailhidden']) || $uservalues['emailhidden'] == 0) || isforumadmin() ) //gli amministratori vedono tutte le email
			{
				print("<a class=\"forum\" href=\"mailto:" . $uservalues['email'] . "\"><img alt=\"mail\" src=\"" . fromtheme("images/icons/mail.png") . "\" border=\"0\" /></a>");
			}
			if ( isset($uservalues['link']) && strlen($uservalues['link']) > 7 )
			{
				print("&nbsp;<a class=\"forum\" href=\"" . $uservalues['link'] . "\" onclick=\"window.open(this.href);return false;\" ><img alt=\"home\" src=\"" . fromtheme("images/icons/home.png") . "\" border=\"0\" /></a>");
			}
		}
		else
		{
			print "<br /><b>$poster</b>";
		}
		echo "</font></td>";
		echo "<td $fbackground class=\"forum-topic-post\" valign=\"top\"><font class=\"forum\" >";
		echo GetPostTime($post['time']);
		echo "<br /><br /><b>" . notags($post['subject']) . ":</b><br />";
		echo tag2html(notags($post['text']));
		echo "<br /><br />";
		if ( $topicsvalues['locked'] != 1 &&  !$compact )
			if ( $_FN['user'] != "" )
				echo "<button onclick=\"window.location='" . fn_rewritelink("?mod={$_FN['idmod']}&op=newtopic&mode=ris&topic=$topic&parent=" . $post['unirecid']) . "'\" >" . _QUOTEPOST . "</button>";
		if ( (($allowmodifypost == 1 && $_FN['user'] == $post['username']) || isforumadmin()) &&  !$compact )
		{
			echo "&nbsp;<button onclick=\"window.location='" . fn_rewritelink("?mod={$_FN['idmod']}&op=editpost&post=" . $post['unirecid']) . "'\" >" . _EDITPOST . "</button>";
		}
		if ( isforumadmin() &&  !$compact )
		{
			echo "<button onclick=\"check('" . fn_rewritelink("?mod={$_FN['idmod']}&op=delpost&post=" . $post['unirecid']) . "')\" >" . _DELETEPOST . "</button>";
		}
		echo "</font></td>";
		echo "</tr>";
	}
	//--------rispondi---------------------------->
	if ( $topicsvalues['locked'] != 1 &&  !$compact )
		if ( $_FN['user'] != "" )
		{
			echo "<tr>" . "<td $fbackground colspan=\"2\"  align=\"center\" >" . "<font class=\"forum\">";
			echo "<button onclick=\"window.location='" . fn_rewritelink("?mod={$_FN['idmod']}&op=newtopic&mode=ris&topic=$topic") . "'\" >" . _FRISP . "</button>" . "</font></td></tr>";
		}
		//--------rispondi----------------------------<
	//--------pagine---------------------------->
	if (  !$compact )
	{
		echo "<tr>" . "<td $fbackground colspan=\"2\" align=\"center\" >" . "<font class=\"forum\">";
		for ( $i = 1;$i <= $numPages;$i++  )
		{
			if ( $page == $i )
				echo "&nbsp;<a href=\"" . fn_rewritelink("?mod={$_FN['idmod']}&amp;op=readtopic&amp;topic=$topic&amp;page=$i") . "\"><b>[$i]</b></a>";
			else
				echo "&nbsp;<a href=\"" . fn_rewritelink("?mod={$_FN['idmod']}&amp;op=readtopic&amp;topic=$topic&amp;page=$i") . "\">[$i]</a>";
		}
		"</font></td></tr>";
		//--------pagine----------------------------<
	}
	//--------notifica---------------------------->
	if ( $_FN['user'] != "" &&  !$compact )
	{
		$tableuser_topics = new XMLTable("fndatabase",$forumdir . "_user_topics",$_FN['datadir']);
		$donotify = getparam("donotify",PAR_POST,SAN_FLAT);
		if ( $donotify != "" )
		{
			$notify = getparam("notify",PAR_POST,SAN_FLAT);
			$notifyuser = getparam("notifyuser",PAR_POST,SAN_FLAT);
			$notiftopic = $topic;
			//if (!isforumadmin())
			$notifyuser = $_FN['user'];
			if ( $notify != "" )
				addusernotify($topic,$notifyuser);
			else
				delusernotify($topic,$notifyuser);
		}
		$iscritto = isusernotify($topic,$_FN['user']);
		$ch = "";
		if ( $iscritto )
			$ch = "checked=\"checked\"";
		echo "<tr>" . "<td $fbackground colspan=\"2\"  align=\"center\" >";
		echo "<form method=\"post\" action=\"" . fn_rewritelink("?mod={$_FN['idmod']}&amp;op=readtopic&amp;topic=$topic&amp;page=$page") . "\">";
		echo "<font class=\"forum\">" . _NOTIFY_BY_EMAIL;
		echo " <input $ch type=\"checkbox\" value=\"notify\" name=\"notify\" />";
		echo "<input type=\"submit\" name=\"donotify\" class=\"submit\" value=\"" . _SAVE . "\" />" . "</font></form>";
		$usersnotify = listusernotify($topic);
		if ( isforumadmin() && count($usersnotify) > 0 )
		{
			echo _FUTENTI . "&nbsp;:";
			foreach ( $usersnotify as $usermot )
			{
				echo " <a href=\"" . fn_rewritelink("?mod=login&amp;op=profile&amp;user=$usermot") . "\">$usermot</a>";
			}
		}
		echo "</td></tr>";
		//--------notifica----------------------------<
	}
	//form d aggiornamento del topic ---->
	if ( isforumadmin() &&  !$compact )
	{
		echo "<tr  ><td $fbackground colspan=\"6\">";
		echo "<b>" . _MODIFICA . ":</b><br />";
		echo "<form action='" . fn_rewritelink("?mod={$_FN['idmod']}&amp;op=readtopic&amp;topic=$topic&amp;page=$page") . "' method='post'>";
		echo "<table>";
		echo "<tr ><td $fbackground colspan=\"\"></td></tr>";
		$tabletopics->ShowUpdateForm($topic,isforumadmin());
		echo "<tr><td $fbackground colspan=\"2\"><input name=\"save\" type=\"submit\" class=\"submit\" value=\"" . _SAVE . "\" />";
		echo "</table>";
		echo "</form></td></tr>";
	}
	//form d aggiornamento del topic ----<
	echo "</tbody>" . "</table>";
	if ( $compact )
		echo "<br />";
	FN_ClosePost();
}
/**
 * 
 * @param string $topic
 * @param string $user
 */
function isusernotify($topic, $user)
{
	global $_FN,$postperpage;
	$forumdir = $_FN['idmod'] . "_" . $_FN['lang'];
	$tableuser_topics = new XMLTable("fndatabase",$forumdir . "_user_topics",$_FN['datadir']);
	$iscritto = $tableuser_topics->GetRecord(array("username"=>$user,"topicid"=>$topic));
	//dprint_r($iscritto);
	if ( $iscritto != null )
		return true;
	return false;
}
/**
 * 
 * @param string $topic
 * @param string $user
 */
function addusernotify($topic, $user)
{
	global $_FN,$postperpage;
	$forumdir = $_FN['idmod'] . "_" . $_FN['lang'];
	$tableuser_topics = new XMLTable("fndatabase",$forumdir . "_user_topics",$_FN['datadir']);
	$iscritto = $tableuser_topics->GetRecord(array("username"=>$user,"topicid"=>$topic));
	if (  !isusernotify($topic,$user) )
		$iscritto = $tableuser_topics->InsertRecord(array("username"=>$user,"topicid"=>$topic));
}
/**
 * 
 * @param string $topic
 * @param string $user
 */
function delusernotify($topic, $user)
{
	global $_FN,$postperpage;
	$forumdir = $_FN['idmod'] . "_" . $_FN['lang'];
	$tableuser_topics = new XMLTable("fndatabase",$forumdir . "_user_topics",$_FN['datadir']);
	$iscritto = $tableuser_topics->GetRecord(array("username"=>$user,"topicid"=>$topic));
	if ( $iscritto != null )
		$tableuser_topics->DelRecord($iscritto['unirecid']);
}
/**
 * 
 * @param string $topic
 */
function listusernotify($topic)
{
	global $_FN,$postperpage;
	$forumdir = $_FN['idmod'] . "_" . $_FN['lang'];
	$tableuser_topics = new XMLTable("fndatabase",$forumdir . "_user_topics",$_FN['datadir']);
	$iscritti = $tableuser_topics->GetRecords(array("topicid"=>$topic));
	$list = array();
	foreach ( $iscritti as $rec )
	{
		$list[] = $rec['username'];
	}
	return $list;
}
/*
 * isforumadmin
 * 
 * predisposizione per i moderatori
 */
function isforumadmin()
{
	global $_FN;
	if ( is_admin() )
		return true;
	return ($_FN['user'] != "" && user_in_group($_FN['user'],"admin_flatforum"));
}
/**
 * 
 * @param string $topicslocation
 */
function OLD_get_arglist($topicslocation)
{
	global $_FN;
	$mod = ($mod = sectionlocation(isset($_GET['mod']) ? $_GET['mod'] : "")) ? $mod : sectionlocation($_FN['home_section']);
	$l = array();
	$fdirectory = opendir($_FN['datadir'] . "/$topicslocation/" . $_FN['lang']);
	while (false !== $file = readdir($fdirectory))
	{
		if ( ($file != ".") && ($file != "..") && ($file != ".xml") &&  !is_dir($_FN['datadir'] . "/$topicslocation/" . $_FN['lang'] . "/$file") )
		{
			$dirtoopen = $_FN['datadir'] . "/$topicslocation/" . $_FN['lang'] . "/" . str_replace(".xml","",$file);
			if ( is_dir($dirtoopen) )
			{
				if ( getlevel($_FN['user']) >= getdirlevel($_FN['datadir'] . "/$topicslocation/" . $_FN['lang'] . "/" . str_replace(".xml","",$file)) )
				{
					$topic = get_xml_element("ff:topic",get_file($_FN['datadir'] . "/$topicslocation/" . $_FN['lang'] . "/$file"));
					$subj = get_xml_element("ff:subj",get_file($_FN['datadir'] . "/$topicslocation/" . $_FN['lang'] . "/$file"));
					$descr = get_xml_element("ff:postbody",get_file($_FN['datadir'] . "/$topicslocation/" . $_FN['lang'] . "/$file"));
					$arg['argumentgroup'] = $subj;
					$arg['subject'] = $topic;
					$arg['description'] = $descr;
					$arg['level'] = $topic['level'] = getdirlevel($dirtoopen);
					;
					array_push($l,$arg);
				}
			}
		}
	}
	closedir($fdirectory);
	return $l;
}
/**
 * 
 * @param string $topicslocation
 */
function OLD_get_topiclist($topicslocation)
{
	global $_FN;
	//$topicslocation = "alltopics";
	//include ("sections/" . sectionlocation("forum") . "/config.pp");
	$l = array();
	$fdirectory = opendir($_FN['datadir'] . "/$topicslocation/" . $_FN['lang']);
	while (false !== $file = readdir($fdirectory))
	{
		if ( ($file != ".") && ($file != "..") && ($file != ".xml") &&  !is_dir($_FN['datadir'] . "/$topicslocation/" . $_FN['lang'] . "/$file") )
		{
			if ( is_dir($_FN['datadir'] . "/$topicslocation/" . $_FN['lang'] . "/" . str_replace(".xml","",$file)) )
			{
				if ( getlevel($_FN['user']) >= getdirlevel($_FN['datadir'] . "/$topicslocation/" . $_FN['lang'] . "/" . str_replace(".xml","",$file)) )
				{
					$string = get_file($_FN['datadir'] . "/$topicslocation/" . $_FN['lang'] . "/$file",100);
					$d['topic'] = get_xml_element("ff:topic",$string);
					$d['subj'] = get_xml_element("ff:subj",$string);
					$d['postbody'] = get_xml_element("ff:postbody",$string);
					$d['file'] = $_FN['datadir'] . "/$topicslocation/" . $_FN['lang'] . "/$file";
					$l[] = $d;
				}
			}
		}
	}
	closedir($fdirectory);
	//array_reverse($l);
	return $l;
}
/**
 * 
 * @param string $topicslocation
 */
function ImportaVecchioForum($topicslocation)
{
	ini_set("max_execution_time","100");
	global $_FN;
	$forumdir = $_FN['idmod'] . "_" . $_FN['lang'];
	$listargs = OLD_get_arglist($topicslocation);
	$listtopic = OLD_get_topiclist($topicslocation);
	$table_forum_threads = new XMLTable("fndatabase",$forumdir . "_posts",$_FN['datadir']);
	$forum_topics = new XMLTable("fndatabase",$forumdir . "_topics",$_FN['datadir']);
	$forum_arguments = new XMLTable("fndatabase",$forumdir . "_arguments",$_FN['datadir']);
	$d = 0;
	foreach ( $listargs as $arg )
	{
		//dprint_r($listtopic);
		$res = $forum_arguments->InsertRecord($arg);
		$unirecid_argoment = $res['unirecid'];
		echo "<h2>" . $arg['subject'] . "</h2>";
		foreach ( $listtopic as $file )
		{
			if ( $arg['subject'] == $file['topic'] )
			{
				//dprint_r($file);
				//continue;
				$title = $file['topic'];
				echo "<h3>title=$title</h3>";
				$body = $file['postbody'];
				$fdir = opendir(str_replace(".xml","",$file['file']));
				for ( $_i = 0;false !== ($file2 = readdir($fdir));)
				{
					if ( $file2 !== "." && $file2 != ".." && get_file_extension($file2) == "xml" )
					{
						$_i++ ;
						$filetoopen = $_FN['datadir'] . "/$topicslocation/" . $_FN['lang'] . "/" . str_replace(".xml","",basename($file['file'])) . "/$file2";
						$dirtoopen = $_FN['datadir'] . "/$topicslocation/" . $_FN['lang'] . "/" . str_replace(".xml","",basename($file['file']));
						$filetoopenuser = $_FN['datadir'] . "/$topicslocation/" . $_FN['lang'] . "/" . str_replace(".xml","",basename($file['file'])) . "/" . str_replace(".xml",".users",$file2);
						$fcont = file_get_contents($filetoopen);
						$topicinfo = get_xml_array("ff:post",$fcont);
						$q = count($topicinfo);
						if ( $q != 0 )
						{
							$letto = get_xml_element("ff:reads",$fcont);
							echo "<h4>topic=$file2, letto $letto volte</h4>";
							$first = true;
							foreach ( $topicinfo as $message )
							{
								$newvalue = array();
								$newvalue['time'] = get_xml_element("ff:postime",$message);
								$newvalue['subject'] = html_entity_decode(get_xml_element("ff:subj",$message));
								$newvalue['username'] = get_xml_element("ff:poster",$message);
								$newvalue['text'] = get_xml_element("ff:postbody",$message);
								$newvalue['text'] = str_replace("<br>","\n",$newvalue['text']);
								$newvalue['text'] = str_replace("<br/>","\n",$newvalue['text']);
								$newvalue['text'] = str_replace("<br />","\n",$newvalue['text']);
								$newvalue['text'] = html_entity_decode($newvalue['text']);
								if ( $first )
								{
									$topic['time'] = $newvalue['time'];
									$topic['subject'] = $newvalue['subject'];
									$topic['username'] = $newvalue['username'];
									$topic['argument'] = $unirecid_argoment;
									$topic['read'] = $letto;
									$ntopic = $forum_topics->InsertRecord($topic);
									$unirecid_topic = $ntopic['unirecid'];
									echo "<br />topic:" . $topic['subject'] . "imported";
									$listusers = array();
									echo "<br />$filetoopenuser";
									if ( is_dir($filetoopenuser) )
									{
										$fdirectory = opendir($filetoopenuser);
										while (false !== $file4 = readdir($fdirectory))
										{
											if ( ($file4 != ".") && ($file4 != "..") )
											{
												array_push($listusers,$file4);
												echo "<br />add user:$file4 ";
												addusernotify($ntopic['unirecid'],"$file4");
											}
										}
										closedir($fdirectory);
									}
								}
								$newvalue['topicid'] = $unirecid_topic;
								//$newvalue['unirecid']=$d++;
								$table_forum_threads->InsertRecord($newvalue);
								echo "<br />message:" . $newvalue['subject'] . "imported";
								$first = false;
							}
						}
					}
				}
			}
		}
	}
}
?>