<?php
/**
 * @package flatnux_section_gallery
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @copyright Copyright (c) 2003-2005
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 * 
 */
if (strpos ( strtolower ( $_SERVER ['SCRIPT_NAME'] ), strtolower ( basename ( __FILE__ ) ) ))
{
	header ( "Location: ../../index.php" );
	die ( "..." );
}
global $_FN;
require_once ("sections/{$_FN['vmod']}/photo_functions.php");

global $photodir;
global $ThumbSize, $Num_Cols, $movie_extensions, $_FN, $photogroup,$use_lightbox,$create_thumbs_dir;

$dir = getparam ( "dir", PAR_GET, SAN_FLAT );
$getdir = getparam ( "dir", PAR_GET, SAN_FLAT );


//evito di navigare in altre cartelle --->
if (strstr ( $dir, "." ))
	die ( _NONUOI );
	//evito di navigare in altre cartelle ---<
global $movie_extensions;
include ("sections/" . $_FN ['vmod'] . "/config.php");
if ($photodir == "")
	die ( "photodir is not defined in " . "sections/" . $_FN ['vmod'] . "/config.php" );

$PATH_GALLERY = $_FN ['datadir'] . "/$photodir";

//----- inizializzazione gallery ------------->
if (! file_exists ( $PATH_GALLERY ))
{
	mkdir ( $PATH_GALLERY );
	if (is_writable ( $PATH_GALLERY ))
	{
		fn_copy_dir ( "include/install/foto", $PATH_GALLERY );
	}
}
//----- inizializzazione gallery -------------<


//----- se il gruppo foto non esiste lo creo ------------->
if ($photogroup != "")
{
	$table = new XMLTable ( "fndatabase", "groups", $_FN ['datadir'] );
	$grouplist = $table->GetRecordByPk ( $photogroup );
	if (! $grouplist)
		$table->InsertRecord ( array ("groupname" => $photogroup ) );
}
//----- se il gruppo foto non esiste lo creo -------------<


//-------NUOVA CARTELLA ------>>>>
if (is_photo_admin () && isset ( $_POST ['sectionname'] ))
{
	$dirtomake = strippostpslashes ( getparam ( "sectionname", PAR_POST, SAN_FLAT ) );
	if ($dirtomake != "")
		if (file_exists ( "$PATH_GALLERY/$dir" . $dirtomake ))
		{
			echo "<div>" . "$PATH_GALLERY/$dir" . $dirtomake . ":" . _FIG_ALERTEXIST . "</div>";
		}
		else
		{
			mkdir ( "$PATH_GALLERY/$dir/" . $dirtomake );
		}
}
//-------NUOVA CARTELLA ------<<<<


//-------NUOVA FOTO ------>>>>


if (is_photo_admin () && isset ( $_FILES ['newfile'] ))
{
	$fileToOpen = "$PATH_GALLERY/$dir";
	$file_clean = str_replace ( "\\", '', $_FILES ['newfile'] ['name'] );
	
	if ($file_clean != "")
	{
		if (is_Image ( $_FILES ['newfile'] ['tmp_name'] ) || gg_is_Video ( $file_clean ) || get_file_extension ( $file_clean ) == "link")
		{
			if (! move_uploaded_file ( $_FILES ['newfile'] ['tmp_name'], $fileToOpen . "/" . $file_clean ))
			{
				jsalert ( _FILENOTCREATED );
			}
			else
			{
			
			}
			refreshThumb ( $fileToOpen );
		}
		else
		{
			echo ("<div>" . (_FIG_ALERTNOTIMG) . "</div>");
		}
	}
}
//dprint_r($_FILES);


//<<<<-------NUOVA FOTO ------
//>>>>-------ELIMINA FOTO ------
$delfile = getparam ( "delfile", PAR_GET, SAN_FLAT );
if (is_photo_admin () && $delfile != "")
{
	$delfile = basename ( $delfile );
	$fileToOpen = "$PATH_GALLERY/$dir/$delfile";
	if (file_exists ( $fileToOpen ))
	{
		unlink ( $fileToOpen );
		refreshThumb ( "$PATH_GALLERY/$dir" );
	}
}
$deldir = getparam ( "deldir", PAR_GET, SAN_FLAT );
if (is_photo_admin () && $deldir != "")
{
	if (! strstr ( "..", $deldir ))
	{
		$fileToOpen = "$PATH_GALLERY/$deldir";
		if (file_exists ( $fileToOpen ) && is_dir ( $fileToOpen ))
		{
			remove_dir_rec ( $fileToOpen );
		}
	}
}

//<<<<-------ELIMINA FOTO ------


$photos = get_file_list ( "$PATH_GALLERY/$dir", "jpg,jpeg,gif,bmp,png" );
$videos = get_file_list ( "$PATH_GALLERY/$dir", "$movie_extensions" );
$links = get_file_list ( "$PATH_GALLERY/$dir", "link" );
$dirs = get_dir_list ( "$PATH_GALLERY/$dir" );
//dprint_r($videos);


//---------javascript window ----------->
echo '
<script language="javascript" type="text/javascript">
<!-- // nascondi ai vecchi browser
function popup(nomefile, larghezza, altezza, x, y) {win_popup = window.open(nomefile,"popup","toolbar= 0,location= 0,directories= 0,status= 0,menubar= 0,scrollbars= 1,resizable= 1,copyhistory= 0,width=" + larghezza + ",height=" + altezza);
if(x && y); {x = parseInt(x);
y = parseInt(y);
win_popup.moveTo(x, y); } }
';
if (is_photo_admin ())
{
	echo '
function divtoinput(obj)
{
	var obj_title=obj.innerHTML;
	obj.removeAttribute("onclick");
	obj.innerHTML="<input style=\"text-align:center\" type=\"text\" name=\""+obj.id+"\" value=\""+obj_title+"\"/>";
	document.getElementById("x__btn_savephotos").type="submit";		
}
function toinput(id)
{
	var obj_title=document.getElementById("galleryid_"+id)

	document.getElementById("galleryid_"+id).removeAttribute("onclick");
	document.getElementById("d_"+"galleryid_"+id).removeAttribute("onclick");
	obj_title.innerHTML="<input style=\"text-align:center\" type=\"text\" name=\""+obj_title.id+"\" value=\""+document.getElementById("x__"+obj_title.id).innerHTML+"\"/>";
	olddesc=document.getElementById("x__d_"+obj_title.id).innerHTML;
	document.getElementById("d_"+obj_title.id).innerHTML="<textarea name=\"d_"+obj_title.id+"\">"+olddesc+"</textarea>";

	document.getElementById("x__btn_savephotos").type="submit";
}

function titletoinput(obj)
{
	try{
	var olddesc=document.getElementById("desc_"+obj.id).innerHTML;
	var oldtitle=document.getElementById("title_"+obj.id).innerHTML;
	
	document.getElementById("x_title_"+obj.id).innerHTML=
	"<input type=\"text\" name=\"title_"+obj.id+"\" value=\"" + oldtitle + "\" />&nbsp;";

	document.getElementById("desc_" + obj.id).innerHTML=
	"<input value=\""+olddesc+"\"  type=\"text\" name=\"desc_"+obj.id+"\"  />";
	document.getElementById("x__btn_savephotos").type="submit";
	}
	catch(e)
	{}
}
';
}
echo '

// -->
</script>
';

//---------javascript window -----------<
//----cambio titolo ------->
if (is_photo_admin () && isset ( $_POST ["ffmaintitle"] ))
{
	//dprint_r($_POST);
	$newtitle = htmlspecialchars ( strippostpslashes ( getparam ( "ffmaintitle", PAR_POST, SAN_FLAT ) ) );
	$filetoopen = "$PATH_GALLERY/$dir/title." . $_FN ['lang'] . ".txt";
	$fileh = fopen ( $filetoopen, "w" );
	fwrite ( $fileh, $newtitle );
	fclose ( $fileh );
}
//----cambio titolo -------<


echo createnavbar ();
if (is_photo_admin ())
	echo "<form action=\"?mod=" . $_FN ['mod'] . "&amp;dir=$dir\" enctype=\"multipart/form-data\" method=\"post\">";

$title = "";
if (file_exists ( "$PATH_GALLERY/$dir/title." . $_FN ['lang'] . ".txt" ))
{
	$title = htmlentities ( file_get_contents ( "$PATH_GALLERY/$dir/title." . $_FN ['lang'] . ".txt" ) );
}
$ok = "";
if (is_photo_admin ())
{
	$ok = "onclick=\"divtoinput(this)\"";
}

echo "<div style=\"text-align:center\" id=\"ffmaintitle\" $ok >" . ($title) . "</div>";
if (is_photo_admin () && $title == "")
{
	echo "<img style=\"cursor:pointer\" onclick=\"divtoinput(document.getElementById('ffmaintitle'))\" style=\"cursor:pointer\" src=\"" . fromtheme ( "images/modify.png" ) . "\" border=\"0\" alt=\"\" title=\"" . _MODIFICA . "\" />";
}

//-----------------cartelle ----------------------->
$iddir = 0;
foreach ( $dirs as $curdir )
{
	$dir = $curdir ['dir'];
	$dirtitle = $curdir ['title'];
	$dirdesc = $curdir ['description'];
	
	$basedir = getparam ( "dir", PAR_GET, SAN_FLAT );
	MakeDirThumb ( $basedir, $dir, $PATH_GALLERY, false );
	
	$tonclick = "";
	//----cambio titolo interno e nome cartella --->
	if (is_photo_admin () && isset ( $_POST ["desc_iddir$iddir"] ))
	{
		$dirdesc = $newdesc = strippostpslashes ( getparam ( "desc_iddir$iddir", PAR_POST, SAN_FLAT ) );
		$dirtitle = $newtitle = strippostpslashes ( getparam ( "title_iddir$iddir", PAR_POST, SAN_FLAT ) );
		$fileh = fopen ( $PATH_GALLERY . "/" . $curdir ['dir'] . "/title." . $_FN ['lang'] . ".txt", "w" );
		fwrite ( $fileh, $newdesc );
		fclose ( $fileh );
		set_section_title ( $PATH_GALLERY . "/" . $curdir ['dir'] . "/lang.xml", strippostpslashes ( $newtitle ), $_FN ['lang'] );
	}
	//----cambio titolo interno e nome cartella ---<
	echo "\n<div>";
	
	////-------anteprima cartella o icona-------------------->
	$img = get_thumb_ ( "$PATH_GALLERY$dir" );
	if ($create_thumbs_dir == 1 && $img != false)
	{
		echo "<a href=\"".fn_rewritelink("?mod=" . $_FN ['idmod'] . "&amp;dir=$dir")."\" ><img style=\"padding:5px;vertical-align:middle\" alt=\"\" src=\"$img\" border=\"0\" /></a>&nbsp;";
	}
	else
		echo "<img alt=\"\" src=\"" . fromtheme ( "images/subsection.png" ) . "\" border=\"0\" />&nbsp;";
		
	////-------anteprima cartella o icona--------------------<
	

	echo "<b id=\"x_title_iddir$iddir\" ><a href=\"".fn_rewritelink("?mod=" . $_FN ['idmod'] . "&amp;dir=$dir")."\" id=\"title_iddir$iddir\">$dirtitle</a></b>";
	
	echo "&nbsp;<em><span id=\"desc_iddir$iddir\">" . $dirdesc . "</span></em>"; // descrizione
	

	if (is_photo_admin ())
	{
		echo "&nbsp;<img id=\"iddir$iddir\" style=\"cursor:pointer\" onclick=\"titletoinput(this)\" style=\"cursor:pointer\" src=\"" . fromtheme ( "images/modify.png" ) . "\" border=\"0\" alt=\"\" title=\"" . _MODIFICA . "\" />";
	
	}
	//---icona cancella --->
	if (is_photo_admin ())
	{
		$cdir = getparam ( "dir", PAR_GET, SAN_FLAT );
		echo "<a href=\"javascript:check('?mod={$_FN['mod']}&amp;dir=$cdir&amp;deldir=$dir')\"><img  type=\"image\"  src=\"" . fromtheme ( "images/delete.png" ) . "\" border=\"0\" alt=\"\" title=\"" . _GGREMOVEFOLDER . "\" /></a>";
	}
	//---icona cancella ---<
	

	echo "</div>";
	
	$iddir ++;
}
//-----------------cartelle -----------------------<


//-----------------links ----------------------->
if (count ( $links ) > 0)
{
	foreach ( $links as $curlink )
	{
		$url = $curlink ['url'];
		$dirtitle = $curlink ['url'];
		echo "\n<div><img alt=\"\" src=\"" . fromtheme ( "images/mime/web.png" ) . "\" border=\"0\">.<b><a  onclick=\"window.open(this.href);return false;\"  href=\"$url\" >$dirtitle </a></b> " . $curlink ['title'] . "</div>";
	}
}
//-----------------links -----------------------<


//-----------------Foto ----------------------->
print_files ( $photos );
//-----------------Foto -----------------------<


//-----------------Video ----------------------->
print_files ( $videos );
//-----------------Video -----------------------<


if (is_photo_admin ())
{
	// invio nuovo file -------------->
	$maxsize1 = ini_get ( "upload_max_filesize" );
	$maxsize = str_replace ( "M", "000000", $maxsize1 );
	echo "<br /><br /><fieldset><legend>" . _SENDNEWIMAGE . " (max  $maxsize1):</legend>";
	echo "<input type=\"file\" name=\"newfile\" />";
	echo "<input type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"$maxsize\" />";
	// invio nuovo file --------------<
	

	echo "</fieldset><br /><input id=\"x__btn_savephotos\" class=\"submit\" type=\"submit\" value=\"" . _SAVE . "\"> </form>";
}
if (is_photo_admin ())
{
	
	echo "\n<br /><br /><form  method=\"post\" action=\"?mod=" . $_FN ['vmod'] . "&amp;dir=$getdir\" >";
	echo _NEWFOLDER . ":&nbsp;<input  size=\"20\"  type=\"text\" name=\"sectionname\" />";
	echo "\n<input type=\"submit\"  class=\"submit\" name=\"newdir\" value=\"" . _CREA . "\" />";
	echo "\n</form>";

}

/**
 * print_files
 * 
 * stampa i files presenti
 * 
 */
function print_files($photos)
{
	
	global $ThumbSize, $Num_Cols, $_FN,$use_lightbox;
	$dir = getparam ( "dir", PAR_GET, SAN_FLAT );
	static $galleryid = 0;
	//dprint_r($_POST);
	if (count ( $photos ) > 0)
	{
		$cols = 1;
		$row = 1;
		$close = true;
		echo "<table cellpadding=\"1\" cellspacing=\"1\" width=\"100%\" border=\"0\" style=\"text-align:center\">";
		foreach ( $photos as $curphoto )
		{
			create_thumb_ ( $curphoto ['file'], $ThumbSize, false );
			if ($cols == 1)
			{
				echo "<tr>";
				$close = false;
			}
			if (is_Image ( $curphoto ['file'] ))
			{
				list ( $l, $h, $type, $attr ) = getimagesize ( $curphoto ['file'] );
			}
			else
			{
				$l = 100;
				$h = 100;
			}
			$l += 30;
			$h += 30;
			echo "<td style=\"text-align:center\">";
			$tonclick = "";
			
			if (is_photo_admin ())
			{
				if (isset ( $_POST ["galleryid_$galleryid"] ))
				{
					//cambio del titolo
					$newtitle = strippostpslashes ( getparam ( "galleryid_$galleryid", PAR_POST, SAN_FLAT ) );
					$newdesc = strippostpslashes ( getparam ( "d_galleryid_$galleryid", PAR_POST, SAN_FLAT ) );
					
					$filetitle = $curphoto ['file'] . "." . $_FN ['lang'] . ".title.txt";
					$filedesc = $curphoto ['file'] . "." . $_FN ['lang'] . ".txt";
					if (file_exists ( $filetitle ) && ! is_writable ( $filetitle ))
					{
						
						echo "error: $filetitle is radonly";
					}
					else
					{
						$fileh = fopen ( $filetitle, "w" );
						fwrite ( $fileh, $newtitle );
						fclose ( $fileh );
						$fileh = fopen ( $filedesc, "w" );
						fwrite ( $fileh, $newdesc );
						fclose ( $fileh );
						
						$curphoto ['title'] = htmlspecialchars ( $newtitle );
						$curphoto ['description'] = htmlspecialchars ( $newdesc );
					}
				}
				$tonclick = "onclick='toinput(\"$galleryid\");'";
			}
			echo "<div id=\"galleryid_$galleryid\" $tonclick  >" . "<div style=\"text-align:center\" id=\"x__galleryid_$galleryid\">" . $curphoto ['title'] . "</div>";
			if (is_photo_admin () && $curphoto ['title'] == "")
			{
				echo "<img style=\"cursor:pointer\" src=\"" . fromtheme ( "images/modify.png" ) . "\" border=\"0\" alt=\"\" title=\"" . _MODIFICA . "\" />";
			}
			echo "</div>";
			
			
			if ($use_lightbox && ! gg_is_Video($curphoto ['file']))
				echo "<a rel=\"lightbox[roadtrip]\" href=\"" . $curphoto ['file'] . "\">";
			else
				echo "<a onclick=\"popup('sections/" . $_FN ['vmod'] . "/photo.php?mod=" . $_FN ['vmod'] . "&amp;foto=" . $curphoto ['file'] . "&lang=" . $_FN ['lang'] . "', $l,$h, 0, 0); return false;\" href=\"" . $curphoto ['file'] . "\">";
			
			echo "<img  border=\"0\" src=\"" . $curphoto ['thumb'] . "\" alt=\"\" />";
			echo "</a>";
			if (is_photo_admin ())
				echo "<br /><a  href=\"javascript:check('?mod={$_FN['mod']}&amp;dir=$dir&amp;delfile=" . basename ( $curphoto ['file'] ) . "')\"><img style=\"height:16px;border:0px;\" type=\"image\"  src=\"" . fromtheme ( "images/delete.png" ) . "\" border=\"0\" alt=\"\" title=\"" . _ELIMINA . "\" /></a>";
			echo "<div $tonclick id=\"d_galleryid_$galleryid\"  >" . "<div style=\"text-align:center\" id=\"x__d_galleryid_$galleryid\">" . tag2html ( $curphoto ['description'] ) . "</div>";
			if (is_photo_admin () && $curphoto ['description'] == "")
			{
				echo "<img style=\"cursor:pointer\" src=\"" . fromtheme ( "images/modify.png" ) . "\" border=\"0\" alt=\"\" title=\"" . _MODIFICA . "\" />";
			}
			
			echo "</div></td>";
			if ($cols == $Num_Cols)
			{
				echo "</tr>";
				$cols = 0;
				$close = true;
				$row ++;
			}
			$galleryid ++;
			$cols ++;
		}
		if (! $close)
		{
			if ($row > 1)
				while ( $cols != $Num_Cols + 1 )
				{
					echo "<td>&nbsp;</td>";
					$cols ++;
				}
			echo "</tr>";
		}
		
		echo "</table>";
	
	}
}

/**
 * ricava la lista delle sottocartelle
 * @param string directory
 */
function get_dir_list($dir)
{
	global $_FN, $photodir;
	$handle_dir = opendir ( $dir );
	$list_dirs = array ();
	while ( false !== ($file = readdir ( $handle_dir )) )
	{
		if ($file != "." && $file != ".." && $file != "thumbs" && is_dir ( $dir . "/" . $file ))
		{
			$tnp = array ();
			$filetitle = $dir . "/" . $file . "/title." . $_FN ['lang'] . ".txt";
			$tmp ['title'] = getLang ( $dir . "/$file/lang.xml", str_replace ( "_", "&nbsp;", basename ( $file ) ) );
			$tmp ['description'] = "";
			if (file_exists ( $filetitle ))
				$tmp ['description'] = file_get_contents ( $filetitle );
			$s = "^" . $_FN ['datadir'] . "/$photodir/";
			$tmp ['dir'] = preg_replace ("/". str_replace ( '/', '\\/', $s)."/s", "", "$dir" . "/" . $file );
			$list_dirs [] = $tmp;
		}
	}
	sort ( $list_dirs );
	return $list_dirs;
}

/**
 *  createnavbar
 * crea la barra di navigazione per le foto
 */
function createnavbar()
{
	global $_FN;
	$tmp = str_replace ( "none_", "", $_FN ['vmod'] );
	$tmp = preg_replace ( "/^[0-9][0-9]_/si", "", $tmp );
	$tmp = getLang ( $_FN ['vmod'] . "/lang.xml", $tmp );
	echo _POS . ": <a href=\"".fn_rewritelink("?mod=" . $_FN ['idmod']) . "\" >$tmp</a>";
	$path = getparam ( "dir", PAR_GET, SAN_FLAT );
	$path = getparam ( $path, PAR_NULL, SAN_HTML );
	$path = explode ( "/", $path );
	$link = "";
	foreach ( $path as $section )
	{
		if ($section != "")
		{
			$link .= "/$section";
			$tmp = str_replace ( "none_", "", $section );
			$tmp = preg_replace ( "/^[0-9][0-9]_/si", "", $tmp );
			$langxml = $_FN ['datadir'] . "/foto/" . $link . "/lang.xml";
			$tmp = getLang ( $langxml, $tmp );
			echo " -> <a href=\"".fn_rewritelink("?mod=" . $_FN ['idmod'] . "&amp;dir=$link")."\" >$tmp</a>";
		}
	}
}

/**
 * is_photo_admin
 * 
 * verifica se l' utente puo' amministrare le foto
 */
function is_photo_admin()
{
	global $_FN, $photogroup;
	
	if (is_admin () || ($photogroup != "" && user_in_group ( $_FN ['user'], $photogroup )))
		return true;
	else
		return false;
}

/**
 * crea l' anteprima
 */
function create_thumb_($filename, $max = 100, $force_thumb = false, $max_h = "", $max_w = "")
{
	if ($max_h == "")
		$max_h = $max;
	if ($max_w == "")
		$max_w = $max;
	
	if (! function_exists ( "getimagesize" ))
	{
		echo "<br />" . _FNNOGDINSTALL;
		return;
	}
	$new_height = $new_width = 0;
	if (! file_exists ( $filename ))
	{
		echo "non esiste";
		return;
	}
	if (! getimagesize ( $filename ))
	{
		return;
	}
	
	list ( $width, $height, $type, $attr ) = getimagesize ( $filename );
	$path = dirname ( $filename ) . "/thumbs";
	
	$file_thumb = $path . "/" . basename ( $filename );
	
	if (! file_exists ( $path ))
	{
		mkdir ( $path );
	}
	
	if (! file_exists ( $path ))
	{
		echo "errore creazione dir";
		return false;
	}
	
	if (! is_dir ( $path ))
	{
		echo "<br />$path non esiste";
	}
	$new_height = $height;
	$new_width = $width;
	if ($width >= $max_w)
	{
		$new_width = $max_w;
		$new_height = intval ( $height * ($new_width / $width) );
	}
	
	//se troppo alta
	if ($new_height >= $max_h)
	{
		$new_height = $max_h;
		$new_width = intval ( $width * ($new_height / $height) );
	}
	// se l' immagine e gia piccola
	if ($width <= $max_w && $height <= $max_h)
	{
		$new_width = $width;
		$new_height = $height;
		//return;
	}
	
	//die("h=$new_height w=$new_width");
	// Load
	$thumb = imagecreatetruecolor ( $new_width, $new_height );
	$white = imagecolorallocate ( $thumb, 255, 255, 255 );
	$size = getimagesize ( $filename );
	switch ($size [2])
	{
		case 1 :
			$source = ImageCreateFromGif ( $filename );
			break;
		case 2 :
			$source = ImageCreateFromJpeg ( $filename );
			break;
		case 3 :
			$source = ImageCreateFromPng ( $filename );
			break;
		default :
			$tmb = null;
			$size [0] = $size [1] = 150;
			$source = ImageCreateTrueColor ( 150, 150 );
			$rosso = ImageColorAllocate ( $tmb, 255, 0, 0 );
			ImageString ( $tmb, 5, 10, 10, "Not a valid", $rosso );
			ImageString ( $tmb, 5, 10, 30, "GIF, JPEG or PNG", $rosso );
			ImageString ( $tmb, 5, 10, 50, "image.", $rosso );
	}
	// Resize
	imagefilledrectangle ( $thumb, 0, 0, $width, $width, $white );
	imagecopyresampled ( $thumb, $source, 0, 0, 0, 0, $new_width, $new_height, $width, $height );
	
	// Output
	$file_to_open = $file_thumb;
	//forzo estensione jpg
	imagejpeg ( $thumb, $file_to_open . ".jpg" );
}

/****************************************************************************
 *
 * Funzione che permette di creare l'icona di anteprima degli albums
 * prende in ingresso il numero di immagini presenti nell'album ($n)
 * il nome della galleriea ($gallery)
 * e l'array con i nomi di tutte le immagini presenti nell'albume ($modlist)
 *
 *****************************************************************************/
function FN_createIco($targetthumb, $listfiles)
{
	//	if (is_admin())
	{
		//		dprint_r($listfiles);
	//		dprint_r ($targetthumb);	
	}
	global $_FN;
	$image_quality = 8;
	
	$n = count ( $listfiles );
	if ($n > 4)
		$n = 4;
		
	//if ($n==0)
	//	return;
	$maxwidth = 58;
	$maxheight = 40;
	
	$newwidth = 144;
	$newheight = 108;
	
	$dimg = ImageCreateTrueColor ( $newwidth, $newheight );
	$bianco = ImageColorAllocate ( $dimg, 255, 255, 255 );
	$arancio = ImageColorAllocate ( $dimg, 254, 184, 22 );
	$giallo = ImageColorAllocate ( $dimg, 255, 243, 140 );
	
	ImageFilledRectangle ( $dimg, 0, 0, 143, 107, $bianco );
	
	// sfondo arancione
	ImageFilledEllipse ( $dimg, 24, 7, 14, 14, $arancio );
	ImageFilledEllipse ( $dimg, 54, 7, 14, 14, $arancio );
	ImageFilledRectangle ( $dimg, 24, 0, 54, 7, $arancio );
	ImageFilledEllipse ( $dimg, 5, 13, 10, 10, $arancio );
	ImageFilledEllipse ( $dimg, 138, 13, 10, 10, $arancio );
	ImageFilledEllipse ( $dimg, 5, 102, 10, 10, $arancio );
	ImageFilledEllipse ( $dimg, 138, 102, 10, 10, $arancio );
	ImageFilledRectangle ( $dimg, 5, 7, 138, 107, $arancio );
	ImageFilledRectangle ( $dimg, 0, 13, 143, 102, $arancio );
	
	//sopra giallo
	ImageFilledEllipse ( $dimg, 26, 9, 14, 14, $giallo );
	ImageFilledEllipse ( $dimg, 52, 9, 14, 14, $giallo );
	ImageFilledRectangle ( $dimg, 26, 2, 52, 9, $giallo );
	ImageFilledEllipse ( $dimg, 7, 15, 10, 10, $giallo );
	ImageFilledEllipse ( $dimg, 136, 15, 10, 10, $giallo );
	ImageFilledEllipse ( $dimg, 7, 100, 10, 10, $giallo );
	ImageFilledEllipse ( $dimg, 136, 100, 10, 10, $giallo );
	ImageFilledRectangle ( $dimg, 7, 9, 136, 105, $giallo );
	ImageFilledRectangle ( $dimg, 2, 15, 141, 100, $giallo );
	
	ImageColorTransparent ( $dimg, $bianco );
	
	for($j = 0; $j < $n; $j ++)
	{
		
		if ($n == 0)
			break;
		$nome = $listfiles [$j];
		$sfile = $listfiles [$j];
		if (gg_is_Video($sfile))
			continue;
		$size = getimagesize ( $sfile );
		switch ($size [2])
		{
			case 1 :
				$simg = ImageCreateFromGif ( $sfile );
				break;
			case 2 :
				$simg = ImageCreateFromJpeg ( $sfile );
				break;
			case 3 :
				$simg = ImageCreateFromPng ( $sfile );
				break;
		
		}
		
		$currwidth = imagesx ( $simg );
		$currheight = imagesy ( $simg );
		//set the dimensions of the thumbnail
		if (($currwidth > $maxwidth) or ($currheight > $maxheight))
		{
			if ($currheight > $currwidth)
			{
				$zoom = $maxheight / $currheight;
				$newheight = $maxheight;
				$newwidth = $currwidth * $zoom;
			}
			else
			{
				$zoom = $maxwidth / $currwidth;
				$newwidth = $maxwidth;
				$newheight = $currheight * $zoom;
			}
		}
		else
		{
			$newwidth = $currwidth;
			$newheight = $currheight;
		}
		
		$distor = ($maxwidth - $newwidth) / 2;
		$distver = ($maxheight - $newheight) / 2 + 2;
		
		switch ($j)
		{
			
			case 0 :
				$distor = $distor + 9;
				$distver = $distver + 14;
				ImageCopyResampled ( $dimg, $simg, $distor, $distver, 0, 0, $newwidth, $newheight, $currwidth, $currheight );
				break;
			
			case 1 :
				$distor = $distor + 77;
				$distver = $distver + 14;
				ImageCopyResampled ( $dimg, $simg, $distor, $distver, 0, 0, $newwidth, $newheight, $currwidth, $currheight );
				break;
			
			case 2 :
				$distor = $distor + 9;
				$distver = $distver + 60;
				ImageCopyResampled ( $dimg, $simg, $distor, $distver, 0, 0, $newwidth, $newheight, $currwidth, $currheight );
				break;
			
			case 3 :
				$distor = $distor + 77;
				$distver = $distver + 60;
				ImageCopyResampled ( $dimg, $simg, $distor, $distver, 0, 0, $newwidth, $newheight, $currwidth, $currheight );
				break;
		}
		ImageDestroy ( $simg );
	}
	//dprint_r($dimg);
	

	@imagepng ( $dimg, $targetthumb, $image_quality );
	imagedestroy ( $dimg );

}

function MakeDirThumb($basedir, $dir, $PATH_GALLERY, $force = false)
{
	if (is_admin () && isset ( $_GET ['f'] ))
		$force = true;
		//------------anteprima------------------->
	$namedir = basename ( $dir );
	
	if (! file_exists ( "$PATH_GALLERY$basedir/thumbs" ))
	{
		mkdir ( "$PATH_GALLERY$basedir/thumbs" );
	}
	$targetthumb = "$PATH_GALLERY$basedir" . "/thumbs/$namedir.png";
	
	if (! file_exists ( $targetthumb ) || $force)
	{
		refreshThumb ( "$PATH_GALLERY$dir" );
	}
	//------------anteprima-------------------<


}

function refreshThumb($fileToOpen)
{
	if (gg_is_Video($fileToOpen))
		return;
	//	dprint_r($fileToOpen);
	$namedir = basename ( $fileToOpen );
	$basedir = dirname ( $fileToOpen );
	$targetthumb = "$basedir" . "/thumbs/$namedir.png";
	$files = get_file_list ( "$fileToOpen", "jpg,gif,png,jpeg" );
	$listfiles = array ();
	foreach ( $files as $f )
	{
		$listfiles [] = $f ['file'];
	}
	FN_createIco ( $targetthumb, $listfiles );
}
?>