<?php
/**
 * @package flatnux_section_sitemap
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @copyright Copyright (c) 2003-2005
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 * 
 */
if ( strpos(strtolower($_SERVER['SCRIPT_NAME']),strtolower(basename(__FILE__))) )
{
	header("Location: ../../index.php");
	die("...");
}
global $_FN;
echo "<div style=\"text-align:left\">";
if ( $_FN['home_section'] == "" )
{
	if ( file_exists("themes/{$_FN['theme']}/images/menu.png") )
		echo "<img src=\"themes/{$_FN['theme']}/images/menu.png\" alt=\"home\" />";
	echo "&nbsp;<a href='index.php'>";
	if ( ($text = getLang("sections/.lang.xml")) )
		echo $text;
	else 
		if ( defined(_FIRSTBUTTONMENU) )
		{
			echo _FIRSTBUTTONMENU;
		}
		else
			echo "{$_FN['sitename']}";
	echo "</a>";
}
printsection("sections");
echo "</div>";
/**
 * Stampa la lista delle sezioni e delle sottosessioni
 *
 * @param string $path dove cercare la sezione (es. sections/01_pippo)
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 *
 */
function printsection($path)
{
	global $_FN;
	static $slevel = 0;
	$modlist = list_sections_translated($path,false,false);
	$slevel++ ;
	echo "\n<br /> ";
	foreach ( $modlist as $mod )
	{
		$tmp = $mod['title'];
		$link = $mod['link'];
		$accesskey = $mod['accesskey'];
		$stile1 = "";
		$image = fromtheme("images/section.png");
		if ( file_exists($image) )
			$stile1 = "<img src=\"$image\" alt=\"\" />";
		if ( $mod['link'] == sectionlocation($_FN['home_section']) )
		{
			$image = fromtheme("images/menu.png");
			if ( file_exists($image) )
			{
				$stile1 = "<img src=\"$image\" alt=\"\" />";
			}
		}
		for ( $i = 0;$i < $slevel;$i++  )
		{
			echo "&nbsp;&nbsp;&nbsp;&nbsp;";
		}
		$hlink = $link;
		$hlink = get_section_id($hlink);
		echo "\n\t$stile1<a accesskey=\"$accesskey\" href=\"" . fn_rewritelink("index.php?mod=$hlink") . "\">&nbsp;$tmp</a>";
		$l = basename($link);
		printsection("$path/$l");
	}
	$slevel-- ;
}
?>