<?php
/**
 * INFO.php
 * 
 * Created on 12-feb-2007
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * 
 * @copyright Copyright (c) 2007
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 * 
 */
if (strpos ( strtolower ( $_SERVER ['SCRIPT_NAME'] ), strtolower ( basename ( __FILE__ ) ) ))
{
	header ( "Location: ../../index.php" );
	die ( "..." );
}
global $_FNMESSAGE, $_FN;

//dprint_r ($_FN);
echo "<table style=\"background-color:#{$_FN['table_border']}\" border=\"0\" cellpadding=\"1\" cellspacing=\"1\" >";
echo "\n<tr><td style=\"background-color:#{$_FN['table_background']}\" colspan=\"2\"><em>" . $_SERVER['SERVER_SOFTWARE'] . "</em><br /><br />" . "  <a href=\"javascript:;\" onclick=\"window.open('sections/{$_FN['vmod']}/phpinfo.php');\">PHPInfo( )</a><br /><br /></td></tr>";
echo "\n<tr><td style=\"background-color:#{$_FN['table_background']}\"><b>" . $_FNMESSAGE['_FCC_VERSION'] . ":</b></td><td style=\"background-color:#{$_FN['table_background']}\">" . get_fn_version() . "</td></tr>";
echo "\n<tr><td style=\"background-color:#{$_FN['table_background']}\"><b>" . $_FNMESSAGE['_FCC_MAINUSERAGENT'] . ":</b></td><td style=\"background-color:#{$_FN['table_background']}\">" . $_SERVER["HTTP_USER_AGENT"] . "<br />";
echo "\n<tr><td style=\"background-color:#{$_FN['table_background']}\"><b>" . $_FNMESSAGE['_FCC_MAINSERVERSPACE'] . ":</b></td><td style=\"background-color:#{$_FN['table_background']}\">" . round(disk_free_space(".") / 1024 / 1024, 2) . " Mb" . "</td></tr>";

$opp = getparam("opt", PAR_GET, SAN_FLAT);
$curdir = getparam("dir", PAR_GET, SAN_FLAT);
$opmod = getparam("opmod", PAR_GET, SAN_FLAT);
if ($curdir == "")
	$curdir = ".";
$dirs = FN_LoadDirlist($curdir);

$totalsizesite = get_size(".");
$totalsize = 0;
$alldirs = array ();
foreach ($dirs as $dir)
{
	$alldirs[$dir]['size'] = get_size("$dir");
	$alldirs[$dir]['dir'] = $dir;
	$totalsize += $alldirs[$dir]['size'];
}

//die ("aa");

echo "<tr><td valign=\"top\" style=\"background-color:#{$_FN['table_background']}\"><b>" . $_FNMESSAGE['_FCC_MAINSITESPACE'] . ":</b></td><td style=\"background-color:#{$_FN['table_background']}\"><table style=\"background-color:#{$_FN['table_border']}\" cellpadding=\"1\" cellspacing=\"1\">";
if (count($alldirs) > 0)
	foreach ($alldirs as $dir)
	{
		$perc = $dir['size'] / $totalsize * 100;
		$w = round($perc, 1);
		$bar = "<div style=\"width:100px;display:block;height:15px;border:1px inset gray;background-color:gray;\"><div style=\"display:block;height:15px;border:0px;background-color:green;width:{$w}px;color:#ffffff\">$w%</div></div>";
		//$bar="$w";
		echo "\n<tr><td style=\"background-color:#{$_FN['table_background']}\"><a href=\"?mod={$_FN['mod']}&amp;opt=$opp&amp;dir={$dir['dir']}\">" . basename($dir['dir']) . ":</a>" . "</td>";
		echo "<td align=\"right\" style=\"background-color:#{$_FN['table_background']}\"> " . round($dir['size'] / 1024 / 1024, 2) . " Mb" . "</td>";
		echo "<td style=\"background-color:#{$_FN['table_background']}\">$bar</td>";
		echo "<td style=\"background-color:#{$_FN['table_background']}\"><img style=\"cursor:pointer;border:0px;\" alt=\"\" src=\"images/mime/dir.png\" onclick=\"window.open('filemanager.php?dir=" . $dir['dir'] . "','filemanager','toolbar= 0,location= 0,directories= 0,status= 0,menubar= 0,scrollbars= 1,resizable= 1,width=640,height=480');\" /></td>";
		echo "</tr>";
	}
if ($curdir != ".")
	echo "\n<tr><td style=\"background-color:#{$_FN['table_background']}\">" . $_FNMESSAGE['_FCC_TOTAL'] . " $curdir:</td><td style=\"background-color:#{$_FN['table_background']}\" align=\"right\">" . " " . round($totalsize / 1024 / 1024, 2) . " Mb" . "</td><td colspan=\"2\" style=\"background-color:#{$_FN['table_background']}\"></td></tr>";
echo "\n<tr><td style=\"background-color:#{$_FN['table_background']}\">" . $_FNMESSAGE['_FCC_TOTAL'] . ":</td><td align=\"right\" style=\"background-color:#{$_FN['table_background']}\">" . " " . round($totalsizesite / 1024 / 1024, 2) . " Mb" . "</td><td colspan = \"2\" style=\"background-color:#{$_FN['table_background']}\">&nbsp;</td></tr>";

echo "</table>";

echo "\n<tr><td style=\"background-color:#{$_FN['table_background']}\"><b>" . _FUTENTI . ":</b></td><td style=\"background-color:#{$_FN['table_background']}\">" . " <a href=\"?mod={$_FN['vmod']}&opt=03_users/30_users\">" . count_users() . "</a></td></tr>";

$table = new XMLTable("fndatabase", "users", "{$_FN['datadir']}");
$administrators  = $table->GetRecords(array("level"=>"10"));
//dprint_r($administrators);
echo "\n<tr><td style=\"background-color:#{$_FN['table_background']}\"><b>" . _FNADMINS . ":</b></td><td style=\"background-color:#{$_FN['table_background']}\">" ;
foreach ($administrators as $admin)
	echo " <a href=\"?mod={$_FN['vmod']}&opt=03_users/30_users&opmod=profile&user={$admin[$table->primarykey]}\">" . $admin[$table->primarykey] . "</a>&nbsp;";
echo "</td></tr>";
echo "\n</table></td></tr>";
?>