<?php
/**
 * 05_backup.php
 * 
 * Created on 2-mar-2007
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * 
 * @copyright Copyright (c) 2007
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 * 
 */
if (  !file_exists("./index.php") ||  !file_exists("./sections") )
	die();
global $_FN,$_FNMOD,$_FNMESSAGE;
$maxsize = 50000;
$op = getparam("opt",PAR_GET,SAN_FLAT);
if ( isadmin() )
{
	//creo la cartella per i backup
	if (  !file_exists("{$_FN['datadir']}/backups") )
		mkdir("{$_FN['datadir']}/backups");
		//gestione operazioni
	gest_bk($maxsize);
	$op = getparam("opt",PAR_GET,SAN_FLAT);
	if ( isset($_GET['tmpfiles']) && $_GET['tmpfiles'] == "del" )
	{
		echo "<pre>";
		delete_backup();
		echo "</pre>";
		echo "<p><a href=\"?mod=$_FNMOD&amp;opt=$op\">" . _AVANTI . " &gt;&gt;</a></p>";
	}
	else
	{
		$icon = "<img alt=\"\" src=\"" . fromtheme("images/mime/dir.png") . "\" />&nbsp;";
		echo "\n<form method=\"post\" action=\"?mod=$_FNMOD&amp;opt=$op\" />";
		echo "<fieldset>";
		echo "<legend>" . $_FNMESSAGE['CC_BK_BACKUP'] . ":</legend>";
		echo "<b>" . $_FNMESSAGE['CC_BK_SELECT'] . ":</b><br />";
		echo "\n<br />$icon" . $_FNMESSAGE['CC_BK_SECTIONS'] . "<input name=\"makebk\" type=\"radio\" value=\"sections\" />";
		echo "\n<br />$icon" . $_FNMESSAGE['CC_BK_BLOCKS'] . "<input name=\"makebk\" type=\"radio\" value=\"blocks\" />";
		echo "\n<br />$icon" . $_FNMESSAGE['CC_BK_USERS'] . "<input name=\"makebk\" type=\"radio\" value=\"{$_FN['datadir']}/fndatabase/users\" />";
		if ( ($forumpath = sectionlocation("forum")) != "" )
		{
			$topicslocation="";
			include ("sections/$forumpath/config.php");
			if ($topicslocation  !="")
				echo "\n<br />$icon" . $_FNMESSAGE['CC_BK_FORUM'] . "<input  name=\"makebk\" type=\"radio\" value=\"{$_FN['datadir']}/$topicslocation\" />";
		}
		if ( ($forumpath = sectionlocation("flatforum")) != "" )
			echo "\n<br />$icon" . $_FNMESSAGE['CC_BK_FORUM'] . "<input  name=\"makebk\" type=\"radio\" value=\"{$_FN['datadir']}/fndatabase/flatforum\" />";
		if ( ($forumpath = sectionlocation("news")) != "" )
		{
			echo "\n<br />$icon" . $_FNMESSAGE['CC_BK_NEWS'] . "<input  name=\"makebk\" type=\"radio\" value=\"{$_FN['datadir']}/news\" />";
		}
		echo "\n<br />$icon" . $_FNMESSAGE['CC_BK_LOG'] . "<input  name=\"makebk\" type=\"radio\" value=\"{$_FN['datadir']}/log\" />";
		echo "\n<br />$icon" . $_FNMESSAGE['CC_BK_ALL'] . "<input  name=\"makebk\" type=\"radio\" value=\"all\" />";
		echo "\n<br />$icon" . $_FNMESSAGE['CC_BK_MISC'] . " ({$_FN['datadir']})<input  name=\"makebk\" type=\"radio\" value=\"{$_FN['datadir']}\" />";
		echo "\n<br /><br /><b>" . $_FNMESSAGE['CC_BK_FILETYPE'] . ":</b><br />";
		$icon = "<img alt=\"\" src=\"" . fromtheme("images/mime/compressed.png") . "\" />&nbsp;";
		echo "\n<br />$icon" . $_FNMESSAGE['CC_BK_FILEZIP'] . "<input  name=\"type\" checked=\"checked\" type=\"radio\" value=\"zip\" />";
		$icon = "<img alt=\"\" src=\"" . fromtheme("images/mime/tar.png") . "\" />&nbsp;";
		echo "\n<br />$icon" . $_FNMESSAGE['CC_BK_FILEGZIP'] . "<input  name=\"type\" type=\"radio\" value=\"gzip\" />";
		echo "\n<br /><br /><input  name=\"submit\" class=\"submit\" type=\"submit\" value=\"" . $_FNMESSAGE['CC_BK_EXECUTE'] . "\" class=\"submit\" />";
		echo "</fieldset>";
		echo "</form>";
		printbackups();
	}
}
/**
 * clean backup files
 */
function delete_backup()
{
	global $_FNMESSAGE;
	global $_FN;
	if ( isadmin() )
	{
		$empty = true;
		foreach ( glob("{$_FN['datadir']}/backups/*") as $filename )
		{
			$empty = false;
			if ( unlink($filename) )
			{
				echo "<br />$filename: <b>" . _FILEDELETED . "</b>";
			}
			else
			{
				echo "<br /> $filename: <b>" . _READONLY . "</b>";
				;
			}
		}
		if ( $empty )
		{
			echo "<br />" . $_FNMESSAGE['CC_BK_NODELFILES'];
		}
	}
}
/**
 * 
 * @param string $maxsize
 */
function gest_bk($maxsize)
{
	global $_FN;
	//dprint_r($_POST);
	$type = isset($_POST['type']) ? $_POST['type'] : "zip";
	$what = getparam("makebk",PAR_POST,SAN_FLAT);
	switch ($what)
	{
		case "sections" :
			createbkzip("sections",$maxsize,"$type");
		break;
		case "all" :
			createbkzip(".",$maxsize,"$type","all");
		break;
		default :
			if ( $what != "" )
			{
				if ( file_exists($what) && is_dir($what) )
					createbkzip("$what",$maxsize,"$type");
				else
				{
					$targetdir = $_FN['datadir'] . "/bk_" . basename($what);
					if ( file_exists($targetdir) )
						rmdird($targetdir);
					mkdir($targetdir);
					$files = glob($what . "*");
					//dprint_r($files);
					foreach ( $files as $file )
					{
						$filename = basename($file,"");
						//echo "<br>bk:$filename";
						if ( is_dir($file) && $filename != "." && $filename != ".." && $filename != "" )
						{
							mkdir($targetdir . "/" . $filename);
							fn_copy_dir($file,$targetdir . "/" . $filename,'0777');
						}
						else
						{
							copy($file,$targetdir . "/" . $filename);
						}
					}
					createbkzip($targetdir,$maxsize,"$type");
					//rmdird($_FN['datadir']."/bk_$what");
				}
			}
		break;
	}
}
/**
 * create backup
 * @param string $folder
 * @param int $maxsize
 * @param string $type
 * @param string $title
 */
function createbkzip($folder, $maxsize, $type, $title = "")
{
	global $_FN;
	if ( $title == "" )
		$title = basename($folder);
	if (  !file_exists($folder) )
		return;
		//echo "<br />".realpath($folder)."<br />";
	if ( check_size("$folder/",(disk_free_space("$folder") - $maxsize)) )
		$dir = new DeepDir();
	else
		return;
	$dir->setDir("$folder");
	$dir->load();
	switch ($type)
	{
		case "zip" :
			$ext = "zip";
			$backup = new zip_file("{$_FN['datadir']}/backups/backup_" . $title . "_" . get_bkdate() . ".$ext");
		break;
		case "bzip" :
			$ext = "tar.bz2";
			$backup = new bzip_file("{$_FN['datadir']}/backups/backup_" . $title . "_" . get_bkdate() . ".$ext");
		break;
		case "gzip" :
			$ext = "tar.gz";
			$backup = new gzip_file("{$_FN['datadir']}/backups/backup_" . $title . "_" . get_bkdate() . ".$ext");
		break;
		case "tar" :
			$ext = "tar";
			$backup = new tar_file("{$_FN['datadir']}/backups/backup_" . $title . "_" . get_bkdate() . ".$ext");
		break;
		default : //non supportato
			return;
			false;
		break;
	}
	$backup->set_options(array('inmemory'=>"0",'overwrite'=>1,'storepaths','prepend','level','type'=>$type));
	foreach ( $dir->files as $n=>$pathToFile )
	{
		$backup->add_files($pathToFile);
	}
	if ( $folder == "." )
	{
		$backup->exclude_files("$folder/{$_FN['datadir']}/backups/*");
		if ( file_exists("{$_FN['datadir']}/updates/") )
			$backup->exclude_files("$folder/{$_FN['datadir']}/updates/*");
	}
	else
	{
		$backup->exclude_files("{$_FN['datadir']}/backups/*");
		if ( file_exists("{$_FN['datadir']}/updates/") )
			$backup->exclude_files("{$_FN['datadir']}/updates/*");
	}
	$backup->create_archive();
	return true;
}
/**
 * Visualizza i files di backup
 */
function printbackups()
{
	$op = getparam("opt",PAR_GET,SAN_FLAT);
	global $_FN;
	global $_FNMESSAGE,$_FNMOD;
	$handledir = opendir("{$_FN['datadir']}/backups");
	$s = "";
	while (false !== $file = readdir($handledir))
	{
		if (  !is_dir($_FN['datadir'] . "/backups/$file") )
		{
			$fsize = filesize("{$_FN['datadir']}/backups/$file");
			$suff = "bytes";
			if ( $fsize > 1024 )
			{
				$fsize = round($fsize / 1024,2);
				$suff = "Kb";
			}
			if ( $fsize > 1024 )
			{
				$fsize = round($fsize / 1024,2);
				$suff = "Mb";
			}
			if ( get_file_extension($file) == "zip" )
				$icon = "<img alt=\"\" src=\"" . fromtheme("images/mime/compressed.png") . "\" />&nbsp;";
			else
				$icon = "<img alt=\"\" src=\"" . fromtheme("images/mime/tar.png") . "\" />&nbsp;";
			$s .= "\n<li>$icon<a href=\"{$_FN['datadir']}/backups/$file\"> $file</a> (" . $fsize . " $suff) </li> ";
		}
	}
	if ( $s != "" )
	{
		echo "<br /><fieldset><legend>" . $_FNMESSAGE['CC_BK_LISTFILES'] . "</legend>";
		echo "<em>" . $_FNMESSAGE['CC_BK_LISTFILES2'] . "</em><br />";
		echo "<ul>$s";
		echo "</ul>";
		echo "\n<br /><br /><input  onclick=\"check('?mod=$_FNMOD&opt=$op&tmpfiles=del')\"  name=\"button\" class=\"submit\" type=\"submit\" value=\"" . $_FNMESSAGE['CC_BK_DELFILES'] . "\" class=\"submit\" />";
		echo "</fieldset>";
	}
}
/**
 * 
 */
function get_bkdate()
{
	global $jet_lag;
	return date("d-m-Y",time() + (3600 * $jet_lag)) . "_" . date("H-i-s",time() + (3600 * $jet_lag));
}
?>