<?php
ini_set("memory_limit","512M");
ini_set("max_execution_time","300");
if ( strpos(strtolower($_SERVER['SCRIPT_NAME']),strtolower(basename(__FILE__))) )
{
	header("Location: ../../index.php");
	die("...");
}
/**
 * inizializza la tabella
 */
function fn_init_18n()
{
	global $_FN;
	$table = new XMLTable("fndatabase","fn_i18n",$_FN['datadir']);
	$newvalueslist = array();
	foreach ( $_FN['listlanguages'] as $clang )
	{
		$suff = "";
		if ( $clang != $_FN['lang_default'] )
		{
			$suff = "_$clang";
		}
		$data = file_get_contents("languages/$clang.php");
		preg_match_all('/define.*?\((.*?),(.*?)\)\;/s',$data,$out);
		foreach ( $out[1] as $k=>$constant )
		{
			$constant = trim(ltrim($constant,"\"' "),"\"' ");
			$value = trim(ltrim($out[2][$k],"\"' "),"\"' ");
			$newvalueslist[$constant]["id"] = $constant;
			$newvalueslist[$constant]["text$suff"] = $value;
		}
	}
	$r = 0;
	foreach ( $newvalueslist as $values )
	{
		//fn_i18n($constant);
		//echo "insert: \"{$values['id']}\" ";
		$newvalues = $table->GetRecordByPrimaryKey($values['id']);
		if (  !isset($newvalues["text"]) )
		{
			$newvalues = $table->InsertRecord($values);
		}
		else
		{
			$toupdate = false;
			foreach ( $newvalues as $k=>$v )
			{
				if ( $v == "" || isset($_GET['force']) )
				{
					if (  !isset($values[$k]) )
					{
						echo "<br />{$values['id']}:$k is non defined";
					}
					else
					{
						$newvalues[$k] = $values[$k];
						$toupdate = true;
					}
				}
			}
			if ( $values['id'] == "_FP_ISTRUZIONIMODIFICA" || $values['id'] == "_CERCA" )
				if ( $toupdate )
					$table->UpdateRecord($values);
		}
		//if ($r>20)
		//	break;
		$r++ ;
	}
}
global $_FN;
if ( isset($_GET['init']) )
{
	fn_init_18n();
}
$op = getparam("opt",PAR_GET,SAN_HTML);
$page_xfn_i18n = getparam("page_xfn_i18n",PAR_GET,SAN_HTML);
$params['show_translations'] = true;
$params['fields'] = "id|text";
//if ( $_FN['lang'] != $_FN['lang_default'] )
{
	$params['fields'] .= "|text_{$_FN['lang']}";
}
$params['recordsperpage'] = "";
$params['link'] = "mod={$_FN['vmod']}&amp;page_xfn_i18n={$page_xfn_i18n}&amp;opt=$op";

	$params['path'] = $_FN['datadir'];
	$params['lang'] = $_FN['lang'];
	$params['languages'] = "xx,".$_FN['languages'];



XMLDB_editor("fn_i18n","fndatabase",$params);
//FN_cc_edit_xmltable("fn_i18n", "fndatabase", "", "", false,false,false,  false, true);
$opmod = getparam("opmod",PAR_GET,SAN_HTML);
if ( $opmod == "" )
	echo "<br /><br /><a href=\"?mod={$_FN['mod']}&amp;opt=$op&amp;init\">[Init table]</a>";
?>