<?php
/**
 * theme.php
 * 
 * @package Flatnux
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @copyright Copyright (c) 2003-2005
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 */

if ( strpos(strtolower($_SERVER['SCRIPT_NAME']),strtolower(basename(__FILE__))) )
{
	header("Location: ../../index.php");
	die("...");
}
global $_FN;
//config.php
global $sizecolumnleft,$sizecolumnright,$showblocksright,$showblocksleft,$showmenuleft,$showmenuright,$menu_recursive,$menu_recursive_onlyselected,$show_horizzontal_menu,$site_width,$align_news_horizontal,$bodycolor,$site_color,$bgcolor2,$bgcolor3,$color_text_block_title,$bgcolor1,$colorbordertabletitle,$bgcolortabletitle,$color_text_table_title,$bgcolortabletitlebody,$colortable,$bgcolortable,$backimage,$forumborder,$forumback,$show_subsections_in_section,$show_icons,$show_section_footer;
include ("themes/{$_FN['theme']}/config.php");
define("_THEME_VER",1);

/**
 * Open table
 */
function OpenTable()
{
	global $bgcolortable,$colortable;
	echo "<table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\" bgcolor=\"$colortable\"><tr><td>\n";
	echo "<table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"1\" bgcolor=\"$bgcolortable\"><tr><td>\n";
}

/**
 * Open table with title
 * @param string $title
 */
function OpenTableTitle($title)
{
	global $bgcolor1,$color_text_table_title,$bgcolor2,$bgcolor3,$bgcolortabletitle,$bgcolortabletitlebody,$colorbordertabletitle;
	echo "<table border='0' cellspacing='0' cellpadding='0' bgcolor='$colorbordertabletitle' width='100%'>
<tbody>
<tr>
<td>
<table width='100%' border='0' cellspacing='1' cellpadding='3'>
<tbody>
<tr>
<td bgcolor='$bgcolortabletitle' valign='top'><font style=\"color:#$color_text_table_title\" class=\"boxtitle\">$title
</font></td>
</tr>
<tr>
<td bgcolor='$bgcolortabletitlebody'>
<table width='100%'>
<tbody>
<tr>
<td valign='Top'>
	";
}
/**
 * Open block
 * @param string $img
 * @param string $title
 */
function OpenBlock($img, $title)
{
	global $bgcolor1,$bgcolor2,$bgcolor3,$color_text_block_title;
	echo "<table border='0' cellspacing='0' cellpadding='0' bgcolor='$bgcolor2' width='100%'>
<tbody>
<tr>
<td>
<table width='100%' border='0' cellspacing='1' cellpadding='3'>
<tbody>
<tr>
<td bgcolor='$bgcolor3' valign='top'>
<table cellpadding='0' cellspacing='0' border='0'>
<tr>
<td><img src=\"$img\" alt=\"$title\">
</td>
<td><font style=\"color:#$color_text_block_title\" class='boxtitle'>&nbsp;$title</font></td>
</tr></table></td></tr>
<tr>
<td bgcolor='$bgcolor1'>
<table width='100%'>
<tbody>
<tr>
<td valign='Top'>
 ";
}
/**
 * Close block
 */
function CloseBlock()
{
	
	echo "</td>
</tr>
</tbody>
</table>
</td>
</tr>
</tbody>
</table>
</td>
</tr>
</tbody>
</table>";

}
/**
 * Close a table
 */
function CloseTableTitle()
{
	
	echo "</td>
</tr>
</tbody>
</table>
</td>
</tr>
</tbody>
</table>
</td>
</tr>
</tbody>
</table>";

}

/**
 * Open a news
 * @param string $title
 */
function FN_OpenNews($title)
{
	global $align_news_horizontal,$bgcolor1,$color_text_table_title,$bgcolor2,$bgcolor3,$bgcolortabletitle,$bgcolortabletitlebody,$colorbordertabletitle;
	static $i = "";
	if ( $i == "" )
		$i=0;
	$i++;
	if ( $align_news_horizontal == 1 )
	{
		if ( $i % 2 == 0 )
			echo "<div style=\"float:right;width:49%;overflow:auto;padding:1px;\">";
		else
			echo "<div style=\"float:left;width:49%;overflow:auto;padding:1px;\">";
	}
	else
		echo "<br />";
	echo "<table width=\"100%\"   border='0' cellspacing='0' cellpadding='0' bgcolor='$colorbordertabletitle' >
<tbody>
<tr>
<td>
<table width='100%' border='0' cellspacing='1' cellpadding='3'>
<tbody>
<tr>
<td bgcolor='$bgcolortabletitle' valign='top'>
<font style=\"color:#$color_text_table_title\" class=\"boxtitle\">$title</font></td>
</tr>
<tr>
<td bgcolor='$bgcolortabletitlebody'>
<table width='100%'>
<tbody>
<tr>
<td valign='Top'>
";
}
/**
 * Close a news
 */
function FN_CloseNews()
{
	global $align_news_horizontal;
	echo "</td>
</tr>
</tbody>
</table>
</td>
</tr>
</tbody>
</table>
</td>
</tr>
</tbody>
</table>";
	
	if ( $align_news_horizontal == 1 )
		echo "</div>";

}
/**
 * Close a table
 */
function CloseTable()
{
	echo "</td></tr></table></td></tr></table>\n";
}

/**
 * create menu
 */
function create_menu()
{
	global $_FN,$theme,$menu_recursive,$show_icons;
	OpenBlock("themes/$theme/images/menu.png","Menu");
	
	//echo "<ul>";
	

	$tl=($_FN['lang'] != $_FN['lang_default'])?"?lang={$_FN['lang']}":"";
	
	if ( $_FN['home_section'] == "" )
	{
		if ( $show_icons && file_exists("themes/$theme/images/menu.png") )
			echo "<img border=0 src=\"themes/$theme/images/menu.png\" alt=\"home\" />&nbsp;";
		echo "<b><a href=\"index.php$tl\">";
		
		if ( ($text=getLang("sections/.lang.xml"))!="" )
			echo $text;
		elseif ( defined(_FIRSTBUTTONMENU) )
			echo _FIRSTBUTTONMENU;
		else
			echo "HOME";
		echo "</a></b><br />";
	}
	
	printsection2("sections",$menu_recursive);
	CloseBlock();
	echo "<br />";
}

/**
 * Stampa la lista delle sezioni e delle sottosessioni
 *
 * @param string $path dove cercare la sezione (es. sections/01_pippo)
 */
function printsection2($path, $recursive=true)
{
	
	global $_FN,$theme,$home_section,$show_icons;
	static $slevel=0;
	$modlist=list_sections_translated($path,false,false);
	$slevel++;
	$tl=($_FN['lang'] != $_FN['lang_default'])?"&lang={$_FN['lang']}":"";
	
	foreach ( $modlist as $mod )
	{
		$tmp=$mod['title'];
		$link=$mod['link'];
		$accesskey=$mod['accesskey'];
		if ( $_FN['home_section'] == "" )
			echo "&nbsp;&nbsp;";
		
		for ( $i=1;$i < $slevel;$i++ )
		{
			echo "&nbsp;&nbsp;&nbsp;&nbsp;";
		}
		if ( $slevel == 1 )
		{
			echo "<b>";
		}
		$icon="";
		if ( $show_icons && file_exists("themes/$theme/images/menu.png") )
		{
			if ( file_exists("sections/$link/icon.png") )
				$icon="<img src=\"sections/$link/icon.png\" alt=\"\"/>&nbsp;";
			else
				$icon="<img src=\"" . fromtheme("images/section.png") . "\" alt=\"\"/>&nbsp;";
		}
		
		$hlink=get_section_id($link);
		echo "\n\t$icon<a accesskey=\"$accesskey\" href=\"" . fn_rewritelink("index.php?mod=$hlink$tl") . "\">$tmp</a>";
		if ( $slevel == 1 )
		{
			echo "</b>";
		}
		$l=basename($link);
		echo "<br />";
		global $menu_recursive_onlyselected,$_FNVMOD;
		if ( $recursive )
		{
			if ( $menu_recursive_onlyselected && fn_erg('^' . $mod['link'],$_FNVMOD) )
				printsection2("$path/$l");
			else
			{
				if ( !$menu_recursive_onlyselected )
					printsection2("$path/$l");
			}
		}
	}
	$slevel--;
}

/**
 * FN_OpenSection
 * apre una sezione
 * @param $title titolo sezione
 **/
function FN_OpenSection($title)
{
	OpenTableTitle($title);
}

/**
 * FN_CloseSection
 * chiude una sezione
 * @param $title titolo sezione
 **/
function FN_CloseSection()
{
	global $show_subsections_in_section,$show_section_footer;
	
	if ( $show_section_footer )
		FN_SectionFooter();
	if ( $show_subsections_in_section )
		FN_CreateSubmenu();
	CloseTableTitle();
}
function news__print_news_summary($item)
{
	global $_FN;
	static $i = 0;
	$i++;
	FN_OpenNews("{$item['title']}");
	echo "{$item['news_SUMMARY']}";
	if ( $item['img_argument'] != "" )
	{
		echo "<img alt=\"\" style=\"float:right;border:0px;\" title = \"{$item['title_argument']}\"  src=\"{$item['img_argument']}\">";
	}

	if ( $item['img_news'] != "" )
	{
		echo "<img alt=\"\" style=\"border:0px;\" src=\"{$item['img_news']}\" /><br />";
	}
	//footer ------>
	echo "<br /><div style=\"text-align:center\">", $item['txt_POSTED'] . $item['txt_DATE'] . " (" . $item['txt_VIEWS'];
	if ( $_FN['news_enablecomments'] )
		echo "," . $item['txt_NUMCOMMENTS'];
	echo ")";
	echo "<br />";
	echo "<img src=\"" . fromtheme("images/read.png") . "\" alt=\"Read\" />&nbsp;<a accesskey=\"{$item['accesskey_READ']}\" href=\"" . $item['link_READ'] . "\" title=\"" . $item['txt_READ'] . " " . $item['news_TITLE'] . "\" ><b>" . $item['txt_READ'] . "</b></a>";
	echo " | <img  src=\"" . fromtheme("images/print.png") . "\" alt=\"" . $item['txt_PRINT'] . "\" />&nbsp;<a accesskey=\"{$item['accesskey_PRINT']}\" href=\"{$item['link_PRINT']}" . "\" title=\"" . $item['txt_PRINT'] . " " . $item['news_TITLE'] . "\" >" . $item['txt_PRINT'] . "</a>";
	if ( $_FN['news_enablecomments'] )
		echo " | <img  src=\"" . fromtheme("images/comment.png") . "\" alt=\"" . $item['txt_COMMENTS'] . "\" />&nbsp;<a accesskey=\"{$item['accesskey_COMMENTS']}\" href=\"{$item['link_COMMENTS']}" . "\" title=\"" . $item['txt_COMMENTS'] . " " . $item['news_TITLE'] . "\" >" . $item['txt_COMMENTS'] . "</a>";
	if ( $item['link_MODIFY'] != "" )
	{
		echo " | <img  src=\"" . fromtheme("images/modify.png") . "\" alt=\"" . $item['txt_MODIFY'] . "\" title=\"" . $item['txt_MODIFY'] . "\" />&nbsp;<a href=\"{$item['link_MODIFY']}\" title=\"" . $item['txt_MODIFY'] . "\" >" . $item['txt_MODIFY'] . "</a>";
	}
	echo $item['facebook_button_i_like'];
	echo "</div>";
	//footer ------<
	FN_CloseNews();
}
/**
 *
 * @param array $commentvalues
 */
function news__print_comment($commentvalues)
{
	OpenTableTitle($commentvalues['username'] . " :");
	echo "<table border=\"0\" cellpadding=\"1\" cellspacing=\"1\" ><tr>";
	echo "<td valign=\"top\"><img src=\"{$commentvalues['img_USER']}\" alt=\"{$commentvalues['username']}\" /></td><td  valign=\"top\">";
	echo $commentvalues['html_COMMENT'];
	echo "</td></tr></table>";
	if ( is_admin ( ) )
		echo "<div style=\"text-align:right\">[" . $commentvalues['html_DELCOMMENT'] . "]</div>";
	CloseTableTitle();
	echo "<br />";
}
/**
 *
 * @global  $_FN
 * @param <type> $news_values
 */
function news__print_news($news_values)
{
	global $_FN;
	if ( $news_values['op'] == "comment" )
		if ( $_FN['user'] == "" && !$_FN['news_guestcomment'] )
		{
			echo "<div class=\"news_comment_login\" >" . fn_i18n("_DEVIREG") . " " . $_FN['sitename'] . " " . fn_i18n("_DEVIREG2");
			fn_loginform();
			echo "</div>";
		}
		else
		{
			echo "<div class=\"news_comment_login\" >";
			nw_writecomment($news_values['unirecid']);
			echo "</div>";
		}
	FN_OpenNews("{$news_values['news_TITLE']}");
	echo $news_values['news_SUMMARY'];
	echo "<br />";
	echo $news_values['news_BODY'];
	echo "<hr />";
	echo $news_values['txt_POSTED'] . $news_values['txt_DATE'];
	if ( is_news_administrator ( ) )
	{
		echo " | <a href=\"{$news_values['link_MODIFY']}\">[{$news_values['txt_MODIFY']}]</a>";
	}
	echo "<br /><br />";
	if ( $_FN['news_enablecomments'] )
	{
		news__print_comments($news_values);
	}
	FN_CloseNews();
}
/**
 *
 * @global <type> $_FN
 * @param <type> $id_news
 */
function news__print_comments($news_values)
{
	global $_FN;
	$comments = $news_values['COMMENTS'];
	if ( $news_values['op'] != "comment" )
	{
		OpenTable();
		echo "<a href=\"{$news_values['link_WRITECOMMENT']}\">{$news_values['txt_WRITECOMMENT']}</a> | <a href=\"{$news_values['link_PRINT']}\">{$news_values['txt_PRINT']}</a>";
		CloseTable();
	}
	if ( count($comments) > 0 )
	{
		echo "<div class=\"newscomments\">";
		echo "<h3>" . fn_i18n("_COMMENTI") . ":</h3><br />";
		foreach ( $comments as $comment )
		{
			news__print_comment($comment);
		}
		echo "</div>";
	}
}

?>